var populateMantras(var mantra, var flag)
{
	var mantras = ["'Ahm'", "'Mu'", "'Ree'", "'Ra'", "'Arr'", "'Summ'", "'Lum'", "'Meh'", "'Mul'", "'Cah'", "'Beh'", "'Doh'", "'Err'", "'Om'", "'Uh'"];
	var size = UI_get_array_size([mantras]);
	
	// This will populate a list of mantras, but it should NOT have the Shrine's actual mantra unless
	// the flag is set true (they learned the mantra). If the flag isn't true and mantra is rolled, do a re-roll.  
	
	//assign random mantras in the choice menu
	var choice_one = mantras[UI_get_random(size)];
		
	//if choice one equals the mantra, re-roll	
	while (choice_one == mantra)
		choice_one = mantras[UI_get_random(size)];
		
	//roll choice two. If it matches choice one OR mantra, re-roll
	var choice_two = mantras[UI_get_random(size)];	
	while (choice_two == choice_one || choice_two == mantra)
		choice_two = mantras[UI_get_random(size)];	
	
	//roll choice three. If it matches choice one, two, OR mantra, re-roll
	var choice_three = mantras[UI_get_random(size)];
	while (choice_three == choice_one || choice_three == choice_two || choice_three == mantra)
		choice_three = mantras[UI_get_random(size)];	

	
	
	var mantra_choices = [choice_one, choice_two, choice_three];
	
	//if mantra flag is set (mantra is learned), replace random choice with actual mantra:
	if (flag)
	{
		UI_error_message("Mantra flag is true");
		UI_error_message("Mantra is " + mantra);
		
		var rand = UI_get_random(3);
		
		if (rand == 1)
			choice_one = mantra;
		else if (rand == 2)
			choice_two = mantra;
		else
			choice_three = mantra;
		
		//reassign mantras
		mantra_choices = [choice_one, choice_two, choice_three];
		
		UI_error_message("Choices are : " + choice_one + "," + choice_two + ", " + choice_three);	
		
	}
	else
		UI_error_message("Flag isn't set?");
		
	
	
	return mantra_choices;
}




void breakForceField(var rune, var virtue_name)
{
	var shrine = UI_find_object(FIND_ON_SCREEN, SHAPE_FORCEFIELD, QUALITY_ANY, FRAME_ANY);
	var moonstone =  UI_find_nearest(shrine, SHAPE_MOONSTONE, 3);
	var forcefield = UI_find_nearest(shrine, SHAPE_FORCEFIELD, 3);

	//If forcefield not found, abort
	if (!forcefield)
	{
		randomPartyBark("We are not close enough.@");
		abort;
			
	}		
	else
	{
		UI_obj_sprite_effect(moonstone, 21, 0, 0, 0, 0, 0, -1);
		UI_play_sound_effect(37);
		
		UI_obj_sprite_effect(moonstone, 9, 0, 0, 0, 0, 0, -1); 
		UI_play_music(9);

		UI_remove_item(forcefield); //deletes force field

		UI_remove_item(rune); //deletes rune
		
		deleteEggs();
		randomPartyBark("@The Shrine of " + virtue_name + " is free!@");
		giveExperience(100);
		UI_play_music(9);
	}

}

void breakForceFieldFailed()
{
	
	var moonstone = find_nearest(SHAPE_MOONSTONE, 10);
	UI_obj_sprite_effect(moonstone, 9, 0, 0, 0, 0, 0, -1); 
	UI_play_sound_effect(69);
	randomPartyBark("@I don't think that was the correct mantra...@");

}



void freeShrines (var shrine, var rune)
{
	var virtue_name = shrine;
	
	var choice_one;
	var choice_two;
	var choice_three;

	/* for reference: 
	const int QUALITY_SACRIFICE 		= 0;
	const int QUALITY_JUSTICE 		= 1;
	const int QUALITY_HUMILITY 		= 2;
	const int QUALITY_SPIRITUALITY 	= 3;
	const int QUALITY_VALOR 			= 4;
	const int QUALITY_COMPASSION 		= 5;
	const int QUALITY_HONOR 			= 6;
	const int QUALITY_HONESTY 		= 7;
	
	The mantra of Honesty: Ahm
	The mantra of Compassion: Mu
	The mantra of Valor: Ra
	The mantra of Justice: Beh
	The mantra of Sacrifice: Cah
	The mantra of Honor: Summ
	The mantra of Humility: Lum
	The mantra of Spirituality: Om
	
		
	*/
	
	var MANTRA_SACRIFICE = "'Cah'";
	var MANTRA_JUSTICE = "'Beh'";
	var MANTRA_HUMILITY = "'Lum'";
	var MANTRA_SPIRITUALITY = "'Om'";
	var MANTRA_VALOR = "'Ra'";
	var MANTRA_HONESTY = "'Ahm'";
	var MANTRA_COMPASSION = "'Mu'";
	var MANTRA_HONOR = "'Summ'";
	
	var face;
	
	if (shrine == "Sacrifice")
		face = 250;
	else if (shrine == "Justice")
		face = 251;
	else if (shrine == "Humility")
		face = 252;
	else if (shrine == "Spirituality")
		face = 249;
	else if (shrine == "Valor")
		face = 248;
	else if (shrine == "Honesty")
		face = 254;
	else if (shrine == "Compassion")
		face = 255;
	else if (shrine == "Honor")
		face = 253;
	else
		face = 256;
	
		
	var npc;
	
	if (shrine == "Sacrifice")
		npc = NPC_SACRIFICE;
	else if (shrine == "Justice")
		npc = NPC_JUSTICE;
	else if (shrine == "Humility")
		npc = NPC_HUMILITY;
	else if (shrine == "Spirituality")
		npc = NPC_SPIRITUALITY;
	else if (shrine == "Valor")
		npc = NPC_VALOR;
	else if (shrine == "Honesty")
		npc = NPC_HONESTY;
	else if (shrine == "Compassion")
		npc = NPC_COMPASSION;
	else if (shrine == "Honor")
		npc = NPC_HONOR;
	else
		npc = AVATAR;
	
	
	
	UI_error_message("NPC is : " + npc);
	
	var npc_face = UI_get_npc_object(npc);
	UI_error_message("Face is : " + npc_face);
	
	//show correct shrine face
	UI_show_npc_face(face, 0);
	
	//stop any music from playing. TODO: Add shrine music?
	UI_play_music(255);
	
	face.say("You hear a voice ringing inside your head.");
	face.say("@Speak the mantra of " + virtue_name + ".@");
	
	
	//Shrine of Sacrifice
	if (shrine == "Sacrifice")
	{
		var mantra_choices = populateMantras(MANTRA_SACRIFICE, LEARNED_MANTRA_SACRIFICE);
		
		var mantra_choice = chooseFromMenu(mantra_choices);
		
		if (mantra_choice == MANTRA_SACRIFICE)
		{
			UI_close_gumps();
			breakForceField(rune, virtue_name);
			gflags[SACRIFICE_FREED] = true;
		}	
	
		else
		{
			breakForceFieldFailed();
		}
	}
	
	//Shrine of Justice
	else if (shrine == "Justice")
	{
		var mantra_choices = populateMantras(MANTRA_JUSTICE, LEARNED_MANTRA_JUSTICE);
		
		var mantra_choice = chooseFromMenu(mantra_choices);
		
		if (mantra_choice == MANTRA_JUSTICE)
		{
			UI_close_gumps();
			breakForceField(rune, virtue_name);
			gflags[JUSTICE_FREED] = true;
		}	
	
		else
		{
			breakForceFieldFailed();
		}
	}
	
	//Shrine of Humility
	else if (shrine == "Humility")
	{
		var mantra_choices = populateMantras(MANTRA_HUMILITY, LEARNED_MANTRA_HUMILITY);
		
		var mantra_choice = chooseFromMenu(mantra_choices);
		
		if (mantra_choice == MANTRA_HUMILITY)
		{
			UI_close_gumps();
			breakForceField(rune, virtue_name);
			gflags[HUMILITY_FREED] = true;
		}	
	
		else
		{
			breakForceFieldFailed();
		}
	}
	
	//Shrine of Spirituality
	else if (shrine == "Spirituality")
	{
		var mantra_choices = populateMantras(MANTRA_SPIRITUALITY, LEARNED_MANTRA_SPIRITUALITY);
		
		var mantra_choice = chooseFromMenu(mantra_choices);
		
		if (mantra_choice == MANTRA_SPIRITUALITY)
		{
			UI_close_gumps();
			breakForceField(rune, virtue_name);
			gflags[SPIRITUALITY_FREED] = true;
		}	
	
		else
		{
			breakForceFieldFailed();
		}
	}
	
	//Shrine of Valor
	else if (shrine == "Valor")
	{
		var mantra_choices = populateMantras(MANTRA_VALOR, LEARNED_MANTRA_VALOR);
		
		var mantra_choice = chooseFromMenu(mantra_choices);
		
		if (mantra_choice == MANTRA_VALOR)
		{
			UI_close_gumps();
			breakForceField(rune, virtue_name);
			gflags[VALOR_FREED] = true;
		}	
	
		else
		{
			breakForceFieldFailed();
		}
	}
	
	//Shrine of Compassion
	else if (shrine == "Compassion")
	{
		var mantra_choices = populateMantras(MANTRA_COMPASSION, LEARNED_MANTRA_COMPASSION);
		
		var mantra_choice = chooseFromMenu(mantra_choices);
		
		if (mantra_choice == MANTRA_COMPASSION)
		{
			UI_close_gumps();
			breakForceField(rune, virtue_name);
			gflags[COMPASSION_FREED] = true;
		}	
	
		else
		{
			breakForceFieldFailed();
		}
	}
	
	//Shrine of Honor
	else if (shrine == "Honor")
	{
		var mantra_choices = populateMantras(MANTRA_HONOR, LEARNED_MANTRA_HONOR);
		
		var mantra_choice = chooseFromMenu(mantra_choices);
		
		if (mantra_choice == MANTRA_HONOR)
		{
			UI_close_gumps();
			breakForceField(rune, virtue_name);
			gflags[HONOR_FREED] = true;
		}	
	
		else
		{
			breakForceFieldFailed();
		}
	}
	
	//Shrine of Honesty
	else if (shrine == "Honesty")
	{
		var mantra_choices = populateMantras(MANTRA_HONESTY, LEARNED_MANTRA_HONESTY);
		
		var mantra_choice = chooseFromMenu(mantra_choices);
		
		if (mantra_choice == MANTRA_HONESTY)
		{
			UI_close_gumps();
			breakForceField(rune, virtue_name);
			gflags[HONESTY_FREED] = true;
		}	
	
		else
		{
			breakForceFieldFailed();
		}
	}
	
	
	

}

