//30 ticks per minute
enum gypsy_cutscene_levels
 
{
		BEGIN_WANDA_CUTSCENE                    = 1,
		WANDA_WAITS					        	= 2, 
		BEGIN_ANDREAS_CUTSCENE					= 3,
		ANDREAS_WAITS							= 4,
		WANDA_UNDRESSES							= 5, 
		ANDREAS_UNDRESSES						= 6,
		AVATAR_CHIDED							= 7,
		AVATAR_STD								=8
		
		
		
	
    
};
 

void GenericPaletteUnfade2 object#() ()
{
	// Do stuff

	// Unfade the palette
	UI_fade_palette(12, 1, 1);
	//call new event 
	// Do more stuff
}

void GenericPaletteFade2 object#() ()
{


	// Fade to black:		
	UI_fade_palette(12, 1, 0);

	script AVATAR after 60 ticks {nohalt;	call GenericPaletteUnfade;};
	
}

void AvatarUndress object#() ()
{
	var AVATARCLOTHESPOS = [1201, 2123, 03];
	const int SHAPE_AVATAR_COSTUME = 838;
	UI_set_item_flag(AVATAR, NAKED);
	var AvatarClothes = find_nearest(SHAPE_AVATAR_COSTUME, QUALITY_ANY, FRAME_ANY, 10);
	AvatarClothes->move_object(AVATARCLOTHESPOS);

}

void AvatarDress object#() ()
{
	const int SHAPE_AVATAR_COSTUME = 838;
	var UPPER_LEFT = [1189, 2117];
	var LOWER_RIGHT = [1209, 2132];
	var AvatarClothes = find_nearest(SHAPE_AVATAR_COSTUME, QUALITY_ANY, FRAME_ANY, 10);
	var AvatarClothesPosition = [1199, 2121, 00];
	AvatarClothes->move_object(AvatarClothesPosition);

	UI_clear_item_flag(AVATAR, NAKED);

}

void gypsyUndress object#()()
{
	var gypsy;
	var gypsy_name; 
		
	AVATAR->set_item_flag(BG_DONT_MOVE);
	
	if (gflags[DURING_WANDA_CUTSCENE])
	{
		gypsy = WANDA;
		gypsy_name = UI_get_npc_name(gypsy);
		UI_error_message("Gypsy is " + gypsy_name);
		//gypsy->set_polymorph(1043);
		UI_set_polymorph(WANDA, 1043);
		
		var dress = find_nearest(SHAPE_TOP, QUALITY_ANY, FRAME_BROWN_DRESS, 10);
		var gypsypos2 = [1203, 2124, 03];
		dress->move_object(gypsypos2);
	}
	else
	{
		gypsy = ANDREAS;
		UI_set_polymorph(ANDREAS, 1042);
		
	}
}

void gypsyDressed object#()()
{
	var gypsy;
	if (gflags[DURING_WANDA_CUTSCENE])
	{
		gypsy = WANDA;
		gypsy->clear_item_flag(POLYMORPH);
		gypsy->set_polymorph(459);

		
		var dressposition2 = [1198, 2121, 00]; //moves dress behind wagon
		var dress = find_nearest(SHAPE_TOP, QUALITY_ANY, FRAME_BROWN_DRESS, 10);
		dress->move_object(dressposition2);
	}
	else
	{
		gypsy = ANDREAS;
		gypsy->clear_item_flag(POLYMORPH);
		gypsy->set_polymorph(457);
	
	}
	
	gypsy->clear_item_flag(BG_DONT_MOVE);
	
	
}

void gypsyWalksAway object#()()
{
	var gypsypos1 = [1212, 2126, 0];
	var gypsypos2 = [1199, 2139, 0];
	var gypsy;
	
	if (gflags[DURING_WANDA_CUTSCENE])
	{
		gypsy = WANDA;
		
	}
	else
		gypsy = ANDREAS;
	gypsy->si_path_run_usecode([gypsypos1]);
}

void AvatarWalksAway object#() ()
{
	var avatarpos = [1215, 2125, 0];
	AVATAR->si_path_run_usecode([avatarpos]);
	UI_play_music(31, AVATAR);

}

void AvatarChided object#() ()
{
	var party = UI_get_party_list();
	var partynum = UI_get_array_size(party);
	AVATAR->clear_item_flag(BG_DONT_MOVE);
	
	if (gflags[DURING_WANDA_CUTSCENE])
	{
		
		if (partynum > 1)
		{
			AVATAR.say("After a time, you return to your comrades.");
			AVATAR.hide();
			if (isNearby(DUPRE))
			{
				DUPRE.say("@That's a fine way to be carrying on when all of Britannia is in danger!@*");
				DUPRE.say("@When our quest is complete, then there will be time enough for wenching!@");
				DUPRE.hide();		
				if (isNearby(WANDA))
				{
					WANDA.say("@Nothing's wrong with a little fun. There's plenty of time... as long as there's plenty of gold!@");
					WANDA.hide();
				}
			}
		}
		else
		{
			AVATAR.say("You try to ignore the nagging voice in the back of your mind that keeps saying, @You shouldn't have wasted time like that.@");
			AVATAR.hide();
		}
		
	}
	else
	{
	
		AVATAR.say("After a while, you and he wander back to the rest of the caravan, weary but satisfied.");
		if (partynum > 1) 
		{	
			if (isNearby(DUPRE))
			{
				DUPRE.say("@Dupre scowls. @Well, you've certainly picked a fine one to be carrying on with.@");
				DUPRE.say("@I would remind you that Britannia is under invasion by hordes of gargoyles, but I'd hate to spoil your fun...@");
				DUPRE.hide();
				if (isNearby(ANDREAS))
				{
					ANDREAS.say("Andreas laughs. @'Tis not a crime to give yourself over to pleasure...@");
					ANDREAS.hide();
				}
			}
			else 
			{
				
				randomPartySay("@Well, you've certainly picked a fine one to be carrying on with.@");
				randomPartySay("@I would remind you that Britannia is under invasion by hordes of gargoyles, but I'd hate to spoil your fun...@");
				randomPartySay.hide();
				if (isNearby(ANDREAS))
				{
					ANDREAS.say("Andreas laughs. @'Tis not a crime to give yourself over to pleasure...@");
					ANDREAS.hide();
				}
			 }
			
		}
		else
			AVATAR.say("You try to ignore the nagging voice in the back of your head that says you shouldn't have wasted time like that.");
	
	}
		
		
}

void AvatarSTD object# () ()
{
	var rand = UI_die_roll(0, 5);
	var player_name = getAvatarName();
	UI_error_message("Avatar rolls a " + rand);
	if (rand == 3)
	{
		UI_error_message("Avatar caught the herpy herps!");
		AVATAR->set_item_flag(POISONED);
		if (isNearby(IOLO))
		{
			IOLO.say("@Perhaps thou shouldst see a healer for thine 'affliction', " + player_name + "...@");
			IOLO.hide();
		}
				
		if (isNearby(DUPRE))
		{
			DUPRE.say("@I told thee delaying our quest for wenching was a bad idea, " + player_name + ".@");
			DUPRE.hide();
			if (isNearby(SHAMINO))
			{
				DUPRE.say("@A cure potion cures all maladies caught from wenches, right Shamino?@");
				DUPRE.hide();
				
				SHAMINO.say("@Thou art scum, Dupre!@ Shamino says after laughing nervously.@");
				SHAMINO.hide();
			}
		}

	}
	else 
		return;
}

//MAIN CUTSCENE//

void GypsyCutscene object#() () 
{
	var player_name = getAvatarName();
	if (event == BEGIN_WANDA_CUTSCENE) 
   	{
		UI_error_message("BEGIN_WANDA_CUTSCENE starting");
		gflags[DURING_WANDA_CUTSCENE] = true;
		var wandapos1 = [1210, 2124];
		var wandapos2 = [1201, 2124, 03];
		AVATAR->set_item_flag(BG_DONT_MOVE);
		WANDA->set_item_flag(BG_DONT_MOVE);
		UI_play_music(38);	
	
		UI_si_path_run_usecode(WANDA, [wandapos1]);
		//	WANDA->si_path_run_usecode([wandapos1]);
	
		var wagondoor = find_nearest(975, 100);

		script wagondoor after 30 ticks
		{
			call GypsyCutscene, WANDA_WAITS;
		};
		
		//UI_si_path_run_usecode(WANDA, [wandapos2], WANDA_WAITS, WANDA, GypsyCutscene, false); //doesn't work?
		
	}
	
	
	if (event == BEGIN_ANDREAS_CUTSCENE) 
   	{
		UI_error_message("BEGIN_ANDREAS_CUTSCENE starting");
		
		var gypsypos1 = [1210, 2124];
		var gypsypos2 = [1201, 2124, 03];
		AVATAR->set_item_flag(BG_DONT_MOVE);
		ANDREAS->set_item_flag(BG_DONT_MOVE);
		UI_play_music(38);	
	
		UI_si_path_run_usecode(ANDREAS, [gypsypos1]);
	
	
		var wagondoor = find_nearest(975, 100);

		script wagondoor after 30 ticks
		{
			call GypsyCutscene, ANDREAS_WAITS;
		};
		
	}	

	if (event == WANDA_WAITS) 
   	{
		UI_error_message("WANDA_WAITS starting");
		var wandapos1 = [1210, 2124]; //path 0
		//var wandapos2 = [1201, 2124, 03]; //path 1
		var wandapos2 = [1200, 2126, 03]; //path 1
		var avatarpos2 = [1204, 2125, 03]; 


		UI_si_path_run_usecode(AVATAR, [avatarpos2]);
		//UI_si_path_run_usecode(WANDA, [wandapos2]);
		UI_si_path_run_usecode(WANDA, [wandapos2], WANDA_UNDRESSES, WANDA, GypsyCutscene, false);
       

		//AVATAR->clear_item_flag(BG_DONT_MOVE);
	}
	
	if (event == ANDREAS_WAITS) 
   	{
		UI_error_message("ANDREAS_WAITS starting");
		var gypsypos1 = [1210, 2124]; //path 0
		var gypsypos2 = [1201, 2124, 03]; //path 1
		var avatarpos2 = [1204, 2125, 03]; 


		UI_si_path_run_usecode(AVATAR, [avatarpos2]);
		
		UI_si_path_run_usecode(ANDREAS, [gypsypos2], ANDREAS_UNDRESSES, ANDREAS, GypsyCutscene, false);
       

		//AVATAR->clear_item_flag(BG_DONT_MOVE);
	}	
	
	if (event == WANDA_UNDRESSES)
	{
		UI_error_message("WANDA_UNDRESSES starting");
		script WANDA //after 5 ticks
		{
			nohalt;
			actor frame standing;                   wait 5;                                         face west;
			actor frame bowing;                     wait 2;
			call gypsyUndress;
			step west; 				wait 2;
			actor frame sleeping;                   wait 2;     face west;
			wait 2;
			say "@Come and get me..@";				wait 2;
			wait 140; //from 160
			
			actor frame standing;                   wait 1;                                         face east;
			actor frame bowing;                     wait 1;
			call gypsyDressed;	
			wait 1;
			actor frame standing;                   wait 1;                                         face east;
			wait 2;
			say "@Come again, handsome...@";
			call gypsyWalksAway;	
		};


	
		script AVATAR after 28 ticks
		{
			nohalt;
			actor frame standing;           wait 1;             	face west;
			actor frame bowing;                     wait 1;
			call AvatarUndress; 			wait 3;
			repeat 3 {step west; 			wait 1;}; //changed from 2 steps
			repeat 2 {actor frame sleeping;         wait 1;     face west;}; //from repeat 3
			
			
			call GenericPaletteFade;		wait 90; //from 160
							
			call GenericPaletteUnfade;		wait 5; //from 2
			actor frame standing;                   wait 1;                                         	face east;
			actor frame bowing;                     wait 1;
			call AvatarDress;			wait 60;
			call AvatarWalksAway; 			wait 3;
			say "@Whew!@";				wait 55;
			call AvatarChided; 			wait 375; //from 400
			call AvatarSTD;
		};
		
		

	}
	
	
	if (event == ANDREAS_UNDRESSES)
	{
		UI_error_message("ANDREAS_UNDRESSES starting");
		var player_is_female = UI_is_pc_female();
		var bark1;
		var bark2;
		if (player_is_female)
		{
			bark1 = "Let's go..";
			bark2 = "Come again, foxy!";
		}
		else
		{
			bark1 = "Money is money..";
			bark2 = "Gotta earn a living somehow!";
		}
			
		script ANDREAS //after 5 ticks
		{
			nohalt;
			actor frame standing;                   wait 5;                                         face west;
			actor frame bowing;                     wait 2;
			call gypsyUndress;
			step west; 				wait 2;
			actor frame sleeping;                   wait 2;     face west;
			wait 2;
			say bark1;		wait 2;
			wait 160; //from 180
			
			actor frame standing;                   wait 1;                                         face east;
			actor frame bowing;                     wait 1;
			call gypsyDressed;	
			wait 1;
			actor frame standing;                   wait 1;                                         face east;
			wait 2;
			say bark2;
			call gypsyWalksAway;	
		};


	
		script AVATAR after 28 ticks
		{
			nohalt;
			actor frame standing;           wait 1;             	face west;
			actor frame bowing;                     wait 1;
			call AvatarUndress; 			wait 3;
			repeat 2 {step west; 			wait 1;};
			repeat 2 {actor frame sleeping;         wait 1;     face west;}; //from repeat 3
			
			
			call GenericPaletteFade;		wait 90; //from 160
							
			call GenericPaletteUnfade;		wait 5; //from 2
			actor frame standing;                   wait 1;                                         	face east;
			actor frame bowing;                     wait 1;
			call AvatarDress;			wait 60;
			call AvatarWalksAway; 			wait 3;
			say "@Whew!@";				wait 55;
			call AvatarChided; 			wait 350; //from 400
			call AvatarSTD;
		};
		
		

	}	
	
	
	

}