//function to determine if someone in the party is charmed already
var isCharmed(var npc)
{
	if (UI_get_item_flag(npc, CHARMED))
	{
		UI_error_message("npc is charmed");
		return true;
		
	}	
	else
	{
		UI_error_message("npc is NOT charmed");
		return false;

	}
}


//the event which is called from equipping the Chaos sword
void chaosSword object# () ()
{
	var cont;
	
	enum chaos_levels
	{
    	CHAOS_LOOP				= 1,
		CHAOS_POISON 			= 2,
		CHAOS_BURN				= 3   //Karma is too high > 20
		
    
	};
	
	UI_error_message("chaosSword called");
	
	//prevents from calling it too much
	if (gflags[CHAOS_SWORD_EQUIPPED])
	{
		UI_error_message("Chaos sword loop activated via readied event");
		script item after 10 ticks
		{
			call chaosSword, CHAOS_LOOP;
		
		};
	}
	
	if (event == CHAOS_LOOP)
	{
		//randomPartyBark("Chaos loop initiated");
		UI_error_message("Chaos sword event called");
		//Get sword container:
		cont = get_container();
		
		//Avatar's karma - can't be too high to wield the chaos sword. 
		var avatar_karma = getKarma();
		
		var is_charmed = false; //boolean to detrmine if someone is charmed already
		
		var party = UI_get_party_list();
		var npc;
		var rand = UI_get_random(5);
		
		//random chance wearer takes damage
		
		//karma is too high, sword will do damage and kill the wearer.  NPCs in the party will share the Avatar's karma of course. 
		if (avatar_karma > 40 && rand == 3)
		{
			UI_error_message("Avatar karma is " + avatar_karma + ", take damage after 40!");
			if (cont->is_npc() && (item == cont->get_readied(BG_BOTH_HANDS) || item == cont->get_readied(BG_WEAPON_HAND))) //failsafe
			{
				
				
				
				var current_health = UI_get_npc_prop(cont, HEALTH);
				
				if (avatar_karma < 60)
					UI_item_say(cont, "Yeow! The chaos sword feels hot!");
				else if (avatar_karma > 60 && avatar_karma < 80)
					UI_item_say(cont, "The chaos sword is burning mine hand!");
				else if (avatar_karma > 80)
				{
					UI_item_say(cont, "The chaos sword feels very hot and unstable!");
					//earthquake effect
					UI_earthquake(3);
				
					rand = UI_get_random(5);
					
					if (rand == 1) //chaos sword erupts and explodes!
					{
						UI_obj_sprite_effect(cont, 5, 0,0, 0, 0, 0, -1); //small explosion on the wearer

						if (avatar_karma / 6 < current_health > 0)
							UI_item_say(cont, "The chaos sword just exploded in mine hand!");
						else
							UI_item_say(cont, "Arrrgh!!");
						
						//remove chaos sword
						UI_remove_item(item);
						
						
					
						gflags[CHAOS_SWORD_EQUIPPED] = false;
					}
					
					
				
				}
				
				//apply damage based on karma
				UI_apply_damage(1, avatar_karma / 6, LIGHTNING_DAMAGE, cont);	
				UI_play_sound_effect(26);
				
							
			
				
				
			
			}
		
		
		}
		else if (UI_in_combat())
		{
			if (cont->is_npc() && (item == cont->get_readied(BG_BOTH_HANDS) || item == cont->get_readied(BG_BOTH_HANDS))) //switch to weapon hand if not 2 handed
				//charm user:
				cont->set_item_flag(CURSED);
		
			//check if anyone in the party is charmed, if not, set them as charmed
			
			for (npc in party)
			{
				if (isCharmed(npc))
				{
					is_charmed = true;
					continue;
				}	
			
			}
			
			
			//no one in the party is charmed, pick a random one and charm them
			if (!is_charmed)
			{
				var party_num =  UI_get_array_size([party]);
				var rand = UI_get_random(party_num);
				var rand_npc = party[rand];
				
				//set the random party member to CHARMED
				UI_set_item_flag(rand_npc, CHARMED);
				
				//set alignment
				UI_set_alignment(rand_npc, CHAOTIC);
			
			
			}
			
		
		
		}
		if (UI_is_readied(cont, BG_WEAPON_HAND, SHAPE_CHAOS_SWORD, FRAME_ANY))
		{
			UI_error_message("Chaos loop called");
			script item after 30 ticks
			{
				call chaosSword, CHAOS_LOOP;
			
			}
		}
	
	
	
	}
	
	//karma is > 20, too high to wield the chaos sword.  
	if (event == CHAOS_BURN)
	{
		
	
	
	}

}

void ChaosSword shape#(637) () //
{
	var party = UI_get_party_list();
	var cont;

	if (event == DOUBLECLICK)
	{
	
		item->chaosSword();
	
	}


	if (event == READIED)
	{
		UI_close_gumps();
		gflags[CHAOS_SWORD_EQUIPPED] = true;
		UI_error_message("Should call chaos sword object");
		item->chaosSword();
	}

	if (event == UNREADIED)
	{

	 //Stop charmed:
		gflags[CHAOS_SWORD_EQUIPPED] = false;
		
		//clear charmed effect
		for (npc in party)
		{
			//clear the random party member to CHARMED
			UI_clear_item_flag(npc, CHARMED);
					
			//set alignment back to GOOD
			UI_set_alignment(npc, GOOD);
		}
	}
 
}
 




