


//used for balloon - renders party once the balloon has landed	
void renderParty object#() ()
{
	UI_error_message("render party called");
	var party = UI_get_party_list();
	var balloon = UI_find_nearest(AVATAR, SHAPE_BALLOON, 31); //
	var npc;
	var warningLevel = UI_get_npc_id(BALLOON_DOG);
	
	
	//get barge Avatar is on then remove it
	var barge = UI_get_barge(AVATAR);
	UI_remove_item(barge);
	
	//reworked for falling into the void.  
	if (warningLevel > 2)
	{
		//kill Avatar
		UI_apply_damage(127, 127, ETHEREAL_DAMAGE, AVATAR);
		
		//reset warning level
		UI_set_npc_id(BALLOON_DOG, 0); 
	
	}
	else
	{
		for (npc in party)
		{
			
			UI_clear_item_flag(npc, DONT_RENDER);
			
		}
		UI_clear_item_flag(AVATAR, DONT_RENDER);
		UI_clear_item_flag(AVATAR, POLYMORPH);
		
		//re-center screen on the Avatar
		UI_center_view(AVATAR);
		
		UI_set_item_frame(balloon, 0);
	}

}	





//function that makes sure the Avatar doesn't fly off the gargoyle world too far...
void checkVoid object#() ()
{
	enum checkVoid_levels
	{
		 CHECK_VOID                                       = 1,
		 CHECK_VOID2                                      = 2,
		 BALLOON_SINKING                                  = 3,
		 LAND_BARGE                                       = 4,
		 ADD_BARGE										  = 5




	};





	var warningLevel = UI_get_npc_id(BALLOON_DOG);
	var balloon = UI_find_nearby_avatar(SHAPE_NEW_BALLOON);
	//var balloon = UI_find_object(FIND_ON_SCREEN, SHAPE_NEW_BALLOON, QUALITY_ANY, FRAME_ANY);
	var barge = get_barge();
	
	//if (balloon)
	//	UI_error_message("Balloon found.");
	//else
	//	UI_error_message("Balloon NOT found.");
		
	//if (barge)
	//	UI_error_message("Barge found.");
	//else
	//	UI_error_message("Barge NOT found.");		
	
	//get current position and map
	var current_pos = UI_get_object_position(AVATAR);
	var currentX = current_pos[X];
	var currentY = current_pos[Y];
	var top_left = [0923, 0678, 0];
	var bottom_right = [2230, 2099, 0];
	var current_map = UI_get_map_num(AVATAR);
	
	if (event == CHECK_VOID) 
   	{
		UI_error_message("Event CHECK_VOID is playing.  Warning level is: " + warningLevel);
		
		
		if (warningLevel > 2) //have been warned several times already to go back to land
		{
			randomPartyBark("@The balloon is falling into the void!!@");
			UI_halt_scheduled(AVATAR);
			script AVATAR after 15 ticks
			{
				call checkVoid, BALLOON_SINKING;
			
			}
		
		
		}
		else
		{
			//if map is not 3, do nothing
			if (current_map == 3)
			{
				if (currentX > top_left[X] && currentX < bottom_right[X] && currentY > top_left[Y] && currentY < bottom_right[Y]) //in bounds, do nothing
					UI_error_message("Balloon is in bounds of the gargoyle world");
				else
				{
					//balloon is out of bounds, give warning
					UI_error_message("Balloon OUT of bounds of the gargoyle world - warning level " + warningLevel);
					
					//set ID level for balloon dog (holder for warning level)
					UI_set_npc_id(BALLOON_DOG, warningLevel + 1);
					
					//give party warning
					randomPartySay("@We should probably turn back, it feels like the balloon is getting sucked into the void!@");
					
				}
				
			}
			
			if (!gflags[BALLOON_IS_FLYING])
			{
				UI_error_message("Balloon is landed, call off the script");
			//	UI_halt_scheduled(balloon);
				UI_set_npc_id(BALLOON_DOG, 0); // reset warning level
			}	

			script AVATAR after 30 ticks
			{
				call checkVoid, CHECK_VOID;
			
			}
		}
		
	}
	
	if (event == CHECK_VOID2) 
	{
		//randomPartyBark("@Event CHECK_VOID is playing@");
		UI_error_message("Event CHECK_VOID2 is playing");
		script AVATAR
		{
			call checkVoid, CHECK_VOID;
		
		}
		
	
	
	
	}

	if (event == LAND_BARGE)
	{
		var barge = UI_find_nearby(AVATAR, 961, 10, MASK_EGG); //hopefully find the barge before placing
		var party = UI_get_party_list();
		var quality = get_item_quality();
		var balloon = UI_find_nearest(AVATAR, SHAPE_BALLOON, 31); //

		// Yes; so begin process of landing.
		// Flag 10 = 'on moving barge'
		barge->clear_item_flag(10);
		// Flag 26 = 'in motion'
		barge->clear_item_flag(26);
		
		// Make barge descent until the ground.
		// Flag 10 = 'on moving barge'
		balloon->clear_item_flag(10);
		
		// Flag 26 = 'in motion'
		balloon->clear_item_flag(26);
		
		// Make barge descent until the ground.
			script barge
			{
				repeat 10
				{
					descent;
					
				};
			}



			script balloon
			{
				repeat 9
				{
					descent; //should lift item on z level 8
				};
				wait 3;
		  
			}


			script AVATAR
			{
				repeat 9
				{
					descent; //should lift item on z level 9
				};
			}

			for (npc in party)
			{
				script npc
				{
					 repeat 9
					{
						descent; //should lift item on z level 9
					};
						
				}
			}


			UI_remove_item(barge);
	
	
	
	
	
	
	}
	
	if (event == BALLOON_SINKING)
	{
		UI_error_message("Event BALLOON_SINKING called");
		const int SHAPE_BALLOON = 1201;
		var barge = get_barge();
		var party = UI_get_party_list();
		var balloon = UI_find_nearest(AVATAR, SHAPE_BALLOON, 31); //
		//var newballoon = UI_find_object(FIND_ON_SCREEN, SHAPE_NEW_BALLOON, QUALITY_ANY, FRAME_ANY);
		var newballoon = UI_find_object(FIND_ON_SCREEN, 1232, QUALITY_ANY, FRAME_ANY); //test
		var quality = UI_get_item_quality(item);
		var basket_pos = UI_get_object_position(item);
		
		
		if (item)
			UI_error_message("Balloon in BALLOON_SINKING event found");
		else
			UI_error_message("Balloon in BALLOON_SINKING event NOT found");
			
		

		//UI_set_item_flag(AVATAR, BG_DONT_MOVE);
		
		// Flag 10 = 'on moving barge'
		barge->clear_item_flag(10);
		
		// Flag 26 = 'in motion'
		barge->clear_item_flag(26);
		
		// Make carpet descent until the ground.
		// Flag 10 = 'on moving barge'
		item->clear_item_flag(10);
		
		// Flag 26 = 'in motion'
		item->clear_item_flag(26);
		
		// Flag 10 = 'on moving barge'
		AVATAR->clear_item_flag(10);
		
		// Flag 26 = 'in motion'
		AVATAR->clear_item_flag(26);
		UI_clear_item_flag(AVATAR, SAILOR);

		//sound effect
		UI_play_sound_effect(89);
		
		//cut the music
		UI_play_music(255);
		
		//may not be necessary:
	//	UI_halt_scheduled(AVATAR);

		script balloon //changed from balloon
		{
				
			repeat 9
			{
				descent; //should lift item on z level 9
			};
			wait 5;
			

		}
		script barge after 20 ticks
		{
			call renderParty;
			
			
		}

		script AVATAR
		{
			repeat 9
			{
				descent; //should lift item on z level 9
			};
			
		}
		

	
		
		
		

		for (npc in party)
		{
			script npc
			{
				repeat 9
				{
					descent; //should lift item on z level 9
				};
				
			}
		
			
		}

		//remove balloon
		//UI_remove_item(item);
		
		gflags[BALLOON_IS_FLYING] = false;


	}



}


void AddBarge object#() ()
{

	var party = UI_get_party_list();
	var basket_pos = UI_get_object_position(item);
	var quality = get_item_quality();
	var balloon = UI_find_nearest(AVATAR, SHAPE_BALLOON, 31); //

	UI_create_barge_object(6, 6, NORTH);		
	UI_update_last_created([basket_pos]);

	UI_set_item_flag(AVATAR, SAILOR);
	UI_set_item_flag(AVATAR, ON_MOVING_BARGE);
	UI_set_item_flag(AVATAR, IN_MOTION);
	
	script item
	{
		rise; //should lift item on z level 9
	};
	
	UI_set_item_shape(item, SHAPE_NEW_BALLOON); //so the Avatar can double click the new shape to descend
	
	//balloon is in the air, set flag
	gflags[BALLOON_IS_FLYING] = true;
	
	//calls checkVoid event
	item->checkVoid();
		
}

	

void balloon shape#(1201) ()
{	
	
	var barge = get_barge();
	var party = UI_get_party_list();
	var balloon = UI_find_nearest(AVATAR, SHAPE_BALLOON, 31); //
	var quality = UI_get_item_quality(item);
	var basket_pos = UI_get_object_position(item);

	if (event == DOUBLECLICK)
	{
		UI_error_message("Balloon event called from Doubleclick from new_balloon.uc");
		if (UI_get_item_frame(item) == 0) //Balloon is freshly placed and ready to ride
		{
			var barge = UI_find_nearby(basket_pos, 961, 10, MASK_EGG); //hopefully find the barge before placing
			
			if ((UI_get_container(item) == 0))  //checks if on the ground and not in container
			{
				if (!UI_is_pc_inside()) //checks if no roof above
				{
					if (!UI_find_nearby(basket_pos, 961, 10, MASK_EGG)) //will create barge if one not found 		
					{
						UI_create_barge_object(8, 8, NORTH);		//changed from 7x7
						UI_update_last_created([basket_pos]);

					}
					
					if (UI_on_barge()) //everyone should be on barge
					{
						var barge = UI_find_nearby(basket_pos, 961, 10, MASK_EGG); //hopefully find the barge before placing
							
						UI_remove_item(barge); //removes barge to create new one at proper z level
						UI_set_polymorph(AVATAR, 639); //death vortex
						
						//attempt to put Avatar in the middle of the barge
						UI_si_path_run_usecode(AVATAR, [basket_pos[X] -1, basket_pos[Y] -1]);
						
											

						script item
						{
							repeat 9
							{
								rise; //should lift item on z level 8
								//add sfx
								//sfx 
							};

							wait 3;
							call AddBarge;
							
		
						}



						script AVATAR
						{
							repeat 9
							{
								rise; //should lift item on z level 9
							};
								
							
								
				
						}

						for (npc in party)
						{
							script npc
							{
								repeat 9
								{
									rise; //should lift item on z level 9
								};
				
							}

							UI_set_item_flag(npc, DONT_RENDER);
							UI_clear_item_flag(AVATAR, DONT_RENDER);
							
			
						}
						//carpet theme
						UI_play_music(25);
						
						
						
						

		
					}//on barge
					else
					{				//UI_si_path_run_usecode(actor npc, int pos[], int event, object obj, function fun, bool flag)
						UI_si_path_run_usecode(AVATAR, [basket_pos[X] -1, basket_pos[Y] -1], DOUBLECLICK, item, balloon, false);
						//AVATAR->path_run_usecode([basket_pos[X] -1, basket_pos[Y] -1], balloon, item, DOUBLECLICK, false);
						UI_error_message("Avatar should walk to balloon and call doubldlick");
						for (npc in party)
						{
							UI_error_message("Attempting to move " + npc);
						
							UI_si_path_run_usecode(npc, [basket_pos[X] -1, basket_pos[Y] -1], SCRIPTED, item, balloon, false);		
						}
						
						
						
					}
												
				}
				else randomPartyBark("@The balloon can't be used here.@");
			}
			else randomPartyBark("@Place it on the ground first..@");
    	
		}
		else //packing the balloon
		{
			UI_set_item_frame(item, 0); //to make sure the packed balloon renders
			
			var item_frame = UI_get_item_frame(item);
			//var location = UI_get_object_position(item);
			UI_set_item_shape(item, SHAPE_PACKED_BALLOON); //landed, packed balloon
			UI_set_item_frame(item, 0); //to correct the frame
			
			
			//UI_move_object(item, location, false);
			
			var item_shape = UI_get_item_shape(item);
			UI_error_message("Balloon should be packed.  Item frame is " + item_frame + " and item shape is now: " + item_shape);
		}
	}
	else
		return;
	
	if (event == SCRIPTED)
	{
	
		//balloon should not be in the air
		if (!gflags[BALLOON_IS_FLYING])
		{
	
	
			UI_error_message("Balloon event called from Scripted from new_balloon.uc");
			if (UI_on_barge()) //should wait til everyone is on barge before running the script
			{
			
				script item
				{
					repeat 9
					{
						rise; //should lift item on z level 8
						//add sfx
						//sfx 
					};

					wait 3;
					call AddBarge;

				}
				
				script AVATAR
				{
					repeat 9
					{
						rise; //should lift item on z level 9
					};
						
						
		
				}

				for (npc in party)
				{
					script npc
					{
						repeat 9
						{
							rise; //should lift item on z level 9
						};
		
					}

					UI_set_item_flag(npc, DONT_RENDER);
					UI_clear_item_flag(AVATAR, DONT_RENDER);
					UI_set_polymorph(AVATAR, 639); //death vortex
				
				}
				
				//carpet theme
				UI_play_music(25);
				UI_error_message("Scripted event called on balloon");
			}
		}
		else //balloon is in the air, call the scripted function to determine if close to gargoyle island
		{
			
			
			if (!gflags[BALLOON_IS_FLYING])
			{
				UI_error_message("Balloon is landed, call off the script");
				UI_halt_scheduled(AVATAR);
				UI_set_npc_id(BALLOON_DOG, 0); // reset warning level
			}	
		
		}
			
	}

}


