/*
 *
 *  Copyright (C) 2006  The Exult Team
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 *	This source file contains the code for the Improved Orb of the Moons.
 *
 *	Author: Marzo Junior
 *	Last Modified: 2006-02-27
 */

/* The old Moongate destinations:
enum moongate_destinations
{
	BRITAIN				= 1,
	JHELOM				= 2,
	YEW					= 3,
	MINOC				= 4,
	TRINSIC				= 5,
	NEW_MAGINCIA		= 6,
	SKARA_BRAE			= 7,
	SPIRITUALITY		= 8
	MOONGLOW			= 9,
};
*/

enum moongate_destinations_new
{
	BRITAIN				= 1,
	JHELOM				= 2,
	YEW					= 3,
	MINOC				= 4,
	TRINSIC				= 5,
	SKARA_BRAE			= 6,
	NEW_MAGINCIA     	= 7,
	MOONGLOW			= 8,
	COMPASSION			= 9,
	VALOR				= 10,
	JUSTICE				= 11,
	SACRIFICE			= 12,
	HONOR				= 13,
	SPIRITUALITY		= 14,
	HUMILITY			= 15,
	HONESTY				= 16
	
	/*
	//Maybe I will add these locations in the future:
	CASTLE_BRITISH		= 17,
	SERPENTS_HOLD		= 18,
	STONEGATE			= 19, //Some other location, maybe?
	ISLE_OF_AVATAR		= 20,
	EMPATH_ABBEY		= 21,
	TERFIN_SHRINE		= 22,
	LYCAEUM				= 23,
	?????				= 24
	*/
};

var isOrbMoongate 0x826 (var itemref)
{
	var orbmoongates;
	orbmoongates = [SHAPE_ORB_MOONGATE_HORIZONTAL, SHAPE_ORB_MOONGATE_NW_SE,
			   SHAPE_ORB_MOONGATE_VERTICAL, SHAPE_ORB_MOONGATE_NE_SW];
	if ((itemref->get_item_shape()) in orbmoongates)
		return true;
	else
		return false;
}

var getMoongateDestination 0x823 (var moongate)
{
	/* Old destinations:
	//The coordinates of moongate destinations (changed to reflect the multi-map Britannia):
	dest_X =   [0x04dF, 0x0105, 0x0207, 0x073F, 0x03FF, 0x087F, 0x0237, 0x0B67, 0x0B3F];
	dest_Y =   [0x0550, 0x0B0A, 0x01EB, 0x0192, 0x0983, 0x0922, 0x0649, 0x0963, 0x0712];
	dest_Z =   [0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x0000, 0x0000, 0x0001, 0x0000];
	dest_map = [0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x0000];
	*/

	//The coordinates of moongate destinations. These are also the destinations
	//of "standard" blue moongates. If you compare with the above, you'll see
	//that I switched Skara Brae with New Magincia. This is so the Orb works
	//closer to the one from U6. Whatever differences are left from U6 (and 
	//there are many) I blame on the sphere generator :-).
	var dest_X = [
	//Cities:	Britain, 		Jhelom, 		Yew, 			Minoc, 			Trinsic, 
				0x054F, 		0x0105, 		0x02b7, 		0x07dF, 		0x046f,
	//			Skara Brae, 	New Magincia	Moonglow
				0x00af, 		0x08bF, 		0x0ac0,
				
	//Shrines:	Compassion, 	Valor,  		Justice, 		Sacrifice, 		Honor,
				0x0606, 		0x01FB, 		0x0386, 		0x9b9, 			0x03b1,
	
	//			Spirituality,	Humility, 		Honesty
				0x098a, 		0x0B07, 		0x0A99
	 ];

	var dest_Y = [
	//Cities:	Britain, 		Jhelom, 		Yew, 			Minoc, 			Trinsic,
			0x04df, 		0x0B0A, 		0x01a7, 		0x00cf, 		0x098f,
	//		Skara Brae, 		New Magincia		Moonglow
			0x05ff, 		0x083f, 		0x05e0,
	//Shrines:	Compassion, Valor,  		Justice, 		Sacrifice, 		Honor,
			0x0460, 		0x0A70, 		0x0070, 		0x1fd, 		    0x09f6,
	//		Spirituality,	Humility, 		Honesty
			0x0498, 		0x0B0a, 		0x048C
		 ];

	var dest_Z = [
	//Cities:	Britain, 		Jhelom, 		Yew, 			Minoc, 			Trinsic,
				0x0000, 		0x0000, 		0x0000, 		0x0000, 		0x0001,
	//			Skara Brae, 	New Magincia	Moonglow
				0x0000, 		0x0000, 		0x0002,
	//Shrines:	Compassion, 	Valor,  		Justice, 		Sacrifice, 		Honor,
				0x0000, 		0x0000, 		0x0000, 		0x0000, 		0x0000,
	//			Spirituality,	Humility, 		Honesty
				0x0001, 		0x0000, 		0x0000
		 ];

	var dest_map = [
	//Cities:	Britain, 		Jhelom, 		Yew, 			Minoc, 			Trinsic,
				0, 				0, 				0, 				0, 				0,
	//			Skara Brae, 	New Magincia	Moonglow
				0, 				0, 				0,
	//Shrines:	Compassion, 	Valor,  		Justice, 		Sacrifice, 		Honor,
				0, 				0, 				0, 				0, 				0,
	//			Spirituality,	Humility, 		Honesty
				1, 				0, 				0
		 ];

	var dest_index;
	var dest_pos;
	
	
	
	
	
	

	//Get moongate quality = destination index:
	dest_index = (moongate->get_item_quality() + 1);
	
	//Blue moongates should only take the avatar to places with blue moongates;
	//this happens only in the exit from the Shrine of Spirituality, which should
	//take us to Skara Brae (Moonglow in the original):
	if (!isOrbMoongate(moongate) && (dest_index > 8)) dest_index = SKARA_BRAE;
	
	//If the orb hasn't been fixed, we can't visit the Timelord:
	//if ((!gflags[ORB_FIXED_TIMELORD]) && (dest_index == SPIRITUALITY)) dest_index = SKARA_BRAE;
	//the original takes the avatar to Moonglow instead.

	//Return the exit coordinates of the moongate:
	dest_pos = [dest_X[dest_index], dest_Y[dest_index], dest_Z[dest_index], dest_map[dest_index]];
	
	//return the destination coordinates:
	return dest_pos;
}

void enterMoongate 0x824 (var moongate)
{
	var avatar_pos;
	var moongate_pos = UI_get_object_position(moongate);
	var moongate_shape;
	var var0004;
	var quality = UI_get_item_quality(moongate);
	
	var destination;
	
	//town coords
	var britain = [1360, 1247, 0, 0];
	var trinsic = [1135, 2447, 0, 0];
	var yew = [0695, 0425, 0, 0];
	var skara = [0175, 1535, 0, 0];
	var minoc = [2015, 0207, 0, 0];
	var jhelom = [0400, 2688, 0, 0];
	var new_magincia = [2240, 2112, 0, 0];
	var moonglow = [2751, 1504, 0, 0];
	
	//shrine coords
	var humility = [2800, 2858, 0, 0];
	var justice = [0911, 0131, 0, 0];
	var honor = [0943, 2582, 0, 0];
	var sacrifice = [2513, 0530, 0, 0];
	var compassion = [1554, 1141, 0, 0];
	var valor = [0432, 2911, 0, 0];
	var honesty = [2858, 0826, 0, 0];
	var spirituality = [2457, 1198, 0, 1];
	
	
	//other coords
	// gargoyle lands are protected by global flags, only avaliable once you reach it
	var the_slab = [1576, 1333, 0, 3];
	var diligence = [1568, 1740, 0, 3];
	var control = [1401, 1170, 0, 3];
	var passion = [1719, 1167, 0, 3];
	
	var isle_of_avatar = [2808, 2687, 0, 0];
	var lb_throneroom = [0935, 1070, 0, 0];
	
	
	
	
	

	//Fade to black:		
	UI_fade_palette(12, 1, 0);
		
	//Moongate travel sound:
	UI_play_sound_effect2(SOUND_MOONGATE, item);
		
	//Teleport avatar to destination:
//	var dest = getMoongateDestination(moongate);
	
	if (quality == 0)//void
		destination = moongate_pos;
	else if (quality == 1)
		destination = compassion;
	else if (quality == 2)
		destination = honesty;	
	else if (quality == 3)
		destination = britain;
	else if (quality == 4)
		destination = lb_throneroom;
	else if (quality == 5)
		destination = jhelom;	
	else if (quality == 6)
		destination = passion;
	else if (quality == 7)
		destination = valor;		
	else if (quality == 8)
		destination = justice;		
	else if (quality == 9)
		destination = yew;		
	else if (quality == 10)
		destination = minoc;		
	else if (quality == 11)
		destination = isle_of_avatar;		
	else if (quality == 12)
		destination = sacrifice;
	else if (quality == 13)
		destination = honor ;
	else if (quality == 14)
		destination = trinsic;
	else if (quality == 15)
		destination = diligence;
	else if (quality == 16)
		destination = skara;
	else if (quality == 17)
		destination = the_slab;
	else if (quality == 18)
		destination = humility;		
	else if (quality == 19)
		destination = spirituality;		
	else if (quality == 20)
		destination = new_magincia;	
	else if (quality == 21)
		destination = moonglow;		
	else if (quality == 22)
		destination = control;
	else
		destination = moongate_pos;
		
		UI_error_message("Quality is " + quality + " and destination is: " + destination);
		
		PARTY->move_object(destination);
		
		script AVATAR {nohalt;	call exitMoongate;};
	
}

void Orb_of_the_Moons shape#(0x311) ()
{
	var target;
	var target_coords;
	var direction;
	var coordinate;
	var moongate_shape;
	var counter;
	var blocked;
	var moongate;
	var arrived_dest;
	var distance;
	var avatar_pos;
	var coord_offset;
	
	var quality; //used to set for correct destination
	
	var destination; 
	
	//town coords
	var britain_coords = [1360, 1247, 0, 0];
	var trinsic_coords = [1135, 2447, 0, 0];
	var yew_coords = [0695, 0243, 0, 0];
	var skara_coords = [0175, 1535, 0, 0];
	var minoc_coords = [2015, 0207, 0, 0];
	var jhelom_coords = [0400, 2688, 0, 0];
	var new_magincia_coords = [2240, 2112, 0, 0];
	var moonglow_coords = [2751, 1504, 0, 0];
	
	//shrine coords
	var humility = [2800, 2858, 0, 0];
	var justice = [0911, 0131, 0, 0];
	var honor = [0943, 2582, 0, 0];
	var sacrifice = [2513, 0530, 0, 0];
	var compassion = [1554, 1141, 0, 0];
	var valor = [0432, 2911, 0, 0];
	var honesty = [0943, 2582, 0, 0];
	var spirituality = [2457, 1198, 0, 1];
	
	
	//other coords
	// gargoyle lands are protected by global flags, only avaliable once you reach it
	var the_slab = [1576, 1333, 0, 3];
	var diligence = [1568, 1740, 0, 3];
	var control = [1401, 1170, 0, 3];
	var passion = [1719, 1167, 0, 3];
	
	var isle_of_avatar = [2808, 2687, 0, 0];
	var lb_throneroom = [0935, 1070, 0, 0];
	



	if (event == DOUBLECLICK)
	{
		if (!gflags[ASKED_LB_ABOUT_ORB])
		{
			delayedBark(AVATAR, "@I don't know how to use this..@", 0);
			return;
		}
		
		//I prefer this here to help the player choose a
		//target (no gumps in the way and all...):
		UI_close_gumps();
		
		//Prompt for target:
		target = UI_click_on_item();
		
		//Get the target's coordinates:
		target_coords = getClickPosition(target);
		
		//Make avatar face moongate.
		script AVATAR {face target;};
		
		
		//Find the direction of the throw:
		direction = AVATAR->find_direction(target_coords);
		UI_error_message("Avatar direction from target coords is " + direction);
		
		//Get avatar position:
		avatar_pos = AVATAR->get_object_position();
		

		var moongateshapes = [SHAPE_ORB_MOONGATE_HORIZONTAL, SHAPE_ORB_MOONGATE_NW_SE, SHAPE_ORB_MOONGATE_VERTICAL,
							  SHAPE_ORB_MOONGATE_NE_SW, SHAPE_ORB_MOONGATE_HORIZONTAL, SHAPE_ORB_MOONGATE_NW_SE,
							  SHAPE_ORB_MOONGATE_VERTICAL, SHAPE_ORB_MOONGATE_NE_SW];
							  
	
		
		var dist_x = (target_coords[X] - avatar_pos[X]);
		UI_error_message("Dist x is " + dist_x);
		
		var dist_y = (target_coords[Y] - avatar_pos[Y]) * -1;
		UI_error_message("Dist y is " + dist_y);
		
		
		//find proper moongate shape and destination
		
		
		//center column of "U6 grid"
		if (dist_x > -3 && dist_x < 3)
		{
			moongate_shape = SHAPE_ORB_MOONGATE_HORIZONTAL;
			if (dist_y > -3 && dist_y < 2)
				quality = 0; //void
			else if (dist_y < -3 && dist_y > -8)
			{
				if (gflags[FOUND_DILIGENCE])
					quality = 15; //Shrine of Diligence
				else
					quality = 0; //haven't visited shrine yet
			}
			else if (dist_y < -8)
				quality = 14; //Trinsic;
			else if (dist_y > 2 && dist_y < 8)
				quality = 4;//lb_throneroom;
			else
				quality = 3; //britain_coords;


			



		}
		//2nd column (left)
		else if (dist_x > -8 && dist_x < -2) 
		{
			moongate_shape = SHAPE_ORB_MOONGATE_HORIZONTAL;
			
			if (dist_y > 7)
				quality = 2; // Honesty shrine
			else if (dist_y < 7 && dist_y > 2)
			{
				if (gflags[FOUND_CONTROL])
					quality = 22; //CONTROL
				else
					quality = 0; //haven't visited Control yet
				moongate_shape = 1114;
				
			
			}
			else if (dist_y < 3 && dist_y > -3)
			{
				quality = 20; // New Magincia
				moongate_shape = SHAPE_ORB_MOONGATE_VERTICAL;
			}
			else if (dist_y < -2 && dist_y > -8)
			{
				moongate_shape = SHAPE_ORB_MOONGATE_NE_SW;
				if (gflags[FOUND_SLAB])
					quality = 17; //The Slab
				else
					quality = 0; //haven't visited Slab yet
				
			
			}
			else
				quality = 13; // Shrine of Honor
			
		
		}
		//1st column
		else if (dist_x < -7)
		{
			moongate_shape = SHAPE_ORB_MOONGATE_HORIZONTAL;
			if (dist_y > 7)
			{
				quality = 21; //Moonglow
				moongate_shape = SHAPE_ORB_MOONGATE_NW_SE;
			}
			else if (dist_y < 7 && dist_y > 2)
			{
				quality = 18; //Shrine of Humility
				moongate_shape = SHAPE_ORB_MOONGATE_HORIZONTAL;
			
			
			}
			else if (dist_y < 3 && dist_y > -3)
			{
				quality = 20; // New Magincia
				moongate_shape = SHAPE_ORB_MOONGATE_VERTICAL;
			}
			else if (dist_y < -2 && dist_y > -8)
			{
				moongate_shape = SHAPE_ORB_MOONGATE_HORIZONTAL;
				quality = 19; //Shrine of Spirituality
			
			}
			else
			{
				quality = 16; //Skara Brae
				moongate_shape = SHAPE_ORB_MOONGATE_NE_SW;
			}
			
			
			
			
		}
		//4th column (right)
		else if (dist_x > 2 && dist_x < 8)
		{
			moongate_shape = SHAPE_ORB_MOONGATE_HORIZONTAL;
			if (dist_y > 7)
				quality = 1; //compassion;
			else if (dist_y < 7 && dist_y > 2)
			{
				if (gflags[FOUND_PASSION])
					quality = 6; //Shrine of passion
				else
					quality = 0; //haven't visited Control yet
				moongate_shape = SHAPE_ORB_MOONGATE_NE_SW;
				
			
			}
			else if (dist_y < 3 && dist_y > -3)
			{
				quality = 9; // Yew
				moongate_shape = SHAPE_ORB_MOONGATE_VERTICAL;
			}
			else if (dist_y < -2 && dist_y > -8)
			{
				moongate_shape = SHAPE_ORB_MOONGATE_NW_SE;
				quality = 11; //isle of the avatar
				
			
			}
			else
				quality = 12; //Shrine of Sacrifice
		
			
		
		}
		//5th column
		else if (dist_x > 7)
		{
			moongate_shape = SHAPE_ORB_MOONGATE_HORIZONTAL;
			if (dist_y > 7)
			{
				UI_error_message("Destination should be Jhelom");
				quality = 5; //Jhelom_coords;
				moongate_shape = SHAPE_ORB_MOONGATE_NE_SW;
			}
			else if (dist_y < 7 && dist_y > 2)
			{
				quality = 7; //Shrine of Valor
				moongate_shape = SHAPE_ORB_MOONGATE_HORIZONTAL;
			
			
			}
			else if (dist_y < 3 && dist_y > -3)
			{
				quality = 9; // Yew
				moongate_shape = SHAPE_ORB_MOONGATE_VERTICAL;
			}
			else if (dist_y < -2 && dist_y > -8)
			{
				moongate_shape = SHAPE_ORB_MOONGATE_HORIZONTAL;
				quality = 8; //Shrine of Justice
			
			}
			else
			{
				quality = 10; //minoc_coords;
				moongate_shape = SHAPE_ORB_MOONGATE_NW_SE;
			}
			
			
			
			
		}
		
		
		
		
		UI_error_message("Moongate quality is " + quality);
	
		
		

		//Change the position to make moongate centered on target pos:
		//target_coords[coordinate] = (target_coords[coordinate] + 2);
		
		if ((direction == NORTH) || (direction == SOUTH))
			target_coords[X] = (target_coords[X] + 2);
		else if ((direction == EAST) || (direction == WEST))
			target_coords[Y] = (target_coords[Y] + 2);
		else
		{
			target_coords[X] = (target_coords[X] + 1);
			target_coords[Y] = (target_coords[Y] + 1);
		}
		
		//See if the target destination is blocked:
		blocked = (!UI_is_not_blocked(target_coords, moongate_shape, 0));
		
		if (blocked)
		{
			UI_error_message("Error - moongate blocked");
			//It is blocked; attempt to circumvent it by incrementing
			//the Z coordinate and give up trying after 3 tries:
			counter = 3;
			while (counter)
			{
				target_coords[Z] = (target_coords[Z] + 1);
				blocked = (!UI_is_not_blocked(target_coords, moongate_shape, 0));
				if (!blocked) counter = 0;
				else counter = counter - 1;
			}
			
			//If it is still blocked, tell it to the player
			//and then leave:
			if (blocked)
			{
				UI_flash_mouse(0);
				return;
			}
		}

		//Create the moongate:
		moongate = UI_create_new_object(moongate_shape);
		
		//set moongate quality for destination:
		moongate->set_item_quality(quality);

		//Could not create moongate, so bail out:
		if (!moongate)
		{
			UI_error_message("Moongate aborted for some reason");
			return;
		}
		//Move the moongate to the target position:
		UI_update_last_created(target_coords);

		//Undoes the change made above, in preparation
		//to move the avatar to the right spot:
		if ((direction == NORTH) || (direction == SOUTH))
			target_coords[X] = (target_coords[X] - 2);
		else if ((direction == EAST) || (direction == WEST))
			target_coords[Y] = (target_coords[Y] - 2);
		else
		{
			target_coords[X] = (target_coords[X] - 1);
			target_coords[Y] = (target_coords[Y] - 1);
		}
		
		//Moongate music:
		UI_play_music(0x0033, 0);
		
		//Mark moongate as temporary, to avoid filling Britannia
		//with nonfunctional moongates: 
		moongate->set_item_flag(TEMPORARY);
		
		//Makes the moongate rise from the ground, animate for a while
		//then sink back to the ground and disappear:
		script moongate
		{
			frame 0;
			repeat 3 next frame;;
			repeat 6
			{
				repeat 6 next frame;;
				frame 4;
			};
			repeat 3 previous frame;;
			remove;
		}

		//Determine the distance between Avatar and moongate:
		distance = AVATAR->get_distance(moongate);

		
		//Make avatar face moongate.
	//	script AVATAR {face direction;};
		
		//Give a small delay to avatar. Only needed for moongates
		//created very close to the avatar:
		distance = 5 - distance;
		if (distance > 0) script AVATAR {wait distance;};
		
		//Get avatar position:
		avatar_pos = AVATAR->get_object_position();
		
		//Determine coord offset for avatar destination:
		if (!(direction in [EAST, WEST]))
		{
			UI_error_message("Destionation is in East / West");
			if ((target_coords[Y] < avatar_pos[Y])) coord_offset = 1;
			else coord_offset = -1;
			target_coords[Y] = (target_coords[Y] + coord_offset);
		}
		if (!(direction in [NORTH, SOUTH]))
		{
			UI_error_message("Destionation is in North / South");
			if ((target_coords[X] < avatar_pos[X])) coord_offset = 1;
			else coord_offset = -1;
			target_coords[X] = (target_coords[X] + coord_offset);
		}

	
		arrived_dest = UI_path_run_usecode(target_coords, Orb_of_the_Moons, moongate, PATH_SUCCESS);
		
		if (arrived_dest)
		{
			UI_error_message("arrived_dest is true");
			//UI_set_path_failure(function, itemref, eventid)
			//	Should the avatar not reach the destination, (say,
			//	because the player moved to somewhere else while
			//	the avatar was still walking), this will call
			//	function with event = eventid and item = itemref.
			UI_set_path_failure(Orb_of_the_Moons, moongate, PATH_FAILURE);
			
			//See if the orb is in party's possession:
			if (!(getOuterContainer(item) in UI_get_party_list()))
			{
				//... delete it from wherever it was...
				remove_item();
				
				//... and give it back to the avatar:
				UI_add_party_items(1, SHAPE_ORB, 0, 0, false);
			}
		}
		
		//Destination unreachable, close moongate:
		else
		{
			closeOrbMoongate(moongate);
			UI_error_message("arrived_dest is false");
		}

	}

	//The player interrupted the avatar before reaching the moongate:
	if (event == PATH_FAILURE)
	{
		UI_error_message("Path failure");
		//Sanity check: make sure we ARE talking about a moongate:
		if (isOrbMoongate(item))
		{
			//Close the moongate:
			closeOrbMoongate(item);
			
			//Make fun of the player:
			randomPartyBark(["@No, Avatar.@", "@Let thyself enter.@"]);
		}
	}
	
	//The avatar reached the moongate:
	else if (event == PATH_SUCCESS)
	{
		UI_error_message("Path success");
		//Make sure it IS a moongate...
		if (isOrbMoongate(item))
		{
			//Close the moongate:
			closeOrbMoongate(item);
			
		
			
			//Teleport avatar:
			enterMoongate(item);
		}
	}
}
