/*
 *	Copyright 2019 AgentOrangeGuy 
 *
 *	This program is free software: you can redistribute it and/or modify it under the terms
 *	of the GNU General Public License as published by the Free Software Foundation,
 *	either version 2 of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *	without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *	See the GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License along with this program.
 *	If not, see <http://www.gnu.org/licenses/>.
 */


void Anya object# (0x425) ()
{
	var party = UI_get_party_list();
	var player_name = getAvatarName();
	var polite_title = getPoliteTitle();
	var hour = UI_game_hour();
	var partynum = UI_get_array_size(party);
	var bark;
	var player_is_female;
	var greeting; //When addressing party as plural or singular
	var avatar_bark;
	var npc_bark;
	var time_of_day = timeFunction(hour);
	var schedule = UI_get_schedule_type(item); //gets current schedule
	var temp = schedule;
	var current_schedule = temp;
	
	const int MEAD_SELL_PRICE           = 4;
	const int ALE_SELL_PRICE            = 3;
	const int WINE_SELL_PRICE           = 6;

	const int MUTTON_SELL_PRICE        = 4;
	const int CAKE_SELL_PRICE           = 8;

	var food_drink_options =["nothing", "mead", "ale", "wine", "mutton", "cake"];
	var food_drink_frames = [FRAME_MEAD, FRAME_ALE, FRAME_WINE, FRAME_MUTTON, FRAME_CAKE];
	var prices = [4, 3, 6, 4, 8];

	var	initial_choice_question = "@Wouldst thou like ale, mead, wine, mutton, or perhaps a cake@";
	var	askIfInterested1 = "@That'll be "; //split into two to capture price
	var askIfInterested2 = " gold coins, okay?@";
	var ask_quantity = "@How many?@";
	var	cant_afford = "@I'm sorry, but you don't have enough gold.@";
	var	cant_hold = "@You haven't any room in your pack.@";
	var	saidNo = "@Anything else I can do for thee?@";
	var	success = "Anya gives you the "; 
	var success2 = "@I hope thou dost enjoy it!@";	
	var nothing = "@Very well. What else dost thou wish to speak about?@";
	
	//group together dialog options in array for cleaner look
	var dialog = [initial_choice_question, askIfInterested1, askIfInterested2, ask_quantity, cant_afford, cant_hold, saidNo, nothing, success, success2];




	
	//READ flag used to initiate conversations via TALK
	var started_talking = UI_get_item_flag(item, READ);

	if (player_is_female) //
	{
	//	noun = "  ";
	//	title = "madame";
	}
	else 
	{
	//	noun = " ";
	//	title = " ";
	}
	
	//determine single/plural greeting
	if (partynum > 1)
		greeting = "friends"; 
	else greeting = "friend"; //Avatar is solo
	


	if (event == DOUBLECLICK)
	{
	
		//Avatar and NPC greeting barks
		var av_1st_greet = "@Excuse me, miss..@";
		var npc_1st_greet = "@What can I do for you?@";
				
		var av_2nd_greet  = "@Hello again.@";
		var npc_2nd_greet = "@Welcome back, " + greeting + ".@";	
		
		//call convo script
		startConvo(item, av_1st_greet, npc_1st_greet, av_2nd_greet, npc_2nd_greet); 
	}
	
	if (started_talking)
	{
		if ((current_schedule != WAITER) && (hour < 6)) 
		{
			UI_error_message("Current schedule is, " + current_schedule);
			UI_error_message("Schedule is, " + schedule);
			UI_error_message("Hour is, " + hour);
			item.say("@I'm sorry, " + polite_title + ", but I've just an hour to myself today. I'll gladly talk with thee later.@");
			delayedBark(item, "Come back tomorrow..", 3);
			UI_run_schedule(item);
			return;
		}	
		
		if (!UI_get_item_flag(item, MET))
		{
			item.say("You see a buxom woman who looks hard working, yet contented.*");
			item.say("@Good " + time_of_day + ", " + polite_title + ", and welcome to the Blue Boar Tavern. Art thou here for business or pleasure?@");
			UI_set_item_flag(item, MET);
		}
		else 
			item.say("@Good " + time_of_day + ", " + polite_title + ", and welcome to the Blue Boar Tavern. Art thou here for business or pleasure?@");
		
		//standard conversation options
		var options = ["name", "job", "bye", "business", "pleasure"];
		
		if (gflags[ASKEDARIANAABOUTRUNE])	
			add("rune");
		

	/////////////////////////////////////////////////////////////////////
	//Main conversation thread
	//
	/////////////////////////////////////////////////////////////////////
		converse(options)
		{
			case "name"(remove): 
				say("@I am Anya.@*");

			case "job"(remove):
				say("@I run this tavern to support my family. The hours are long, but my husband offers what help he can.@");
				say("@We make enough to pay for my daughter's schooling, so 'tis all worthwhile.@");
				add(["family"]); 

			case "pleasure"(remove):
				say("@'Tis good to talk with thee again. Things have been slow around here since the gypsies left. Good! Perhaps thou might stay and talk with me a while, before I'm back about my work.@");
				add(["gypsies"]);

			case "gypsies"(remove):
				say("@They pass by Britain occasionally. I believe they travel on the King's Way.@");
				add(["King's Way"]);

			case "King's Way"(remove):
				say("@The King's Way is the oldest road in Britain.@");

			case "family"(remove):
				say("@My husband Matt, and my daughter Ariana.@");
				add(["Matt", "Ariana"]);

			case "Matt"(remove):
				say("@He had an accident as a child which left him deaf and dumb, but I love him all the same. I only wish he could hear our daughter play, just once. But 'twill ne'er come to pass. He lives in a world of eternal silence.@");
				if (!UI_set_item_flag(item, NAKED)) //Only gives this option if Avatar hasn't already said yes or no to Anya to prevent repeated karma loss/gain
					add(["wish"]);
		
			case "Ariana"(remove):
				say("@Ariana is the light of my life. Seems she had scarce learned to walk when she first showed a gift for music. She studies now with the bards at the Conservatory.@");
				add(["bards"]);

			case "wish"(remove):
				say("Her face brightens suddenly. @You have the look of one who practices the art of magic. Perhaps thou couldst find some spell that might restore my husband's hearing! I know 'tis a lot to ask, but wilt thou try?@"); 
				if (askYesNo())
				{
					say("@Oh, thank you, " + player_name + "!@");
					UI_set_item_flag(item, NAKED); //flag used to prevent repeated karma loss/gain
					addKarma(5);
				}
				else
				{
					say("Her look of hope changes to one of sorrow as she looks down at the floor to hide her embarrassment. @I'm sorry to have bothered thee,@ she says. @I'm sure thou hast more important things to do.@");
					UI_set_item_flag(item, NAKED); //flag used to prevent repeated karma loss/gain
					subtractKarma(5);
				}

			case "bards"(remove):
				say("@Bless their hearts for teaching her well. She'll be no tavern wench when she grows older.@*");
				say("@Perhaps she'll even be court musician to Lord British some day...@");

			case "mantra"(remove):
				say("@Thou shouldst ask my daughter of that. Methinks the bards have taught her of it.@");
				
			case "rune"(remove):
				if (!gflags[ASKED_PARENTS_PERMISSION])
				{
					say("@Ah, twas the proudest moment of my life when they awarded my dear little Ariana the Rune of Compassion. They said she was the most promising student they'd ever had at the Conservatory. I'm sure she would show thee the rune, if thou wouldst care to see it.@");
					say("@Thou dost wish to borrow the Rune of Compassion from my daughter?@ She pauses a while in thought.*");
					say("@Very well--thou dost have an honest face. I grant thee my permission.@");
					gflags[ASKED_PARENTS_PERMISSION] = true;
					
				}
				else
					say("@I already gave thee my permission to borrow the rune! Do thou be careful not to lose the stone or let any harm befall it. Ariana would never forgive herself.@");
				add(["mantra"]);


			case "business":
				sellFood(ANYA, food_drink_options, prices, food_drink_frames, dialog);
				
				
				
//TODO: add sidequest to cure Matt

			case "bye":
				say("@Well, 'tis time I was back about my work. Dishes to wash, food to cook, drinks to serve... I thank thee for stopping by to brighten my day with thy conversation. Do thou come again.@");
				var avatar_goodbye = "@Have a good " + time_of_day + "!@";
				var npc_goodbye = "@Come back anytime!@";
				
				//function that is called, do not change this:
				sayGoodbye(item, npc_goodbye, avatar_goodbye);
				break;
	
		}                               
	}
	else scheduleBarks(item);
}