/*
 *	Copyright 2019 AgentOrangeGuy 
 *
 *	This program is free software: you can redistribute it and/or modify it under the terms
 *	of the GNU General Public License as published by the Free Software Foundation,
 *	either version 2 of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *	without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *	See the GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License along with this program.
 *	If not, see <http://www.gnu.org/licenses/>.
 */


void Arty object# (0x428) ()
{

	var party = UI_get_party_list();
	var player_name = getAvatarName();
	var polite_title = getPoliteTitle();
	var hour = UI_game_hour();
	var partynum = UI_get_array_size(party);
	var bark;
	var player_is_female;
	var greeting; //When addressing party as plural or singular
	var avatar_bark;
	var npc_bark;
	var time_of_day = timeFunction(hour);
	var schedule = UI_get_schedule_type(item); //use for schedule specific convos
	var current_schedule = schedule; 
	
	//READ flag used to initiate conversations via TALK
	var started_talking = UI_get_item_flag(item, READ);
	
	//make sure it determines shop is open
	if (UI_get_schedule_type(item) == TEND_SHOP)
	{
		UI_set_item_flag(item, SHOP_IS_OPEN);
		UI_error_message("Shop is open");
	}
	
	//custom flag to determine if Arty is drinking or not (STAND). 
	var is_drinking = UI_get_item_flag(item, PETRA); 
		
	//this makes sure you can talk to them still if their shop is open (convo function turns it to TALK)
	var shop_is_open = UI_get_item_flag(item, SHOP_IS_OPEN);	
	
	
	
	const int FRAME_SILVER = 0;

	if (event == DOUBLECLICK)
	{
		//Avatar and NPC greeting barks
		var av_1st_greet = "@Excuse me..@";
		var npc_1st_greet = "@...@";
				
		var av_2nd_greet  = "@Greetings..@";
		var npc_2nd_greet = "@...@";	
		
		//call convo script
		startConvo(item, av_1st_greet, npc_1st_greet, av_2nd_greet, npc_2nd_greet); 
	}
	
	if (started_talking)
	{
		item.say("A silent but good-natured man.~");
		if (UI_get_schedule_type(item) == MAJOR_SIT)
			item.say("He looks up from his tankard of ale, sees you and smiles.");
		else 
			item.say("He grins widely and waves at you.");
		UI_clear_item_flag(item, READ);	
		UI_run_schedule(item);
				
		//standard conversation options
		var options = ["name", "job", "bye"];

	/////////////////////////////////////////////////////////////////////
	// Main conversation thread

	/////////////////////////////////////////////////////////////////////
		converse(options)
		{
			case "name"(remove):
				say("He points to his mouth and shakes his head.");
				if (isNearby(DUPRE))
				{
					DUPRE.say("@I know of this person, " + player_name + ". He is Arty the Mute, a local shipwright and an honored citizen.@");
					DUPRE.hide();
           			say("The man smiles and nods.");
				}
				add(["mute", "deaf"]);

			case "job":
				if (is_drinking)
					say("The man looks at you, puzzled. Then he raises his tankard and goes back to drinking.");
            		
				else
				{
					say("He smiles and points to the workbench. On the bench, you see the tools of a shipwright.");
					add(["buy"]); 
				}
			case "mute"(remove):
				say("Arty smiles and nods.");
				
			case "deaf"(remove):
				say("The man shakes his head.");
	
			case "buy"(remove):
				if (!shop_is_open)
					say("The man looks at you, puzzled. He shakes his head and spreads his hands as if to say @sorry.@");
				
				else 
				{
					say("The man smiles and points to the deed to a shipm and to a sextant.");
					add(["ship", "sextant"]);
				}
			case "ship"(remove):
				say("Arty shows you a ship deed. Written on it is the price, 400 gold. Do you want to buy the deed?");
					if(askYesNo())
					{
						if (hasGold(400))
						{
							if (UI_add_party_items(1, SHAPE_SCROLL, 44, 1, true))
							{
								chargeGold(400);
								say("After accepting the gold, Arty smiles and hands you the deed. He seems pleased.");

							}
							else say("You don't have enough room to carry the deed");
						}
						else say("You don't have enough gold for that.");
					}
					else say("Arty shrugs.");
					
			case "sextant"(remove):
				say("Arty shows you a sextant. Written on a piece of paper is the price, 20 gold. Do you want to buy the deed?");					
					if(askYesNo())
					{
						if (hasGold(20))
						{
							if (UI_add_party_items(1, SHAPE_SEXTANT, QUALITY_ANY, FRAME_SILVER, true))
							{
								chargeGold(20);
								say("After accepting the gold, Arty smiles and hands you the sextant. He seems pleased.");

							}
							else say("You don't have enough room to carry the sextant");
						}
						else say("You don't have enough gold for that.");
					}
					else say("Arty shrugs.");
				
				
				
				
			case "bye":
				if (is_drinking)
					item.say("Arty waves as you leave, then returns to his ale."); 
         				
				else	
			       item.say("Arty waves as you leave, then returns to what he was doing.");
			     

				var avatar_goodbye = "@Goodbye, Arty!@";
				var npc_goodbye = "@...@";
				
				//function that is called, do not change this:
				sayGoodbye(item, npc_goodbye, avatar_goodbye);
				UI_run_schedule(item);
				UI_clear_item_flag(item, PETRA); // to reset "is drinking"
				break;
		}                               
	}
	else scheduleBarks(item);
}