
void Cullen object# (0x434) ()
{

	var party = UI_get_party_list();
	var player_name = getAvatarName();
	var polite_title = getPoliteTitle();
	var hour = UI_game_hour();
	var partynum = UI_get_array_size(party);
	var bark;
	var barks;
	var player_is_female;
	var greeting; //When addressing party as plural or singular
	var avatar_bark;
	var npc_bark;
	var time_of_day = timeFunction(hour);
	var schedule = UI_get_schedule_type(item); //use for schedule specific convos
	var current_schedule = schedule; 
	
	const int BREAD_SELL_PRICE = 3;
	const int CAKE_SELL_PRICE = 5;
	const int ROLLS_SELL_PRICE = 1;
	const int FLOUR_BUY_PRICE = 5;
	const int PASTRY_SELL_PRICE = 6;
	
	//READ flag used to initiate conversations via TALK
	var started_talking = UI_get_item_flag(item, READ);
	
	//determine single/plural greeting
	if (partynum > 1)
		greeting = "friends"; 
	else greeting = "friend"; //Avatar is solo
	
	
	if ((event == PROXIMITY) && (UI_get_schedule_type(item, BAKE)))
	{
		barks = UI_get_random(3);
		if (barks == 1)
			delayedBark(item, "@Bread fit for a king!@", 0);
		else if (barks == 2)
			delayedBark(item, "@Delicious pastries here!@", 0);
		else
			delayedBark(item, "@Mouthwatering rolls!@", 0);
	}
	

	if (event == DOUBLECLICK)
	{
		//Avatar and NPC greeting barks
		var av_1st_greet = "@Greetings..@";
		var npc_1st_greet = "@Ah, welcome!@";
				
		var av_2nd_greet  = "@Hello again..@";
		var npc_2nd_greet = "@Ah, welcome back!@";	
		
		//call convo script
		startConvo(item, av_1st_greet, npc_1st_greet, av_2nd_greet, npc_2nd_greet); 
	}
	
	if (started_talking)
	{
		//reset schedule for after convo
		UI_run_schedule(item);
		
		if (!UI_get_item_flag(item, MET))
		{
			item.say("You see a short, dark man, covered in white flour.");
 			item.say("@Hello again my " + greeting + "!@ As he shakes your hand enthusiastically, clouds of flour fly off his clothes.");
			UI_set_item_flag(item, MET);
		}
		else 
		{
			item.say("You see a short, dark man, covered in white flour.");
 			item.say("@Hello again my " + greeting + "!@ As he shakes your hand enthusiastically, clouds of flour fly off his clothes.");
		}
		//standard conversation options
		var options = ["name", "job", "bye"];


	/////////////////////////////////////////////////////////////////////
	// Main conversation thread

	/////////////////////////////////////////////////////////////////////
		converse(options)
		{
			case "name":
				say("@I'm Cullen, Cullen the Baker.@");
				add(["baker"]);

			case "job":
				say("@I'd have thought that'd be obvious! I'm a baker!@ As he laughs heartily, more clouds of flour rise off his clothing.*");
				say("@You can buy bakery goods from me or perhaps you have some flour to sell, eh?@");
  				add(["baker", "buy", "sell"]); 

			case "baker"(remove):
				say("@I bake goods for Lord British himself!@ the man says proudly. @If you'd like to buy some, just say the word!@");

			case "sell" (remove):
			if (UI_get_schedule_type(item) != BAKE)
				say("@Come to my shop when it's open!@");
			else 
			{
				
				var sack1 = UI_count_objects(PARTY, SHAPE_KITCHEN_ITEMS, QUALITY_ANY, FRAME_UNOPENED_SACK);
				var sack2 = UI_count_objects(PARTY, SHAPE_KITCHEN_ITEMS, QUALITY_ANY, FRAME_FLOUR);
				var party_flour = sack1 + sack2;
				if (party_flour > 0)
				{
					say("@Will you take 5 gold for that sack of flour?@");
					if (askYesNo())
					{
						say("@Done!@ He hands you 5 gold pieces and takes the sack of flour.@");
						if (sack1 >= 1)
							UI_remove_party_items(1, SHAPE_KITCHEN_ITEMS, QUALITY_ANY, FRAME_UNOPENED_SACK, true);
						else
							UI_remove_party_items(1, SHAPE_KITCHEN_ITEMS, QUALITY_ANY, FRAME_FLOUR, true);
						UI_add_party_items(5, SHAPE_GOLD, QUALITY_ANY, FRAME_ANY, true);
					}
					else say ("@Changed your mind, eh?@ he folds his arms. @Well, what else will it be then?@");
				}
				else say("@Sorry, you haven't any flour.@");
			}	

		//For shopkeepers: 
			case "buy"(remove):
				if (UI_get_schedule_type(item) != BAKE)
					say("@Come to my shop when it's open!@");
				else
				{
					say("@Which item?@");
					//shopkeeper options
					var choice;
					var cant_hold = "@But thou canst not carry any " + choice + "!@";
					
					var cant_afford = "@I'm sorry, but you don't have enough gold.@";
					var success = "@Here's thy " + choice + ", " + player_name + ", plus one for luck!@";
					var askIfInterested; //"Do you want this 
					var saidNo = "Suit thyself, " + polite_title + ", but thou'lt find no better!@";
					var quantity; 
					
					if (askYesNo())
					{
						say("@Which item?@");
						choice = chooseFromMenu(["bread", "rolls", "cake", "pastry", "nothing"]);
						
						if (choice == "bread")
						{
							askIfInterested = "@Those cost " + BREAD_SELL_PRICE + " gold each. How many do you want, " + polite_title + "?@";
							quantity = UI_input_numeric_value(1, 100, 1, 1);
							while (quantity > 50)
							{
								say("@Whoa! Don't buy out my entire stock!@");
								say("@How many do you want, " + polite_title + "?@");
								quantity = UI_input_numeric_value(1, 100, 1, 1);
							}
							basicSell(item, SHAPE_FOOD, quantity, QUALITY_ANY, FRAME_BREAD, BREAD_SELL_PRICE, cant_hold, cant_afford, success, askIfInterested, saidNo);
						}
						else if (choice == "rolls")
						{
							askIfInterested = "@Those cost " + ROLLS_SELL_PRICE + " gold each. How many do you want, " + polite_title + "?@";
							quantity = UI_input_numeric_value(1, 100, 1, 1);
							while (quantity > 50)
							{
								say("@Whoa! Don't buy out my entire stock!@");
								say("@How many do you want, " + polite_title + "?@");
								quantity = UI_input_numeric_value(1, 100, 1, 1);
							}
							basicSell(item, SHAPE_FOOD, quantity, QUALITY_ANY, FRAME_ROLLS, ROLLS_SELL_PRICE, cant_hold, cant_afford, success, askIfInterested, saidNo);
						}
						
						else if (choice == "cake")
						{
							askIfInterested = "@Those cost " + CAKE_SELL_PRICE + " gold each. How many _do you want, " + polite_title + "?@";
							quantity = UI_input_numeric_value(1, 100, 1, 1);
							while (quantity > 50)
							{
								say("@Whoa! Don't buy out my entire stock!@");
								say("@How many do you want, " + polite_title + "?@");
								quantity = UI_input_numeric_value(1, 100, 1, 1);
							}
							basicSell(item, SHAPE_FOOD, quantity, QUALITY_ANY, FRAME_CAKE, CAKE_SELL_PRICE, cant_hold, cant_afford, success, askIfInterested, saidNo);
						}
						
						else if (choice == "pastry")
						{
							askIfInterested = "@Ah, my specialty! Those cost " + PASTRY_SELL_PRICE + " gold each. How many do you want, " + polite_title + "?@";
							quantity = UI_input_numeric_value(1, 100, 1, 1);
							while (quantity > 50)
							{
								say("@Whoa! Don't buy out my entire stock!@");
								say("@How many do you want, " + polite_title + "?@");
								quantity = UI_input_numeric_value(1, 100, 1, 1);
							}
							basicSell(item, SHAPE_FOOD, quantity, QUALITY_ANY, FRAME_PASTRY, PASTRY_SELL_PRICE, cant_hold, cant_afford, success, askIfInterested, saidNo);
						}
						else if (choice == "nothing")
							say("@How about something else, " + polite_title + "?@");
								
					}
					else
						say("@Perhaps some other time, then.@");	

				}
	
			case "bye":
				
				var avatar_goodbye = "@Farewell..@";
				var npc_goodbye = "@Come again soon!@";
				
				//function that is called, do not change this:
				sayGoodbye(item, npc_goodbye, avatar_goodbye);
				break;
	
		}                               
	}
	else scheduleBarks(item);
}