/*
 *	Copyright 2019 AgentOrangeGuy 
 *
 *	This program is free software: you can redistribute it and/or modify it under the terms
 *	of the GNU General Public License as published by the Free Software Foundation,
 *	either version 2 of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *	without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *	See the GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License along with this program.
 *	If not, see <http://www.gnu.org/licenses/>.
 */


void Daver object# (0x41f)()
{

	var party = UI_get_party_list();
	var player_name = getAvatarName();
	var polite_title = getPoliteTitle();
	var hour = UI_game_hour();
	var partynum = UI_get_array_size(party);
	var bark;
	var player_is_female;
	var greeting; //When addressing party as plural or singular
	var avatar_bark;
	var npc_bark;
	var time_of_day = timeFunction(hour);
	var schedule = UI_get_schedule_type(item); //use for schedule specific convos
	var current_schedule = schedule; 
	
	//READ flag used to initiate conversations via TALK
	var started_talking = UI_get_item_flag(item, READ);

	if (event == DOUBLECLICK)
	{
		//Avatar and NPC greeting barks
		var av_1st_greet = "@Greetings..@";
		var npc_1st_greet = "@Hello.@";
				
		var av_2nd_greet  = "@Greetings..@";
		var npc_2nd_greet = "@Hello again.@";	
		
		//call convo script
		startConvo(item, av_1st_greet, npc_1st_greet, av_2nd_greet, npc_2nd_greet); 
	}
	
	if (started_talking)
	{
		item.say("A man wearing a long grey cloak. He wears gloves with the fingers cut off, and carries a large hourglass with him.");
		item.say("@Good " + time_of_day + ", friend Avatar.@");
		
		//standard conversation options
		var options = ["name", "job", "bye"];

	/////////////////////////////////////////////////////////////////////
	// Main conversation thread

	/////////////////////////////////////////////////////////////////////
		converse(options)
		{
			case "name"(remove):
				say("@I'm Daver McCord.@");

			case "job":
				say("@Every hour of the day, I ring the bell a number of times.@");
  				add(["bell"]); 

			case "bell"(remove):
				say("@According to the numbers on the hourglass, you see.@");
				add(["numbers"]);

			case "numbers"(remove):
				say("@Well, I usually know what time it is up here in my head somehow. But just in case, I start this hourglass at sunup, turning it over every nine hours.@");
				add(["time"]);

			case "time"(remove):
				say("@It is especially important for those with shops. They know when to open for business, eat lunch, close, and that sort of thing.@");
				say("@Another of Lord British's innovations, this bell thing.@");
				add(["business"]);

			case "business"(remove):
				say("@Hmmm. I guess that you don't keep a regular schedule, being the Avatar and all. Probably out till all hours, collecting runes and such.@");
				add(["Avatar", "runes"]);

			case "Avatar"(remove):
				say("@You look much taller in person. Woodroffe's painting does not do you justice.@");
				add(["justice"]);

			case "justice"(remove):
				say("@Heh, heh. I know little of that. I'm just the bell-ringer.@");

			case "runes"(remove):
				say("@Magical little things. There's a symbol on one side, and a letter on the other.@");
				say("@Probably spell something out if you put 'em all on a necklace. But that hasn't been done for a long time.@");
				say("@After the Codex of Ultimate Wisdom was brought back from the underworld, Lord British gave the runes to the lords of the eight cities.@");
				add(["Lord British"]);

			case "Lord British"(remove):
				say("@Lord British appointed lords to rule the eight cities.@");
				add(["cities"]);

			case "cities"(remove):
				say("@Let's see now.@ He counts them off on his fingers. @Minoc, Trinsic, Jhelom, Yew, Skara Brae, Britain, Moonglow...@");
				say("@...Ah yes, and New Magincia. I hear each of the lords knows a mantra.@");
				add(["mantra"]);

			case "mantra"(remove):
				say("@Haven't the foggiest what those are for. Something to do with the shrines, I think.@");
				add(["shrines"]);

			case "shrines"(remove):
				say("@Always wanted to visit them. Never had the time.@");
				say("@Heh, heh, heh!@");
								
			case "bye":
								
				var avatar_goodbye = "@Farewell..@";
				var npc_goodbye = "@Until we meet again..@";
				
				//function that is called, do not change this:
				sayGoodbye(item, npc_goodbye, avatar_goodbye);
				break;
	
		}                               
	}
	else scheduleBarks(item);
}