
void Efram object# (0x426) ()
{

	var party = UI_get_party_list();
	var player_name = getAvatarName();
	var polite_title = getPoliteTitle();
	var hour = UI_game_hour();
	var partynum = UI_get_array_size(party);
	var bark;
	var player_is_female;
	var greeting; //When addressing party as plural or singular
	var avatar_bark;
	var npc_bark;
	var time_of_day = timeFunction(hour);
	var schedule = UI_get_schedule_type(item); //use for schedule specific convos
	var current_schedule = schedule; 
	
	//READ flag used to initiate conversations via TALK
	var started_talking = UI_get_item_flag(item, READ);

	const int TORCH_SELL_PRICE = 3;
	const int OIL_SELL_PRICE = 4;
	const int BEDROLL_SELL_PRICE = 40;
	const int BACKPACK_SELL_PRICE = 10;
	const int BAG_SELL_PRICE = 3;
	const int SHOVEL_SELL_PRICE = 15;
	const int POWDER_KEG_SELL_PRICE = 30;
	const int ABACUS_SELL_PRICE = 50;
	
	if (UI_get_schedule_type(item) == TEND_SHOP)
	{
		UI_set_item_flag(item, SHOP_IS_OPEN);
		UI_error_message("Shop is open");
	}
	
	
	//this makes sure you can talk to them still if their shop is open (convo function turns it to TALK)
	var shop_is_open = UI_get_item_flag(item, SHOP_IS_OPEN);
	
	
	
	//shopkeeper stuff
	
	var price;
	var item_choice;
	var item_options = ["nothing", "torch", "oil", "backpack", "bag", "shovel", "powder keg", "abacus"];
	var item_shapes = [SHAPE_TORCH, SHAPE_OIL, SHAPE_BACKPACK, SHAPE_BAG, SHAPE_SHOVEL, SHAPE_POWDER_KEG, SHAPE_DESK_ITEM];
	var item_prices = [TORCH_SELL_PRICE, OIL_SELL_PRICE, BACKPACK_SELL_PRICE, BAG_SELL_PRICE, SHOVEL_SELL_PRICE, POWDER_KEG_SELL_PRICE, ABACUS_SELL_PRICE]; 

		
	var item_frames = [0, 0, 0, 0, 0, 0, 0, FRAME_ABACUS];
	//
	
			
	//Dialog options
	var initial_choice_question = "@Which of these?@"; //arms or armor? etc
	var ask_quantity = "@How many do you want?@";
	var askIfInterested1 = "@It'll cost you "; //needs to be split into array to capture price
	var askIfInterested2 = " gold for each.@";
	var cant_afford = "Efram looks at you. @That costs more than you have.@"; 
	var cant_hold = "Efram looks at you. @You haven't any room in your pack.@";
	var saidNo = "Efram frowns at you. @Hrmmph. That was a fair price. Well...@";
	var nothing = "@@Anything else?@";
	var success = "@He hands you the ";
	var success2 = ". There ya go.@";
	
	
	
	
	//group together dialog options in array for cleaner look
	
	var dialog = [initial_choice_question, askIfInterested1, askIfInterested2, ask_quantity, cant_afford, cant_hold, saidNo, nothing, success, success2];	
	
	
	if (event == PROXIMITY)
	{
		if (UI_get_schedule_type(item) == TEND_SHOP)
		{
			//reorganized to make it easier to add barks
			var barks = [
				"@Torches? Backpacks? Shovels?@",
				"@Get thy powder kegs here!@",
				"@Hrmmph..Where is my pipe tobacco?@",
				"@Provisions here!@"
			];

			var rand = UI_get_random(UI_get_array_size(barks));
			UI_item_say(item, barks[rand]);
		}
		//Otherwise, say generic NPC barks
		else scheduleBarks(item);
	}
	

	if (event == DOUBLECLICK)
	{
		//Avatar and NPC greeting barks
		var av_1st_greet = "@Greetings, milord.@";
		var npc_1st_greet = "@Hrmph, hello.@";
				
		var av_2nd_greet  = "@Hello there.@";
		var npc_2nd_greet = "@Hrmph, hello.@";	
		
		//call convo script
		startConvo(item, av_1st_greet, npc_1st_greet, av_2nd_greet, npc_2nd_greet); 
	}
	
	if (started_talking)
	{
		//reset schedule for after convo
		UI_run_schedule(item);
		
		if (!UI_get_item_flag(item, MET))
		{
			item.say("You see a grunting and grumbling man with a large stomach.");
			item.say("@Hrmmph. Hello.@ His breathing is quite heavy.");
			UI_set_item_flag(item, MET);
		}
		else 
			item.say("@Hrmmph, well. Haven't we...never mind. Hrmmph. What do you need?@");
		
		//standard conversation options
		var options = ["name", "job", "bye"];

		//automatically add buy/sell to options next time
		if (UI_get_item_flag(item, SHOPPED_BEFORE))
			add("buy provisions");
		
	
	/////////////////////////////////////////////////////////////////////
	// Main conversation thread

	/////////////////////////////////////////////////////////////////////
		converse(options)
		{
			case "name":
				say("@Efram the provisioner.@");
				add(["Efram"]);

			case "job":
				say("@I sell torches, oil, gems, backpacks, bags, shovels, and powder kegs.@");
				//automatically add buy/sell to options next time
				if (!UI_get_item_flag(item, SHOPPED_BEFORE))
					UI_set_item_flag(item, SHOPPED_BEFORE);
  				add(["buy provisions"]); 

			case "Efram"(remove):
				say("@It's a nice enough name, hrmmph.@");

			//For shopkeepers: 
			case "buy provisions"(remove):
				if (shop_is_open)
				{
					say("@Are you interested in buying provisions today?@");
					if (askYesNo())
					{
						buyItems(EFRAM, item_options, item_prices, item_shapes, item_frames, dialog);
					}
					else
						say("@Very well. What else dost thou wish to speak about?@");	
				}
				else 
					say("@Come back to my shop when it's open.@");

			case "bye":
				
				var avatar_goodbye = "@Farewell..@";
				var npc_goodbye = "@I'm glad you stopped by.@";
				
				//function that is called, do not change this:
				sayGoodbye(item, npc_goodbye, avatar_goodbye);
				break;
	
		}                               
	}
	else scheduleBarks(item);
}