/*
 *	Copyright 2019 AgentOrangeGuy 
 *
 *	This program is free software: you can redistribute it and/or modify it under the terms
 *	of the GNU General Public License as published by the Free Software Foundation,
 *	either version 2 of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *	without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *	See the GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License along with this program.
 *	If not, see <http://www.gnu.org/licenses/>.
 */


void Tholden object# (0x42b) ()
{

	var party = UI_get_party_list();
	var player_name = getAvatarName();
	var polite_title = getPoliteTitle();
	var hour = UI_game_hour();
	var partynum = UI_get_array_size(party);
	var barks;  //for proximity
	var player_is_female;
	var greeting; //When addressing party as plural or singular
	var avatar_bark;
	var npc_bark;
	var time_of_day = timeFunction(hour);
	var schedule = UI_get_schedule_type(item); //use for schedule specific convos
		
	//READ flag used to initiate conversations via TALK
	var started_talking = UI_get_item_flag(item, READ);

	if (player_is_female) //
	{
	//	noun = "  ";
	//	title = "madame";
	}
	else 
	{
	//	noun = " ";
	//	title = " ";
	}
	
	//determine single/plural greeting
	if (partynum > 1)
		greeting = "friends"; 
	else greeting = "friend"; //Avatar is solo
	
	
	if ((event == PROXIMITY) && (schedule == DESK_WORK))
	{
		var rand = UI_get_random(3);
		if (rand == 1)
			delayedBark(item, "@Busy, busy busy..@", 0);
		else if (barks == 2)
			delayedBark(item, "@Now where did I put mine pen?@", 0);
		else
			delayedBark(item, "@So much to do..@", 0);
	}
		

	if (event == DOUBLECLICK)
	{
		//Avatar and NPC greeting barks
		var av_1st_greet = "@Excuse me, milord..@";
		var npc_1st_greet = "@Ah... yes?@";
				
		var av_2nd_greet  = "@Might we speek again?@";
		var npc_2nd_greet = "@Of course..@";	
		
		//call convo script
		startConvo(item, av_1st_greet, npc_1st_greet, av_2nd_greet, npc_2nd_greet); 
	}
	
	if (started_talking)
	{
		
		item.say("A preoccupied man holding a ledger under one arm.*");
		item.say("@Records to keep, festivals to plan, I'm so busy...@");
		item.say("@But I can spare you a moment, " + polite_title + ".");
		
		//standard conversation options
		var options = ["name", "job", "bye"];

	/////////////////////////////////////////////////////////////////////
	//Main conversation thread

	/////////////////////////////////////////////////////////////////////
		converse(options)
		{
			case "name"(remove):
				say("@I am Tholden von Bazillius, Chancellor to Lord British. In my younger days, I was known as 'The Werecat of the Wine Cellar'...@");
				add(["'Werecat'", "rune"]);

			case "job"(remove):
				say("@All the little details of governing, all the paperwork falls on my shoulders.@*");
				say("@Someone must do it, and yet I miss the days when I was a carefree adventurer.@");

			case "rune"(remove):
				if (!gflags[ASKED_THOLDEN_ABOUT_RUNE])
				{ 
					if (!UI_get_item_flag(ARIANA, SI_ZOMBIE))
						UI_set_item_flag(ARIANA, SI_ZOMBIE); //can now ask Ariana about rune
					gflags[ASKED_THOLDEN_ABOUT_RUNE] = true;
					giveExperience(15);
				}
				say("@The rune and mantra of Compassion are in the keeping of the bards at the Conservatory. I entrusted them with the rune due to their compassionate nature.@*");
				say("@As for the other runes - they are no longer together, as they were when the Codex was recovered. Since then, they have become scattered throughout the land. Each was sent to a town near its shrine. If thou dost ask the lords of each of these towns, they should be able to tell thee more.@*");
				say("@The towns are Moonglow, Jhelom, Yew, Minoc, Trinsic, Skara Brae, and New Magincia.@");
				add(["Codex", "Conservatory"]);
		
			case "Codex"(remove):
				say("@'Tis the greatest treasure in all the realm.@");

			case "Conservatory"(remove):
				say("@'Twas founded by Lord British.@");

			case "'Werecat'"(remove):
				say("@I could tell you stories... But there's no time for that now.@");

			case "bye":
				say("Tholden bows deeply. @I hope I have been of assistance, Avatar.@");
				
				var avatar_goodbye = "@So long..@";
				var npc_goodbye = "@Safe journeys, Avatar.@";
				
				//function that is called, do not change this:
				sayGoodbye(item, npc_goodbye, avatar_goodbye);
				break;
	
		}                               
	}
	else scheduleBarks(item);
}