/*
 *	Copyright 2019 AgentOrangeGuy 
 *
 *	This program is free software: you can redistribute it and/or modify it under the terms
 *	of the GNU General Public License as published by the Free Software Foundation,
 *	either version 2 of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *	without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *	See the GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License along with this program.
 *	If not, see <http://www.gnu.org/licenses/>.
 */


void Chuckles object# (0x437) ()
{

	var party = UI_get_party_list();
	var player_name = getAvatarName();
	var polite_title = getPoliteTitle();
	var hour = UI_game_hour();
	var partynum = UI_get_array_size(party);
	var bark;
	var player_is_female;
	var greeting; //When addressing party as plural or singular
	var avatar_bark;
	var npc_bark;
	var time_of_day = timeFunction(hour);
	var schedule = UI_get_schedule_type(item); //use for schedule specific convos
	var current_schedule = schedule; 
	
	var avatar_goodbye;
	var npc_goodbye;
	
	//READ flag used to initiate conversations via TALK
	var started_talking = UI_get_item_flag(item, READ);

	if (player_is_female) //
	{
	//	noun = "  ";
	//	title = "madame";
	}
	else 
	{
	//	noun = " ";
	//	title = " ";
	}
	
	//determine single/plural greeting
	if (partynum > 1)
		greeting = "friends"; 
	else greeting = "friend"; //Avatar is solo
	
	//barks for proximity and dance schedule
	if (event == PROXIMITY && current_schedule == DANCE)
	{
		var barks = UI_get_random(3);
		if (gflags[TATTLED_ON_CHUCKLES]) //angry barks!
		{
			if (barks == 1)
				delayedBark(item, "@Go away!@", 1);
			else if (barks == 2)
				delayedBark(item, "@Tattle-tale!@", 1);
			else if (barks == 3)
				delayedBark(item, "@Thou art not welcome here, Avatar!@", 1);
			else
				delayedBark(item, "@Thou art mongbat dung!@", 1);			
		}
		else
		{
			if (barks == 1)
				delayedBark(item, "@Avatar, I have a clue!@", 1);
			else if (barks == 2)
				delayedBark(item, "@Ho eyo he hum!@", 1);
			else if (barks == 3)
				delayedBark(item, "@Woulds thou like to hear a joke?@", 1);
			else
				delayedBark(item, "@Ho ho, hee hee@", 1);			
		
		}
		
	}
	
	if (event == SCRIPTED)
	{
		if (gflags[CHUCKLES_KILLED])
		{
			UI_remove_party_items(5, SHAPE_RUSTY_CUTLASS, QUALITY_ANY, FRAME_ANY);
			UI_play_sound_effect(37); //breaking
			
			UI_clear_item_flag(AVATAR, BG_DONT_MOVE);
			
			DRUDGEWORTH.say("@I knew ye had it in ye, Avatar! Now, take his wretched remains to be cremated, lest his spirit be reunited with his body.@");
			DRUDGEWORTH.say("@When I am guaranteed eternal torment of Chuckles' soul, then I shall reward ye handsomely! Bring his ashes back to my hut and I will bequeath thee a great treasure..@");
			DRUDGEWORTH.say("@Now, make haste!@");
			DRUDGEWORTH.hide();
			
			UI_item_say(AVATAR, "The cutlass disentegrated..");
			var mirror = UI_find_object(FIND_ON_SCREEN, SHAPE_MIRROR, QUALITY_ANY, FRAME_ANY);
			var ghost = UI_find_object(FIND_ON_SCREEN, SHAPE_GHOST, QUALITY_ANY, FRAME_ANY);
			
			
			
			script mirror after 3 ticks
			{
				frame 2;
				wait 1; 
				sfx 37;
			
			}
			
			UI_sprite_effect(ghost, 7, 0, 0, 0, 0, 0, -1);
			UI_remove_item(ghost);
			
		}
		else
		{
	
	
			//get avatar's position
			var avatarpos = UI_get_object_position(AVATAR);
			
			//dont move
			UI_set_item_flag(AVATAR, BG_DONT_MOVE);
			
			//find ghost pixel
			var ghost = UI_find_object(FIND_ON_SCREEN, SHAPE_GHOST, QUALITY_ANY, 7); //find frame 7
			
			
			//check if Drudgeworth's sword is in hand
			if (!UI_is_readied(AVATAR, BG_WEAPON_HAND, SHAPE_RUSTY_CUTLASS, FRAME_ANY))
			{
				//search party for sword in party
				var cutlass = UI_find_object(PARTY, SHAPE_RUSTY_CUTLASS, QUALITY_ANY, FRAME_ANY);
				
				//cutlass found in party, move to Avatar
				if (cutlass)
				{
					var carrying = UI_get_readied(AVATAR, BG_WEAPON_HAND, SHAPE_ANY, FRAME_ANY);
					
					//if avatar is carrying an item, drop it at feet
					if (carrying)
						UI_move_object(carrying, [avatarpos], true);
						
					//remove old cutlass, repopulate
					UI_remove_item(cutlass);
					
					
				
				}
				
				//if cutlass is on screen, delete.
				var cutlass_on_screen = UI_find_object(FIND_ON_SCREEN, SHAPE_RUSTY_CUTLASS, QUALITY_ANY, FRAME_ANY);
				if (cutlass_on_screen)
					UI_remove_item(cutlass_on_screen);
				
				//repopulate cutlass
				UI_add_cont_items(AVATAR, 1, SHAPE_RUSTY_CUTLASS, QUALITY_ANY, FRAME_ANY, true);
			}
			
			//Drudgeworth's sword
			var sword = UI_get_readied(AVATAR, BG_WEAPON_HAND);
			
			
			CHUCKLES.say("@I am here as thou has requested, in front of the mirror. For a second, looking into it I could have sworn I saw...nevermind...couldn't be...@");
			CHUCKLES.say("@So what would you have me do? Avatar, I beg thee... I'll do anything... just please keep mine secret!@");
			AVATAR.say("You clutch Drudgeworth's cutlass and it's almost as if all of his rage overtakes you, clouding your own thoughts as you approach Chuckles.");
			AVATAR.say("@Drudgeworth sends his regards...@, you calmly speak as you plunge the cutlass into Chuckles' belly. His eyes are sheer terror as he coughs up blood and collapses before you.");
			subtractKarma(25);
			CHUCKLES.hide();
			AVATAR.hide();
			
			
			
			
			script AVATAR after 5 ticks
			{
				face north;
				actor frame SWING_1;
				wait 2;
				actor frame SWING_2;
				wait 2; 
				actor frame SWING_3;
				wait 20;
				call (Chuckles);
				
			
			
			};
			
			script CHUCKLES after 9 ticks
			{
				say "NOOOOOO!";
				wait 5; 
				hit 25, NORMAL_DAMAGE; 
				wait 2; 
				sfx 37;
			
			
			};
			
			script sword after 10 ticks
			{
				wait 10;
				sfx 37;
				remove;
			
			}
			
			script ghost after 11 ticks
			{
				frame 19; 
				wait 1;
				frame 20; 
				wait 1; 
				frame 21; 
				wait 1;
				frame 22; 
				wait 1; 
				sfx 65; 
			
			}
			
			
			gflags[CHUCKLES_KILLED] = true;
			
			return;
		}
		UI_error_message("Chuckles script called, shouldn't be?");
		return;
	}

	if (event == DOUBLECLICK)
	{
		if (gflags[TATTLED_ON_CHUCKLES])
		{
			item.say("@I don't want to talk to thee anymore, tattle-tale! Go away!@");
			sayGoodbyeAbrupt(item, "Go away!");
			return;
		
		
		}
	
	
	
	
		if (gflags[CHUCKLES_WAITS] && UI_get_item_flag(CHUCKLES, SI_ZOMBIE) && UI_get_schedule_type(CHUCKLES, WAIT))
		{
			//Chuckles should be by mirror
			UI_path_run_usecode([1200, 1254, 0], Chuckles, CHUCKLES, SCRIPTED, false); //should move Avatar to spot
		
			return;
		}
	
	
	//	if (gflags[CHUCKLES_WAITS] && 
		//Avatar and NPC greeting barks
		var av_1st_greet = "@Um... hello Chuckles..";
		var npc_1st_greet = "@Ho eyo he hum! Care for a joke?@";
				
		var av_2nd_greet  = "@Chuckles...@";
		var npc_2nd_greet = "@Avatar, thou hast returned for mine jokes!@";	
		
		//call convo script
		startConvo(item, av_1st_greet, npc_1st_greet, av_2nd_greet, npc_2nd_greet); 
	}
	
	if (started_talking)
	{
		item.say("A carefree fellow in a ludicrous costume.");
		item.say("@Ho eyo he hum, I've got a clue! It's important, and just for you!@");

		//standard conversation options
		var options = ["name", "job", "bye", "clue"];
		

		//Variable conversation options based on global flags or people met. Remove if none/////	
		if (gflags[READ_LEAFLET])
			add("Drudgeworth");
			
		if (gflags[HELP_DRUDGEWORTH]) //opens up Lucy convo when you agree to help Drudgeworth
			add("Lucy");			
		
		if (UI_count_objects(PARTY, SHAPE_SCROLL, QUALITY_LEAFLET, FRAME_ANY) > 0)
			add("leaflet");


	/////////////////////////////////////////////////////////////////////
	// Main conversation thread

	/////////////////////////////////////////////////////////////////////
		converse(options)
		{
		    case "name"(remove):
				say("@Why, I'm Chuckles the jester, of course! You've heard of me haven't you? Sure you have!@");
				add(["heard"]);
			 
		    case "heard"(remove): 
				say("@You've heard a word? Why that's absurd!@");
				add(["absurd"]);
		  
		    case "job" (remove):
				say("@To jape, to jeer, to prance, to frolic! To keep this place unmelancholic!@");
				say("@I practice tomfoolery for Lord British - or anyone else who passes too close.@");
				add(["jape", "tomfoolery", "Lord British"]);
		  
		    case "jape" (remove):
				say("@And jeer!@");
				add(["jeer"]);

        	case "jeer" (remove):
			    say("@And prance! To dance a Corybantic dance!@");
			    add(["prance"]);
		  
		    case "prance" (remove):
				say("@Jeer and prance! Prance and frolic!@");
				add(["frolic"]);
		  
		    case "frolic" (remove):
				say("@I lurch 'round like an alcoholic!@");
		 
		    case "tomfoolery" (remove):
				say("@'Cause Dick and Harry both called in sick.@");
	 
		    case "Lord British" (remove):
				say("@Call him Mr. Nose... But don't tell him I said so!@");
				add(["Mr. Nose"]);

		    case "Mr. Nose" (remove):
				say("@Shhh! Don't let him know I told you!@");
				gflags[MR_NOSE] = true;
		  
		    case "clue" (remove):
			    say("@Yes, it's crucial to your quest. Do you want to know what it is?@");
					if(askYesNo())
					{
						say("@Perhaps I don't want to tell you!@");
						UI_run_schedule(item);
						UI_clear_item_flag(item, READ);
						sayGoodbye2(item);
						break;
					}
					else
					{
						say("@Perhaps I'll tell you anyway!  Do you think I will?@");
						if(askYesNo())
						{
							say("@How foolish of you to think so!@");
						}
						else 
						{
							say("@Congratulations! You're exactly right!  I won't tell you the clue.....But I will give you this hint that may lead you to it...~Search the chest in Nystul's room.");
							add(["quest", "hint", "Nystul"]);
						} 
					}
			case "hint" (remove):
				say("@If hints were mints and mints were hints, think what a world it would be!@");
						  
			case "quest"(remove):
				say("@A quest, a chest, oh what a jest!@");
				add(["jest"]);
		
			case "jest"(remove): 
				say("@Have you heard the one about the nun, the dragon, and the drunken penguin?@");
				if(askYesNo())
				{
					say("@Good! Maybe you can teach it to me someday!");
					add(["teach"]);
				}
				else
					say("@That's too bad... Neither have I!@");

			case "teach" (remove):
				   say("@To teach, to preach, what waste of speech!@");
				   add(["speech"]);

			case "speech" (remove):
				   say("@I just said that!@");
				   add(["that"]);
			
			case "that" (remove):
				   say("@You just said 'that!'@");
				   add(["that"]); 
	 
			case "Nystul" (remove):
				   say("@Oh, he's no fun.@");
				   add(["fun"]);

			case "fun" (remove):
					say("@I'll show you fun before I'm done!@");
					add(["done"]);
	 
			case "done" (remove):
				   say("@I just said that!@");
				   add(["that"]);

			case "absurd" (remove):
				   say("@I just said that!@");
				   add(["that"]);


	//Drudgeworth quest lines

		case "Drudgeworth" (remove):
			say("@Who?@");

		case "leaflet" (remove):
			say("You show Chuckles the leaflet from the remnants of the Royal Prison. He reads it and his facial expression changes to a concerned one. Before you can take it back, he shreds it into tiny pieces and shoves them in his mouth.");
			say("He swallows the pieces and his demeanor changes to a mischevious one once more. @Didst thou enjoy the vanishing act?@");
			UI_remove_party_items(1, SHAPE_SCROLL, QUALITY_LEAFLET, FRAME_ANY);
			add(["about that leaflet.."]);

		case "about that leaflet.."(remove):
			say("@What leaflet?@");
			
		case "Lucy"(remove):
			say("Chuckle's carefree demeanor changes to one of concern when you ask him of 'Lucy'.");
			say("@Wh.. what about her?@");
			say("You tell Chuckles that you know what happened to Lucy, and his association with Drudgeworth.");
			say("Chuckles falls to his knees, putting his face in his hands. @I confess, Avatar! She was my only confidant during such troubling times...I don't know what happened to her.. she was fine one minute and then...@");
			say("Chuckles chokes up for a moment. @I didn't mean to kill her, Avatar, honest! I don't know what happened. I couldn't let this secret get out.@");
			say("@Drudgeworth offered to help me hide her body until I figured out a way to bring her to a healer. He meant to blackmail me!@");
			say("@I admit, I tried to cover it all up. Our liege still doesn't know, and I wouldst like to keep it that way. I am ashamed of my behavior..@");
			say("@Whilst thou keep mine secret?@");
			if (askYesNo())
			{
				say("@Oh, I thank thee, Avatar! Perhaps as a reward I could tell thee some more jokes!@");
				if (isNearby(DUPRE))
				{
					DUPRE.say("@Thy gratitude will suffice I'm sure...@");
					DUPRE.say("He whispers to you. @I'd rather face Blackthorn's torture chamber than have to listen to more of Chuckles' jokes!@");
				}
				if (isNearby(SHAMINO))
				{
					SHAMINO.say("@Frankly, if telling him yes gets him out of our hair, that's good enough for me.@");
					SHAMINO.hide();
				
				}
				//say("@No? Thy loss.  Anyway, I thank thee for keeping my secret. 
				gflags[CHUCKLES_SECRET] = true; //agree to keep his secret, but can tattle on him to LB
				addKarma(10); //can somewhnat be redeemed.
				sayGoodbye2(item);
				break;
			
			}
			else
			{
				say("Chuckles throws himself at your feet. I beseech thee, what shall I do to convince you to not ruin mine life!?@");
				AVATAR.say("@Be waiting at the Blue Boar tavern after midnight by the mirror and we shall discuss the details...@");
				AVATAR.hide();
				say("@Tis a strange request but I'll be there, I promise thee!@ Chuckles walks off nervously.");
				if (isNearby(IOLO))
				{
					IOLO.say("@Avatar, thou surely couldn't be considering that spirit's offer??@");
					IOLO.hide();
					
				}
				if (isNearby(SHAMINO))
				{
					SHAMINO.say("@I question your methods on this but I hope thou hast some sort of lesson in mind and not going along with Drudgeworth's plot..@");
					SHAMINO.say("@It truly wouldn't be virtuous.@");
					SHAMINO.hide();
				}
				if (isNearby(DUPRE))
				{
					DUPRE.say("@While running Chuckles through is something many of us have entertained the thought of because of his terrible jokes, you can't be serious.@");
					DUPRE.say("@Thou shouldst never trust the word of a pirate, an undead one at that!@");
					DUPRE.hide();
				
				}
				gflags[CHUCKLES_WAITS] = true; //flag to move Chuckles to the mirror at 3am
				sayGoodbyeAbrupt(item, "What am I to do?");
				break;
			}
		case "bye":
		    say("@I did my best, did I amuse you? If not, I hope I did confuse you.@");
		    say("@Did you enjoy my jokes?@");
			    if(askYesNo())
			    {
				    say("@You did? Then I'll tell you another one!@");
					    var count = 1;
						while (count >= 1)
						{
							say("@Riddle me this: Do you know what the goose said to the avatar?@");
							if (askYesNo())
							{
								say("@No, no, no, that's not how it works! You're supposed to say you don't, so I can tell you! Let's try it again@");
							}
							else
							{	
								say("@It said 'ankh ankh!'@");
								count = 0;
							}
						}
						say("@What did you think of that one?@");
						AVATAR.say("@...@");
						AVATAR.hide();
						say("@Well, who asked you, anyway?@");
						say("@Oh, that's right, I did!@~");
						say("@Hee hee, ho ho, to spread good cheer I go! Come talk to me again and I'll give you another show!@");
						avatar_goodbye = "@I must be going now..@";
						npc_goodbye = "@Come back for some more great jokes!@";
						sayGoodbye(item, npc_goodbye, avatar_goodbye);
						break;
						
				}  
				else
				{ 
					say("@Really? I'll just have to try harder, then!@");
					say("@Why is Dupre like a horseshoe?@");
					say("@It's because they both have the letter 'r' in them!@");
					say("@What did you think of that one?@");
					AVATAR.say("@Er..Well..@");
					AVATAR.hide();
					if (isNearby(DUPRE))
					{
						DUPRE.say("@I think we should run you through for that terrible joke!@");
						DUPRE.hide();
					}
					say("@Well, who asked you, anyway?@");
					say("@Oh, that's right, I did!@~");
					say("@Hee hee, ho ho, to spread good cheer I go! Come talk to me again and I'll give you another show!@");
									
					if (inParty(DUPRE))
						delayedBark(DUPRE, "Can we run him through yet, Avatar?", 2);
					
					avatar_goodbye = "@I must be going now..@";
					npc_goodbye = "@Come back for some more great jokes!@";
					sayGoodbye(item, npc_goodbye, avatar_goodbye);
					break;
				}
		}                               
	}
	else scheduleBarks(item);
}