/*
 *	Copyright 2019 AgentOrangeGuy 
 *
 *	This program is free software: you can redistribute it and/or modify it under the terms
 *	of the GNU General Public License as published by the Free Software Foundation,
 *	either version 2 of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *	without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *	See the GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License along with this program.
 *	If not, see <http://www.gnu.org/licenses/>.
 */


void Maldric object# (0x430) ()
{

	var party = UI_get_party_list();
	var player_name = getAvatarName();
	var polite_title = getPoliteTitle();
	var hour = UI_game_hour();
	var partynum = UI_get_array_size(party);
	var bark;
	var player_is_female = UI_is_pc_female();
	var greeting; //When addressing party as plural or singular
	var avatar_bark;
	var npc_bark;
	var time_of_day = timeFunction(hour);
	var schedule = UI_get_schedule_type(item); //use for schedule specific convos
	var current_schedule = schedule; 
	
	//READ flag used to initiate conversations via TALK
	var started_talking = UI_get_item_flag(item, READ);

	if (player_is_female) //
	{
	//	noun = "  ";
	//	title = "madame";
	}
	else 
	{
	//	noun = " ";
	//	title = " ";
	}
	
	//determine single/plural greeting
	if (partynum > 1)
		greeting = "friends"; 
	else greeting = "friend"; //Avatar is solo
	
	if (event == DOUBLECLICK)
	{
		//Avatar and NPC greeting barks
		var av_1st_greet = "@Hello there..@";
		var npc_1st_greet = "@Excuse me a moment..@";
				
		var av_2nd_greet  = "@Hello again..@";
		var npc_2nd_greet = "@Oh, hey!";	
		
		//call convo script
		startConvo(item, av_1st_greet, npc_1st_greet, av_2nd_greet, npc_2nd_greet); 
	}
	
	if (started_talking)
	{
		
		if (!UI_get_item_flag(item, MET))
		{
			UI_set_item_flag(item, MET); 
			item.say("A bare chested, muscular man, his body gleaming with sweat.");
			item.say("He pulls a napkin from his belt and mops at his brow. @Now, what were you saying?@*");
			item.say("@Wait a minute,@ he interrupts, @I recognize you...You're the Avatar! I've always wanted to meet you.@");
				if (player_is_female) 
				{
					item.say("@From the day I first saw your portrait, I knew you must be the most beautiful woman in all Britannia.@");
				}
				else item.say("@You're the greatest hero in all the land.@");
				add(["Avatar"]);
		}
		else 
		{	
			if (player_is_female) 
				item.say("@Oh, " + polite_title + " Avatar, 'tis an unexpected pleasure to see you again!@");
			else item.say("@Hey, my old buddy " + player_name + "! Good to see you again.@");
		}
		//standard conversation options
		var options = ["name", "job", "bye"];
		
	/////////////////////////////////////////////////////////////////////
	//Main conversation thread

	/////////////////////////////////////////////////////////////////////
		
		converse(options)
		{
			case "name"(remove):
				say("@Maldric, I am. Once Maldric the boar hunter, now Maldric the cook.@");
				add(["boar"]);

			case "boar"(remove):
				say("@Aye, I used to live in the forest and hunt wild boars.@*");
  				say("But one day I presented a roast boar as a gift to his majesty, and he liked it so much he hired me as his cook.@");
				add(["forest", "majesty", "cook", "roast"]); 

			case "forest"(remove):
				say("@Those were good times. But I'm happy here.@");
				
			case "job"(remove):
				say("@I cook for all those who live in the castle, and for any guests who dine with Lord British as well.@*");
				say("@'Tis sastisfying work, yet at times I wish I could travel with one such as you...@");
				add(["cook", "castle", "guests", "travel"]);

			case "majesty"(remove):
				say("@Yes, Lord British himself.@");
				add(["Lord British"]);

			case "roast"(remove):
				say("@The secret is in the spices. It's an old family recipe.@");
				add(["recipe"]);

			case "recipe"(remove):
				if (player_is_female) 
				{
					say("@I'll never tell. Though for one so sweet, I must say I'm tempted.@");
				}
				else say("@I'll never tell.@");
			
			case "cook"(remove):
				say("@I like having a job where I can make people happy.@");

			case "castle"(remove):
				
				say("@A fancier home than any of my family ever lived in. Yet I still miss my simple hut in the forest.@*");
				if (player_is_female) 
				{
					say("@I wish it were still there, so I could invite you to come spend an evening by the fireplace with me...@");
					add(["fireplace"]);
				}
				

			case "guests"(remove):
				say("@Lord British has many friends.@");
				
			case "travel"(remove):
				say("@I shouldn't even speak of such things.@*");
				say("@After all, you are the Avatar, and I but a lowly cook. Please forgive me.@");
				script item after 3 ticks say "@I'm sorry " + polite_title + "...@";
				
				//do cleanup so no more circular conversations
				UI_clear_item_flag(item, READ);
				UI_run_schedule(item);
				script AVATAR after 8 ticks say "@Goodbye..@";
				
				return;

			case "fireplace"(remove):
				say("@There's fire enough in my kitchen, but 'tis no place for romance. I shouldn't even speak of such things.@*");
				say("@After all, you are the Avatar, and I but a lowly cook. Please forgive me.@");
				script item after 3 ticks say "@I'm sorry milady...@";
				return;
				
			case "Lord British"(remove):
				say("@He's a good man. Likes plenty of pepper in his stew.@");
				add(["pepper"]);

			case "pepper"(remove):
				say("@Spice puts some variety in life, is what I always say.@");
				add(["spice"]);

			case "spice"(remove):
				if (player_is_female) 
				{
					say("@You're a pretty spicy little number yourself!@");
				}
				else say("@Yes indeed.@");

			case "Avatar"(remove):
				say("@I've heard about all of your adventures. I wish I were a warrior too, and not just a cook!@");
				
			case "bye":
				say("@See you later. And next time you dine with his majesty, I'll cook you something special.@");
				if (player_is_female) 
					say("He seems about to say more, with a hopeful look in his eyes. But then he turns away without speaking.");
				var avatar_goodbye = "@Goodbye..@";
				var npc_goodbye = "@I must get back to cooking..@";
				
				//function that is called, do not change this:
				sayGoodbye(item, npc_goodbye, avatar_goodbye);
				break;
	
		}                               
	}
	else scheduleBarks(item);
}