
void Eckhart object# (0x472) ()
{

	var party = UI_get_party_list();
	var player_name = getAvatarName();
	var polite_title = getPoliteTitle();
	var hour = UI_game_hour();
	var partynum = UI_get_array_size(party);
	var bark;
	var player_is_female = UI_is_pc_female();
	var greeting; //When addressing party as plural or singular
	var avatar_bark;
	var npc_bark;
	var time_of_day = timeFunction(hour);
	var schedule = UI_get_schedule_type(item); //use for schedule specific convos
	var current_schedule = schedule; 
	var pronoun;
	
	//For schedule specific behavior - Change WAITER with the 'working' schedule of the npc (BLACKSMITH/ TEND SHOP / etc)
	if (UI_get_schedule_type(item) == TEND_SHOP)
	{
		UI_set_item_flag(item, SHOP_IS_OPEN);
		UI_error_message("Shop is open");
	}
		
	//this makes sure you can talk to them still if their shop is open (convo function turns it to TALK)
	var shop_is_open = UI_get_item_flag(item, SHOP_IS_OPEN);
		
	//Flags used for conversation flags 
	// use PETRA, SI_ZOMBIE, FREEZE, NAKED, POLYMORPH
	var example = UI_get_item_flag(item, SI_ZOMBIE);
	
	
	//READ flag used to initiate conversations via TALK
	var started_talking = UI_get_item_flag(item, READ);

	if (player_is_female) //
	{
		pronoun = "ma'am  ";
	//	title = "madame";
	}
	else 
	{
		pronoun = "sir";
	//	title = " ";
	}
	
	//determine single/plural greeting - change as needed
	if (partynum > 1)
		greeting = "friends"; 
	else greeting = "friend"; //Avatar is solo
	
	if (event == DOUBLECLICK)
	{
		//Avatar and NPC greeting barks
		var av_1st_greet = "@Hello there!@";
		var npc_1st_greet = "@Greetings, " + pronoun + ".@";
				
		var av_2nd_greet  = "@Hello, again.@";
		var npc_2nd_greet = "@Hullo, " + pronoun + ".@";	
		
		//call convo script
		startConvo(item, av_1st_greet, npc_1st_greet, av_2nd_greet, npc_2nd_greet); 
	}
	
	if (started_talking)
	{
		//reset schedule for after convo
		UI_run_schedule(item);
		
		item.say("A gnarled man with knobby muscles.");
		item.say("@Hullo, " + polite_title + ".@ He touches his cap respectfully.");
		if (shop_is_open)
		{
			item.say("He has a very sharp knife with which he prunes off less productive branches. @Mind that you stay out of the flight paths of the bees, " + polite_title + ".@");
			add(["bees"]); 
		}
		//standard conversation options
		var options = ["name", "job", "bye"];

	/////////////////////////////////////////////////////////////////////
	// Main conversation thread

	/////////////////////////////////////////////////////////////////////
		converse(options)
		{
			case "name"(remove):
				say("@Eckhart the vinekeeper, at your service, " + pronoun + ".@");
			
			case "job"(remove):
				say("@I care for the garden and tend the vines.@"); 
  				add(["garden", "vines"]); 

			case "bees"(remove):
				say("You notice the bees have regular aerial routes all about the vineyard.");
				say("@Zeke keeps bees on the other side of the abbey.@");
													
			case "garden"(remove):
				say("@Some of our rosebushes were planted by druids hundreds of years ago.@");
				say("@Eventually, we became the Brotherhood of the Rose.@");
				
			case "vines"(remove):
				if (UI_get_schedule_type(item) == TEND_SHOP)
				{
					say("@These rows,@ he gestures, @are seedless grapes.@");
					
				}
				else 
					say("@Here at the abbey we grow seedless grapes.@");
				add(["seedless"]); 		


			case "seedless"(remove):
				say("@Amazing, ain't it," + player_name + ". The enchanter made them for us.@");
				say("@Now I grow new vines by grafting seedless grapevines onto regular rootstocks.@");
				add(["enchanter", "grapes"]); 		

			case "enchanter"(remove):
				say("@Yes. He lives east of here, between two rivers.@");
				say("@His hut be due north of Britain, or so they tell me..@");
				if (!gflags[LEARNED_ABOUT_NICODEMUS]) //lets you ask others about Nicodemus
					gflags[LEARNED_ABOUT_NICODEMUS] = true;
				
			case "grapes"(remove):
				if (shop_is_open)
				{
					say("@Now those grapes there are for making wine.@");
					if (isNearby(DUPRE))
					{
						DUPRE.say("@I cannot say which I like better: wine from grapes or mead from honey!@");
						DUPRE.hide();	
					}
					say("@And these over here are for eating.@");
					if (UI_add_party_items(1, SHAPE_FOOD, QUALITY_ANY, FRAME_GRAPES, true))
						say("He gives you a plump little bunch of sweet table grapes.");
					else
						say("@Too burdened? Maybe next time.@");
				}
				else 
					say("@Visit me in the fields some time and I'll give you some!@");
				

			case "wine"(remove):
				say("@Ask Faren of that..@");
				add(["Faren"]); 		

			case "Faren"(remove):
				say("@Yes, Faren--the local winemaker.@");

			
			case "bye":
				if (shop_is_open)
					say("He waves and turns back to work.");
				else	
					say("Eckhart waves goodbye.");
         
				
				var avatar_goodbye = "@Nice talking to you.@";
				var npc_goodbye = "@Safe travels to ye.@";
				
				//function that is called, do not change this:
				sayGoodbye(item, npc_goodbye, avatar_goodbye);
				break;
	
		}                               
	}
	else scheduleBarks(item);
}