/*
 *	Copyright 2019 AgentOrangeGuy 
 *
 *	This program is free software: you can redistribute it and/or modify it under the terms
 *	of the GNU General Public License as published by the Free Software Foundation,
 *	either version 2 of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *	without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *	See the GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License along with this program.
 *	If not, see <http://www.gnu.org/licenses/>.
 */


void Glen object# (0x40e) ()
{

	var party = UI_get_party_list();
	var player_name = getAvatarName();
	var polite_title = getPoliteTitle();
	var hour = UI_game_hour();
	var partynum = UI_get_array_size(party);
	var bark;
	var player_is_female;
	var greeting; //When addressing party as plural or singular
	var avatar_bark;
	var npc_bark;
	var time_of_day = timeFunction(hour);
	var schedule = UI_get_schedule_type(item); //use for schedule specific convos
	var current_schedule = schedule; 

	var cremate_body = [];
	var bodies = 0;
	var body;
	var bodyframe;
	var bodyshape;
	
	//for glenCremation function event
	const int ANIMATE_GLEN = 1;
	const int FAILED = 7;

	//Positions for glen cremate function
	var glen_pos1 = [0375, 0603, 0]; //path 0
	var body_pos = [0375, 0599]; //body position in crematoriam pit
	
	var crematorium_pos = [0171, 0257]; //crematoriam pit - prevent from doing it outside of room
	//var path_egg =  UI_find_nearby([crematorium_pos], 607, 10, MASK_EGG);
	
	var scorch =  UI_find_nearby([0171, 0257], 204, 15, MASK_NONE);
	
	//READ flag used to initiate conversations via TALK
	var started_talking = UI_get_item_flag(item, READ);

	if (player_is_female) //
	{
	//	noun = "  ";
	//	title = "madame";
	}
	else 
	{
	//	noun = " ";
	//	title = " ";
	}
	
	//determine single/plural greeting
	if (partynum > 1)
		greeting = "friends"; 
	else greeting = "friend"; //Avatar is solo

	if (event == DOUBLECLICK)
	{
		//Avatar and NPC greeting barks
		var av_1st_greet = "@Greetings milord..@";
		var npc_1st_greet = "@Ah, a potential client..@";
				
		var av_2nd_greet  = "@Excuse me..@";
		var npc_2nd_greet = "@Good evening...@";	
		
		//call convo script
		startConvo(item, av_1st_greet, npc_1st_greet, av_2nd_greet, npc_2nd_greet); 
	}
	
	if (started_talking)
	{
		//Avatar or party carrying a body that can be cremated
		bodies = getBodyCount(item);
		UI_halt_scheduled(GLEN);
		if (UI_in_usecode(GLEN))
		{
			UI_error_message("Glen is in a script");	
			UI_halt_scheduled(GLEN);
		
		}
		else
			UI_error_message("GLEN is not in a script");
			
		if (bodies > 0)
		{
			item.say("His eyes gleam fiendishly when he notices the body you're carrying.*");
			item.say("@Ah, you've brought me a client. Tell the truth, doesn't your friend look more peaceful this way?@*");
			item.say("@For such a heroic client, I have something special to offer. It's a new process I've invented called 'cremation.'@*");
			item.say("@For a mere fifteen gold, the remains of the dearly departed are purified with flame. Would you like me to do this for you?@*");
			if (askYesNo())
			{
				var GlenLocation = UI_get_object_position(GLEN);
								
				var GlenX = GlenLocation[1];
				var GlenY = GlenLocation[2];
						
				var in_range;
				
				//test to see if Glen is in the house
				if (((GlenX < 353)||(GlenX > 380)) || ((GlenY < 593)||(GlenY > 606)))
					in_range = false;
				else
					in_range = true;
						
				UI_error_message("In range is " + in_range);
				
				//if Glen is in the crematorium, proceed
				if (in_range) 
				{
					UI_error_message("Glen is near the creamatorium");
							
					if (hasGold(15))
					{
						chargeGold(15);
						body = findBodyCont(PARTY);
						
						//run glenCremation cutscene
						if (UI_is_dest_reachable(item, [glen_pos1]))
						{
							UI_error_message("Destionation glen pos1 is reachable");
							
							//set Glen to Wait in front of the crematorium spot
							UI_set_new_schedules(GLEN, 2, WAIT, [glen_pos1]);
							
							//force him to move
							UI_run_schedule(GLEN);
							
							
							//play music
							UI_play_music(27);
							
							//start script						
							script GLEN after 35 ticks
							{
								call glenCremation, ANIMATE_GLEN;
							
							};
							
							if (UI_in_usecode_path(GLEN))
								UI_error_message("Glen is moving to the path.");
							else
								UI_error_message("Glen is NOT moving to the path.");
							
						}	
						else
							UI_error_message("Something went wrong.");
	
		
						
					}	
					else item.say("@You're a bit short on gold.@ he says, dissapointedly."); 
					sayGoodbye2(item);
					return; 
					
				}
				else
				{
					item.say("@Bring them back to my shop so we can safely cremate the body..@");
					UI_error_message("Glen is too far away from creamatorium");
					sayGoodbye2(item);
				}
			}
			else item.say("@Too bad.@"); 
			sayGoodbye2(item);
			return;
		
			
		}	
			
		else if (UI_get_item_flag(item, POLYMORPH)) 
		{
			item.say("@Ohhh! Silly me, spending so much time with my clients.@ He gestures at the corpses. @I forget little details like paying Mole...I'll have to take care of it right away!@");
			item.say("@You deserve a reward for helping me straighten this out. That mage over on the table was found just outside of town. He was carrying a couple of enchanted items and some money when the gargoyles got him. Nobody has been able to find any relatives of his, so you might as well take it all.@");	
			
			//Find mage to set "Okay to take" flag for mage and contents
			var mage = UI_find_object(FIND_ON_SCREEN, 762, 1, FRAME_ANY);
			var obj;
			UI_set_item_flag(mage, OKAY_TO_TAKE);
			var item_list = UI_get_cont_items(mage, SHAPE_ANY, QUALITY_ANY, FRAME_ANY);
			for (obj in item_list with index to max)
				UI_set_item_flag(obj, OKAY_TO_TAKE);
		
			//clear all npc flags to prevent re-doing for more exp
			UI_set_item_flag(MOLE, POLYMORPH);
			UI_clear_item_flag(item, CONFUSED);
			UI_clear_item_flag(item, NAKED);
			UI_clear_item_flag(item, PETRA);
			UI_clear_item_flag(item, SI_ZOMBIE);
			UI_clear_item_flag(item, POLYMORPH);
			giveExperience(50);
		}
		else if (UI_get_item_flag(item, CONFUSED)) 
		{
			item.say("@That addle-brained, lower class, miserable excuse for a common laborer...I agreed to give him an equipment allowance with his pay. No doubt it's all been squandered at some tavern, along with the rest of his pay. See what he has to say about that!!@");
			UI_set_item_flag(MOLE, CONFUSED); //triggers 4th mole response
			sayGoodbye2(item);
			return;
		}

		else if (UI_get_item_flag(item, NAKED))
		{
			item.say("@So, his shovel broke? That's no excuse. Tell him he should have bought another one and kept working.@");
			UI_set_item_flag(MOLE, PETRA); //triggers 3rd Mole response
			sayGoodbye2(item);
			return;
		}
		
		else if (UI_get_item_flag(item, SI_ZOMBIE))
		{
			item.say("You pass along Mole's message. @Needs a shovel, does he? Tell him to use the one I gave him when I hired him! No doubt he's forgotten he has it by now, or lost it somewhere...@");
			UI_set_item_flag(MOLE, NAKED); //triggers 2nd Mole response
			sayGoodbye2(item);
			return;
		}
		else
		{
			item.say("You see a quiet, pale, almost motionless gentleman.");
			item.say("@Good evening.@ he says, in a voice that sends shivers down your spine. @It is evening, I hope. That's my favorite time.@");
		}
		
		//standard conversation options
		var options = ["name", "job", "bye"];
	

	/////////////////////////////////////////////////////////////////////
	// Main conversation thread

	/////////////////////////////////////////////////////////////////////
		converse(options)
		{
			case "name"(remove):
				say("@I am Glen D'Arc, of the Trinsic D'Arcs.@");
				add(["Trinsic"]); 

			case "job"(remove):
				say("@I prepare the bodies of the departed for their eternal rest. It's very relaxing work. At least it would be, if I didn't have to put up with that incompetent gravedigger.@");
				add(["rest", "bodies", "gravedigger"]); 
			

			case "Trinsic"(remove):
				say("I had to move away... Too sunny.@");
				add(["sunny"]); 		
									
			case "sunny"(remove):
				say("@I much prefer moonlight. It's more natural and healthy.@");
				
			case "rest"(remove):
				say("@Yes, those who cannot afford resurrection know the cool comfort of good, honest soil.@ He sighs longingly. @How I envy them, for only the dead know true peace..@");
				add(["dead"]);

			case "bodies"(remove):
				say("@For most clients, I prefer to use Frigid Solvol. It's the finest enbalming fluid on the market.@");
				add(["Solvol"]);
			
			case "Solvol"(remove):
				say("@It gives the departed a nice, healthy glow...@");

			case "dead"(remove):
				say("He smiles. @I see you're not much of a believer in death. But next time you're dead you should try staying that way. You might like it...@");

			case "gravedigger"(remove):
				if (!UI_get_item_flag(MOLE, SI_ZOMBIE))
				{
					say("@Mole was supposed to have two more graves finished yesterday. I can't stand to talk to him any more - if you see him, tell him I need those graves dug immediately!@");
					UI_set_item_flag(MOLE, SI_ZOMBIE);
				}
				else say("@Mole was supposed to have two more graves finished yesterday. I can't stand to talk to him any more - if you see him, tell him I need those graves dug immediately!@");

			case "bye":
				say("@Goodbye for now - I'm sure I'll see you again. Every body ends up here sooner or later...@");
				
				var avatar_goodbye = "@Goodbye..@";
				var npc_goodbye = "@I'll see you again I'm sure...@";
				
				//function that is called, do not change this:
				sayGoodbye(item, npc_goodbye, avatar_goodbye);
				break;
	
		}                               
	}
	else scheduleBarks(item);
}