/*
 *	Copyright 2019 AgentOrangeGuy 
 *
 *	This program is free software: you can redistribute it and/or modify it under the terms
 *	of the GNU General Public License as published by the Free Software Foundation,
 *	either version 2 of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *	without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *	See the GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License along with this program.
 *	If not, see <http://www.gnu.org/licenses/>.
 */


void FarmerKrill object# (0x4bb) ()
{

	var avatar_bark;
	var npc_bark;
	var schedule = UI_get_schedule_type(item); //use for schedule specific convos
	var current_schedule = schedule; 
	
	var party = UI_get_party_list();
	var player_name = getAvatarName();
	var polite_title = getPoliteTitle();
	var hour = UI_game_hour();
	var partynum = UI_get_array_size(party);
	var bark;
	var player_is_female;
	var greeting; //When addressing party as plural or singular
	var time_of_day = timeFunction(hour);
		
	
	//READ flag used to initiate conversations via TALK
	var started_talking = UI_get_item_flag(item, READ);
	
	var wearing_amulet = isWearingAmulet();
	

	if (event == DOUBLECLICK)
	{
		//Avatar hasn't used the scroll, hasn't submitted to  Drax, and can't understand gargoyles yet:
		
		if (!isWearingAmulet()) //Avatar has not submitted to Drax yet
		{	
			UI_error_message("Farmer Krll !submit to drax");
			if (UI_get_npc_id(item, 1)) //read the scroll and can understand them
			{	
				
				//Avatar and NPC greeting barks
				var av_1st_greet = "@Hold, gargoyle!@";
				var npc_1st_greet = "@The False Prophet! Workers, attack!@";
						
				var av_2nd_greet = "@Hold, gargoyle!@";
				var npc_2nd_greet = "@The False Prophet! Workers, attack!@";
				//call convo script
				startConvo(item, av_1st_greet, npc_1st_greet, av_2nd_greet, npc_2nd_greet); 
				

			}
			
			else 
			{
				UI_error_message("Krill ID 0");
				//Avatar and NPC greeting barks
				var av_1st_greet = "@Hold, gargoyle!@";
				var npc_1st_greet = "@An-bal-sil-fer! Des-lem, klep lem!@";
						
				var av_2nd_greet = "@Greetings..@";
				var npc_2nd_greet = "@An-bal-sil-fer! Des-lem, klep lem!@";
				
							
				//call convo script
				startConvo(item, av_1st_greet, npc_1st_greet, av_2nd_greet, npc_2nd_greet); 
						
			}
			
	
			
			
		}
		else
		{
			//Avatar and NPC greeting barks
			var av_1st_greet = "@Hail, gargoyle.@";
			var npc_1st_greet = "@To greet you, False Prophet..@";
					
			var av_2nd_greet = "@Farmer Krill..@";
			var npc_2nd_greet = "@To greet you again, False Prophet.@";	
			//call convo script
			startConvo(item, av_1st_greet, npc_1st_greet, av_2nd_greet, npc_2nd_greet); 
		}
		
	
	}
	
	if (started_talking)
	{
		UI_set_schedule_type(SHY);
		UI_run_schedule(item);
		if (!isWearingAmulet()) //Avatar has not submitted to Drax yet
		{
			if (UI_get_npc_id(item, 1))
				item.say("The gargoyle screams, @The False Prophet! Workers, attack!@");
			
			else //npc id is 0
				item.say("The gargoyle screams, @An-bal-sil-fer! Des-lem, klep lem!@");
	
			var wingless_gargs = UI_find_nearby(FARMER_KRILL, 883, 30, MASK_NONE);
			var gargcount = 0;
			
			for (npc in wingless_gargs)
			{
				UI_set_alignment(npc, EVIL);
				UI_set_schedule_type(npc, IN_COMBAT);
				gargcount += 1;
				UI_error_message("Wingless gargoyles found are" + gargcount);
			}	
			return;
		}
		else
		{
		
			if (!UI_get_item_flag(item, MET))
			{
				item.say("A large, healthy-looking winged gargoyle.");
				item.say("@To note that you wear the Amulet of Submission. To admire your courage and to appreciate your sacrifice.@");
				item.say("@To ask your name, that I may address you in a noble manner?@");
				var name = chooseFromMenu(["I am " + player_name]);
				item.say("@To greet you, " + player_name + ".@");
				UI_set_item_flag(item, MET);
			}
			else 
			item.say("@Good " + time_of_day + ", noble " + player_name + ". To be pleased by your return!@");	
		}
		//standard conversation options
		var options = ["name", "job", "bye"];
		
		if (inParty(BEHLEM))
			add("Beh Lem");
		
	/////////////////////////////////////////////////////////////////////
	// Main conversation thread

	/////////////////////////////////////////////////////////////////////
		converse(options)
		{
			case "name"(remove): 
				say("@To be named Krill Us-arb-vas-lem, Krill the Leader of Farmers.@*");
				

			case "job"(remove):
				say("@To lead the wingless ones, the worker gargoyles who tend these fields.@");
				say("@To have great fortune in my harvests!@");
				add(["wingless ones", "harvests"]); 

			case "guidance"(remove): 
				say("@To be forced by necessity to give the wingless ones no room for choice or freedom.@*");
				add(["freedom"]); 
				
			case "Beh Lem"(remove): 
				say("@Beh Lem? To be but a child. To someday grow wings just like his father, Scholar Valkadesh.@*");
				add(["Valkadesh"]); 				

			case "Valkadesh"(remove): 
				say("@To admire the wisdom of Scholar Valkadesh, but to consider his studies unseemly.@*");
				add(["studies"]); 
				
			case "studies"(remove): 
				say("@To abhor his continued study of the accursed humans!@*");
				say("The gargoyle pauses, embarrassed.*");
				say("@To mean no offense to you, " + player_name + ". To acknowledge the nobility of your sacrifice.@*");
				say("@To consider you a great credit to your race!@");
			
			case "freedom"(remove): 
				say("@To acknowledge that it may seem harsh, but to assure you that there is no other way to treat the wingless ones.@*");
				
			case "wingless ones"(remove): 
				say("@To consider them valuable members of society who need firm control and strong leadership. To explain that they are far less intelligent than you or I.@*");
				
			case "harvests"(remove): 
				say("@To receive bountiful harvests thanks to the efforts of my well-directed workers.@*");
				say("@To feed my workers far better than misguided Farmer Nash to the east does.@");
				add(["Farmer Nash"]); 

			case "Farmer Nash"(remove): 
				say("@To be ashamed that Nash lacks common sense. To be appalled by his uncontrolled heart and undirected mind.@*");
				say("@To point out his unproductive fields as an example of why the wingless ones need firm guidance.@");
				add(["guidance"]); 				

			case "bye":
				say("@To have greatly enjoyed this conversation, noble " + player_name + "!@");
				
				var avatar_goodbye = "@So long..@";
				var npc_goodbye = "@To bid you farewell!@";
				
				//function that is called, do not change this:
				sayGoodbye(item, npc_goodbye, avatar_goodbye);
				break;
	
		}                               
	}
	else scheduleBarks(item);
}