/*
 *	Copyright 2019 AgentOrangeGuy 
 *
 *	This program is free software: you can redistribute it and/or modify it under the terms
 *	of the GNU General Public License as published by the Free Software Foundation,
 *	either version 2 of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *	without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *	See the GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License along with this program.
 *	If not, see <http://www.gnu.org/licenses/>.
 */


void Snakecharmer object# (0x4c1) ()
{

	var avatar_bark;
	var npc_bark;
	var schedule = UI_get_schedule_type(item); //use for schedule specific convos
	var current_schedule = schedule; 
	var hour;
	
	//READ flag used to initiate conversations via TALK
	var started_talking = UI_get_item_flag(item, READ);
	
	var wearing_amulet = isWearingAmulet();
	

	if (event == DOUBLECLICK)
	{
		//Avatar hasn't used the scroll, hasn't submitted to  Drax, and can't understand gargoyles yet:
		
		if (!isWearingAmulet()) //Avatar has not submitted to Drax yet
		{	
			UI_error_message("Snakecharmer !submit to drax");
			if (UI_get_npc_id(item, 1))
			{	
				UI_error_message("Snakecharmer id 1");
				//Avatar and NPC greeting barks
				var av_1st_greet = "@Hold, gargoyle!@";
				var npc_1st_greet = "@The False Prophet!@";
						
				var av_2nd_greet = "@Hold, gargoyle!@";
				var npc_2nd_greet = "@The False Prophet!@";
				//call convo script
				startConvo(item, av_1st_greet, npc_1st_greet, av_2nd_greet, npc_2nd_greet); 
				

			}
			
			else 
			{
				UI_error_message("Snakecharmer ID 0");
				//Avatar and NPC greeting barks
				var av_1st_greet = "@Hold, gargoyle!@";
				var npc_1st_greet = "@An-bal-sil-fer!@";
						
				var av_2nd_greet = "@Hold, gargoyle!@";
				var npc_2nd_greet = "@An-bal-sil-fer!@";
				
				//call convo script
				startConvo(item, av_1st_greet, npc_1st_greet, av_2nd_greet, npc_2nd_greet); 
						
			}
		}
		else
		{
			//Avatar and NPC greeting barks
			var av_1st_greet = "@Hail, gargoyle.@";
			var npc_1st_greet = "@The False Prophet..@";
					
			var av_2nd_greet = "@Hail, snakecharmer!@";
			var npc_2nd_greet = "@To greet you, False Prophet.@";	
			//call convo script
			startConvo(item, av_1st_greet, npc_1st_greet, av_2nd_greet, npc_2nd_greet); 
		}
		
	
	}
	
	if (started_talking)
	{
		if (!gflags[READ_GARGISH_SCROLL]) //not read garg scroll
		{
			item.say("An old winged gargoyle.");
			item.say("The gargoyle shouts, @An-bal-sil-fer!@ and flees!");
			UI_clear_item_flag(item, MET);
			sayGoodbyeAbrupt(item, "@An-bal-sil-fer!!");
			UI_set_schedule_type(item, IN_COMBAT);
			UI_set_attack_mode(item, FLEE);
			return;
		}
		else if (!gflags[SUBMITTED_TO_DRAXINUSOM])  //not submitted yet but read scroll
		{
			item.say("An old winged gargoyle.");
			item.say("The gargoyle shouts, @The False Prophet!@ and flees!");
			UI_clear_item_flag(item, MET);
			sayGoodbyeAbrupt(item, "@The False Prophet!!@");
			UI_set_schedule_type(item, IN_COMBAT);
			UI_set_attack_mode(item, FLEE);
			return;
		
		}
		else
		{
			if (!UI_get_item_flag(item, PETRA))
			{
				item.say("An old winged gargoyle.");
				item.say("The gargoyle seems afraid of you at first. Then he notices the amulet around your neck.");
				item.say("@To--to feel honored to address you, False Prophet.@");
				UI_set_item_flag(item, PETRA);
			}
			else 
				item.say("@To feel honored by your visit, False Prophet.@.");
			item.say("@To ask what you wish of a simple snakecharmer?@");	
		
				
		}
		
		
				
	
	
		//standard conversation options
		var options = ["name", "job", "bye"];
		
	/////////////////////////////////////////////////////////////////////
	// Main conversation thread

	/////////////////////////////////////////////////////////////////////
		converse(options)
		{
			case "name"(remove): 
				say("The gargoyle laughs nervously.*");
				say("@To lack a name, of course.@*");
				say("@To be called simply by my job, snakecharmer.@*");
				

			case "job"(remove):
				say("@To summon the silver snake, and to direct the young warriors in defeating it.@");
				say("@Then to extract the venom so that I can make the battle-drug.@");
				add(["battle-drug"]); 


			case "battle-drug"(remove): 
				say("@To make the drug for our bravest warriors, who take it and turn into fighting daemons!@*");
				say("@To express sorrow that the drug is fatal, but to express awe and respect for the warriors' sacrifice.@*");
		
			case "snakecharmer"(remove): 
				say("@To use the great horn to summon the silver snake.@*");
				say("@To always require many warriors to defeat the creature!@*");
				add(["horn"]); 


			case "horn"(remove): 
				say("@To find the horn just north of my house. But to warn you never to blow the horn!@*");
				say("@To be in grave peril from the snake without a squad of warriors!*");
	
			case "bye":
				say("@To express my thanks for the sacrifice you have chosen to make!@");
				
				var avatar_goodbye = "@Farewell..@";
				var npc_goodbye = "@To bid you goodbye, False Prophet.@";
				
				//function that is called, do not change this:
				sayGoodbye(item, npc_goodbye, avatar_goodbye);
				break;
	
		}                               
	}
	else scheduleBarks(item);
}