/*
 *	Copyright 2019 AgentOrangeGuy 
 *
 *	This program is free software: you can redistribute it and/or modify it under the terms
 *	of the GNU General Public License as published by the Free Software Foundation,
 *	either version 2 of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *	without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *	See the GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License along with this program.
 *	If not, see <http://www.gnu.org/licenses/>.
 */


void Weaponsmith object# (0x4be) ()
{

	var avatar_bark;
	var npc_bark;
	var schedule = UI_get_schedule_type(item); //use for schedule specific convos
	var current_schedule = schedule; 
	var hour;
	var polite_title = getPoliteTitle();
	const int SHAPE_SLEEPING_POWDER = 648;
	const int FRAME_POWDER = 1;
	
	//READ flag used to initiate conversations via TALK
	var started_talking = UI_get_item_flag(item, READ);
	
	var wearing_amulet = isWearingAmulet();
	

	if (event == DOUBLECLICK)
	{
		//Avatar hasn't used the scroll, hasn't submitted to  Drax, and can't understand gargoyles yet:
		
		if (!isWearingAmulet()) //Avatar has not submitted to Drax yet
		{	
			
			if (UI_get_npc_id(item, 1))
			{	
				UI_error_message("Snakecharmer id 1");
				//Avatar and NPC greeting barks
				var av_1st_greet = "@Hold, gargoyle!@";
				var npc_1st_greet = "@An-bal-sil-fer!@";
						
				var av_2nd_greet = "@Hold, gargoyle!@";
				var npc_2nd_greet = "@The False Prophet!@";
				//call convo script
				startConvo(item, av_1st_greet, npc_1st_greet, av_2nd_greet, npc_2nd_greet); 
				

			}
			
			else 
			{
				UI_error_message("Snakecharmer ID 0");
				//Avatar and NPC greeting barks
				var av_1st_greet = "@Hold, gargoyle!@";
				var npc_1st_greet = "@An-bal-sil-fer!@";
						
				var av_2nd_greet = "@Hold, gargoyle!@";
				var npc_2nd_greet = "@An-bal-sil-fer!@";
				
				//call convo script
				startConvo(item, av_1st_greet, npc_1st_greet, av_2nd_greet, npc_2nd_greet); 
						
			}
		}
		else
		{
			//Avatar and NPC greeting barks
			var av_1st_greet = "@Hail, gargoyle.@";
			var npc_1st_greet = "@The False Prophet..@";
					
			var av_2nd_greet = "@Hail, weaponsmith!@";
			var npc_2nd_greet = "@To greet you, False Prophet.@";	
			//call convo script
			startConvo(item, av_1st_greet, npc_1st_greet, av_2nd_greet, npc_2nd_greet); 
		}
		
	
	}
	
	if (started_talking)
	{
		//reset schedule for after convo
		UI_run_schedule(item);
		
		if (!gflags[READ_GARGISH_SCROLL]) //Avatar has not read scroll or submitted yet
		{
			item.say("A young, nervous-looking gargoyle.");
			item.say("@An-bal-sil-fer!@ the gargoyle screams. @Agra-lem! Agra-Lem!@");
			item.say("Suddenly realizing that he is holding a weapon, the gargoyle attacks!");
			UI_clear_item_flag(item, MET);
			UI_set_alignment(item, EVIL);
			UI_set_schedule_type(item, IN_COMBAT);
			sayGoodbye2(item);
			return;
				
		}
		else
		{
			if (!gflags[SUBMITTED_TO_DRAXINUSOM]) //can understand him
			{	
				item.say("A young, nervous-looking gargoyle.");
				item.say("@The False Prophet!@ the gargoyle screams. @Guards! Guards!@");
				item.say("Suddenly realizing that he is holding a weapon, the gargoyle attacks!");
				UI_clear_item_flag(item, MET);
				UI_set_alignment(item, EVIL);
				UI_set_schedule_type(item, IN_COMBAT);
				return;
			
		
			
			}
			
			else //Submitted
			{	
				if (!UI_get_item_flag(item, MET))
				{
					UI_set_alignment(item, NEUTRAL);
					item.say("A young, nervous-looking gargoyle.");
					item.say("@The False Prophet!@");
					item.say("@To thank you for your upcoming sacrifice. To greatly respect your nobility and courage.@");
					UI_set_item_flag(item, MET);
				}
				else 
					item.say("@To ask how I can help you, noble one.@.");
			}		
		}
		//standard conversation options
		var options = ["name", "job", "bye"];
		
		
		//flags set once he gives you the freebies already, now you can only ask about them
		if (UI_get_item_flag(item, PETRA))
			add("zu ylem dust");
			
		if (UI_get_item_flag(item, SI_ZOMBIE))
			add("boomerang");	
			
		if (UI_get_item_flag(GOODSCRAFTER, MET))
			add("Goodscrafter");				
		
	/////////////////////////////////////////////////////////////////////
	// Main conversation thread

	/////////////////////////////////////////////////////////////////////
		converse(options)
		{
			case "name"(remove): 
				
				say("@To be but a simple weaponsmith, False Prophet.@*");
                say("@To lack a name, as is appropriate for my station.@*");
				add("weaponsmith");
				

			case "job"(remove):
				say("@To be the master weaponsmith now, although to have but recently been a simple apprentice.@");
				add(["buy"]); 

				
			case "weaponsmith"(remove):
				say("@To be the master weaponsmith now, although to have but recently been a simple apprentice.@");
				add(["apprentice"]); 

			case "zu ylem dust"(remove):
				say("@To regret that I have such a small supply of zu ylem dust.@");
			
			case "boomerang"(remove):
				say("@To wish I had more boomerangs, that I might give you another.@");
			
			case "apprentice"(remove):
				say("@To greatly regret the loss of my master, killed during the disasters.@");
				say("@But to carry on in the face of adversity. And certainly not to lose all passion for life, like the worthless goodscrafter!@");
				add(["goodscrafter", "disasters", "join"]); 

			case "goodscrafter"(remove):
				say("@To consider him a discredit to the race!@");
				say("@Most of all, to consider him a dishonor to my late master!@");
				add(["dishonor"]); 
			
			case "disasters"(remove):
				say("@Yes, surely to know of the disasters?@");
				say("@To have only barely survived the earthquakes after the Codex disappeared.@");
				
			case "join"(remove):
				say("@To wish I could leave on adventures...@");
				say("@But to be dedicated to my important work.@");
								
			case "buy"(remove):
				say("@To not understand what that means.@");
				say("@To create these items for the use of all.@");
				add(["all"]);
				
			case "all"(remove):
				say("@To give these wares to any gargoyle who has need of them.@");
				say("@To invite you to look around at my wares as well.@");
				say("@To ask if any of them interest you?@");
				add(["wares"]); 
				
			case "wares"(remove):
				if (!UI_get_schedule_type(item, BLACKSMITH))
					say("@To ask you to see me at my shop!@");
				else
				{
					say("@To have but a few items available. To be far less adept than my former master.@");
					var wares = ["boomerang", "vial", "helmet", "pouch", "nothing"];
					converse(wares)
					{
						case "boomerang"(remove):
							say("@Ah, to see you admire these boomerangs, the work of my master.@*");
							say("@To regret being unable to create boomerangs myself.@*");
							if (!UI_get_item_flag(item, SI_ZOMBIE))
							{
								say("@To have only a few left in stock, but to offer you one.@");
								say("Do you accept the gift");
								if (askYesNo())
								{
									if (UI_add_party_items(1, SHAPE_BOOMERANG, QUALITY_ANY, FRAME_ANY, false))
									{
										UI_set_item_flag(item, SI_ZOMBIE);
										say("The gargoyle hands you a boomerang.");
										if (inParty(SHAMINO) && isNearby(SHAMINO))
										{
											say("As you take the boomerang, Shamino speaks.");
											SHAMINO.say("@Aye, 'tis a most interesting weapon, " + polite_title + ". Perhaps when our quest is through I can study its use.@");
											SHAMINO.hide();
										}
																				
										say("The gargoyle speaks. @To ask if anything else interests you?@");
									}
									else
										say("@To not be able to carry it.@");
								}
								else say("The gargoyle nods. @Yes, to see that you already have enough weapons.@");
							}
							
						case "pouch"(remove):
							say("@Yes, to be a very interesting weapon. To knock out even a large animal with just a single pouch of this powder!@*");
							say("@To be used most often by hunters, to avoid harming the meat. Unfortunately, to make this powder from plants that can no longer be found.@*");
							if (!UI_get_item_flag(item, SI_ZOMBIE))
							{
								say("@Here, to offer you one.@");
								say("Do you accept the gift");
								if (askYesNo())
								{
									if (UI_add_party_items(1, SHAPE_SLEEPING_POWDER, QUALITY_ANY, FRAME_POWDER, false));
									{
										UI_set_item_flag(item, SI_ZOMBIE);
										say("He hands you a small pouch. @To hope you find it useful.@");
									
									}
									
								}	
								else
									say("The gargoyle nods. @To understand your reluctance To know the dangers of zu ylem dust to the untrained user.@*");
							}	
							add("plants");
					
						case "plants"(remove):
							say("@To create the zu ylem dust from plants that can no longer be found. But to know of far worse effects of the disasters.@");
							
						case "vial" (remove):
							say("@To be a powerful but dangerous drug! To turn gargoyle warriors into unstoppable fighters!@");
							say("@But to always be fatal after the battle ends.@");
							say("@To be created by the snake charmer, who lives to the southwest.@");
							add("snake charmer");
						
						case "snake charmer" (remove):
							say("@Yes, to suggest you visit him if you are interested. To find the snake-summoning horn a most impressive sight!@");
					
						case "helm"(remove):
							say("@To see little of interest in that item.@");
							
							
						case "nothing":
							say("@To ask what you want to speak of next?@");
							break;
							
					}
				
				}
				
			
			case "dishonor"(remove):
				say("@To cheapen all our loss, all our grief, by his self-pity. To have lost my master, like a father to me.@");
				say("@Yet to maintain control, to maintain diligence. Most of all to maintain passion for life. To feel that the goodscrafter dishonors us all by abandoning our principles.@");
				say("@To feel that the goodscrafter needs a trip to the catacombs.@");
				add(["catacombs"]); 
				
			case "catacombs"(remove):
				say("@Yes, to have visited them myself once, long ago. To find there shrines to our three principles: control, passion and diligence.@");
				say("@To speak with these shrines and meditate, to receive new insight. To not remember where the catacombs are.@");
				say("@To be sent there by the Temple of Singularity.@");
				add(["Singularity"]); 
				
			case "Singularity"(remove):
				say("@To find that to the north, in the mountains.@");
				say("@To advise you to find some way to fly if you wish to get there, though!@");
				add(["fly"]); 
				
			case "fly"(remove):
				say("@To be unable to reach the Temple on foot; to be forced to fly over the mountains.@");
					
			case "bye":
				say("@To express my thanks for the sacrifice you have chosen to make!@");
				
				var avatar_goodbye = "@Goodbye..@";
				var npc_goodbye = "@May your long work and strength lead to success!@";
				
				//function that is called, do not change this:
				sayGoodbye(item, npc_goodbye, avatar_goodbye);
				break;
	
		}                               
	}
	else scheduleBarks(item);
}