
void Dale object# (0x45c) ()
{

	var party = UI_get_party_list();
	var player_name = getAvatarName();
	var polite_title = getPoliteTitle();
	var hour = UI_game_hour();
	var partynum = UI_get_array_size(party);
	var bark;
	var player_is_female = UI_is_pc_female();
	var greeting; //When addressing party as plural or singular
	var avatar_bark;
	var npc_bark;
	var time_of_day = timeFunction(hour);
	var schedule = UI_get_schedule_type(item); //use for schedule specific convos
	var current_schedule = schedule; 
	
	//Flags used for conversation flags 
	// use PETRA, SI_ZOMBIE, FREEZE, NAKED, POLYMORPH
	var example = UI_get_item_flag(item, SI_ZOMBIE);
	
	var item_options = ["nothing", "glass", "jar", "mirror"];
	var item_shapes = [SHAPE_CUP, SHAPE_JAR, SHAPE_DESK_ITEM ];
	var item_frames = [FRAME_GLASS, 0, FRAME_MIRROR];
	var item_prices = [5, 5, 15];	
		
	//Dialog options
	var initial_choice_question = "@Which item?@"; //arms or armor? etc
	var askIfInterested1 = "@That item costs ";
	var askIfInterested2 = " gold. Interested, " + polite_title + "?@";
	var cant_afford = "@But thou dost not have enough gold, " + polite_title + "!@"; 
	var cant_hold = "@But 'twould make thee o'erburdened, " + polite_title + "!@";
	var saidNo = "@Very well.@";
	var nothing = "@Anything else can I do for thee?@";
	var success = "@Excellent!@ After accepting your gold, Dale hands over the ";
	var success2; //"I hope this item works well for you!" etc if needed
	var has_quantity;
	var ask_quantity;
	
	if (UI_get_schedule_type(item) == TEND_SHOP)
	{
		UI_set_item_flag(item, SHOP_IS_OPEN);
		UI_error_message("Shop is open");
	}
		
	//this makes sure you can talk to them still if their shop is open (convo function turns it to TALK)
	var shop_is_open = UI_get_item_flag(item, SHOP_IS_OPEN);
	
	
	
	
	//group together dialog options in array for cleaner look
	var dialog = [initial_choice_question, askIfInterested1, askIfInterested2, cant_afford, cant_hold, saidNo, nothing, success, success2];
	
	
	//READ flag used to initiate conversations via TALK
	var started_talking = UI_get_item_flag(item, READ);

	if (player_is_female) //
	{
	//	pronoun = "  ";
	//	title = "madame";
	}
	else 
	{
	//	pronoun = " ";
	//	title = " ";
	}
	
	//determine single/plural greeting - change as needed
	if (partynum > 1)
		greeting = "friends"; 
	else greeting = "friend"; //Avatar is solo
	
	const int GLASS_SELL_PRICE = 5;
	
	const int GEM_BUY_PRICE = 30;
	
	const int JAR_SELL_PRICE = 5;
	const int MIRROR_SELL_PRICE = 15; //or large mirror?

	if (event == DOUBLECLICK)
	{
		//Avatar and NPC greeting barks
		var av_1st_greet = "@Hello there..@";
		var npc_1st_greet = "@Mmmhmm, yes?@";
				
		var av_2nd_greet  = "@Might we speak again?@";
		var npc_2nd_greet = "@Avatar, hello!@";	
		
		//call convo script
		startConvo(item, av_1st_greet, npc_1st_greet, av_2nd_greet, npc_2nd_greet); 
	}
	
	if (started_talking)
	{
		//reset schedule for after convo
		UI_run_schedule(item);
		
		if (!UI_get_item_flag(item, MET))
		{
			item.say("A short, barrel-chested man.*");
			UI_set_item_flag(item, MET);
		}
		item.say("@A good " + time_of_day + " to thee, Avatar.@");
		
		//standard conversation options
		var options = ["name", "job", "bye"];
		
		if (UI_get_item_flag(item, SI_ZOMBIE))
			add("glass sword");
		
		//knows he needs a human lens
		if (gflags[LENS])
			add("lens");
			


	/////////////////////////////////////////////////////////////////////
	// Main conversation thread

	/////////////////////////////////////////////////////////////////////
		converse(options)
		{
			case "name"(remove):
				say("@I am Dale the Glassblower@");
				
			case "job"(remove):
				say("@I make glassware, the finest in the land!@");
  				add(["glassware"]); 

			case "glassware"(remove):
				say("@If you'd like to buy some of my glassware, just say the word!@");
				add(["buy", "sell"]); 

			case "glass sword"(remove):
				say("@Aye, I know how to make glass swords. But there is little demand for them.@");
				add(["demand"]);

			case "demand"(remove):
				say("@I require five gems for the crafting. This is too expensive for most. Aye, but things of beauty they are...@");
				add(["beauty"]);

			case "beauty"(remove):
				say("@Thou seemst like a person who appreciates art. I'll make thee one, if thou hast the gems.@");
				add(["gems"]);

			case "gems"(remove):
				if (UI_get_schedule_type(item) != TEND_SHOP)
					say("@Come to my shop when it's open!@"); 
				else 
				{
					say("@Aye, a glass sword needs fine gems to complete its beauty!@");  
					if (UI_count_objects(PARTY, SHAPE_GEMS, QUALITY_ANY, FRAME_ANY) < 5) //
						say("@Sorry, " + player_name + ", you haven't enough gems.@");  
					else 
					{
						say("@Aye, " + player_name + ", I see the gems you carry. Dost thou wish me to craft thee a glass sword?@"); 
						if (askYesNo())
						{
							say("@It will cost thee 5 gems! Art thou certain?@");
							if (askYesNo())
							{
								say("Dale turns to the furnace and begins crafting the sword. Soon it is finished, and you marvel at its beauty!*");
								say("@There she is, and a finer work thou'lt never see!@");  
								UI_add_party_items(1, SHAPE_GLASS_SWORD, QUALITY_ANY, FRAME_ANY, false);
								UI_remove_party_items(5, SHAPE_GEMS, QUALITY_ANY, FRAME_ANY, false);
							}
							else
								say("@Hmm@, he scowls, @perhaps I was mistaken about thee.@");  
						}
						else
							say("@Hmm@, he scowls, @perhaps I was mistaken about thee.@");  
					}
				}
				
			case "lens"(remove):
				say("@Hmmm...You'd have to see a lensmaker about that. I hear there's one near the Lycaeum.@");
				
			case "sell"(remove):
				say("@Do you have any gems to sell me?@");
				if (askYesNo())
				{
					var gem_count = UI_count_objects(PARTY, SHAPE_GEMS, QUALITY_ANY, FRAME_ANY);
					UI_error_message("Gem amount is " + gem_count);
					if (gem_count > 0)
					{
						say("@I will give thee " + GEM_BUY_PRICE + " for each gem. Agreeable?@");
						if (askYesNo())
						{
							
							say("@How many gems dost thou wish to sell?@");
							var quantity = UI_input_numeric_value(0, gem_count, 1, 1);
							
							if (quantity > 0)
							{
								UI_add_party_items(quantity * GEM_BUY_PRICE, SHAPE_GOLD, QUALITY_ANY, FRAME_ANY, false);
								UI_remove_party_items(quantity, SHAPE_GEMS, QUALITY_ANY, FRAME_ANY, false);
								
								say("@Great!@ Dale takes your gems and gives you your gold.");
							}
							else
								say("@Hmm@, he scowls, @Maybe some other time then..@");
							
						}
						else
							say("@Hmm@, he scowls, @Maybe some other time then..@");
					
					}
					else
						say("@I don't see any gems.@");
	
				}
				else
					say("@I'm always needing them for my glassblowing, let me know when you want to sell any.@");
					
			case "buy"(remove):
				if (!shop_is_open)
					say("@Come to my shop when it's open!@"); 
				else
					buyItems(DALE, item_options, item_prices, item_shapes, item_frames, dialog);
		
			case "bye":
				
				var avatar_goodbye = "@Farewell!@";
				var npc_goodbye = "@A fine " + time_of_day + " to thee!@";
				
				//function that is called, do not change this:
				sayGoodbye(item, npc_goodbye, avatar_goodbye);
				break;
	
		}                               
	}
	else scheduleBarks(item);
}