
void Selganor object# (0x458) ()
{

	var party = UI_get_party_list();
	var player_name = getAvatarName();
	var polite_title = getPoliteTitle();
	var hour = UI_game_hour();
	var partynum = UI_get_array_size(party);
	var bark;
	var player_is_female = UI_is_pc_female();
	var greeting; //When addressing party as plural or singular
	var avatar_bark;
	var npc_bark;
	var time_of_day = timeFunction(hour);
	var schedule = UI_get_schedule_type(item); //use for schedule specific convos
	var current_schedule = schedule; 
	
	//Flags used for conversation flags 
	// use PETRA, SI_ZOMBIE, FREEZE, NAKED, POLYMORPH
	
	var asked_about_rune = UI_get_item_flag(item, SI_ZOMBIE);
	var isabella_balloon = UI_get_item_flag(item, PETRA);
	var gave_rune = UI_get_item_flag(item, FREEZE);
	
	//READ flag used to initiate conversations via TALK
	var started_talking = UI_get_item_flag(item, READ);

	if (player_is_female) //
	{
	//	pronoun = "  ";
	//	title = "madame";
	}
	else 
	{
	//	pronoun = " ";
	//	title = " ";
	}
	
	//determine single/plural greeting - change as needed
	if (partynum > 1)
		greeting = "friends"; 
	else greeting = "friend"; //Avatar is solo
	
	
	if (event == DOUBLECLICK)
	{
		//Avatar and NPC greeting barks
		var av_1st_greet = "@Greetings, bard!@";
		var npc_1st_greet = "@Hello and welcome, " + polite_title + ".@";
				
		var av_2nd_greet  = "@Hello again, Selganor.@";
		var npc_2nd_greet = "@Ah yes, welcome back!@";	
		
		//call convo script
		startConvo(item, av_1st_greet, npc_1st_greet, av_2nd_greet, npc_2nd_greet); 
	}
	
	if (started_talking)
	{
		//reset schedule for after convo
		UI_run_schedule(item);
		
		if (!UI_get_item_flag(item, MET))
		{
			item.say("You see a a slender, graceful man tuning a lute.");
			item.say("@Oh, hello. Maybe you can help me with something. My nephew is studying alchemy, and he needs to know this.@"); 
			item.say("He asks you a few alchemy questions and you answer them.");
			item.say("@Thanks! Now what can I do for you?@");
			UI_set_item_flag(item, MET);
		}
		else 
			item.say("@A pleasure to see thee again, " + player_name + ". What wouldst thou speak of?@");
		
		//standard conversation options
		var options = ["name", "job", "bye"];
		
		//either learned about balloon or asked Isabella about it
		if (gflags[LEARNED_ABOUT_FLYING] || gflags[LEARNED_ABOUT_BALLOONIST])
			add("balloon");
			
		if (gflags[JOINED_ARTISANS_GUILD])
			add(["Julia", "Gwenno", "panpipes"]);
			
		if (asked_about_rune)
			add("rune");			
			
		
		if (UI_get_item_flag(ISABELLA, MET))
			add ("Lady Isabella");
		
		if (UI_get_item_flag(GWENNO, MET))
			add ("Gwenno");
			
		if (UI_get_item_flag(JULIA, MET))
			add ("Julia");

	/////////////////////////////////////////////////////////////////////
	// Main conversation thread

	/////////////////////////////////////////////////////////////////////
		converse(options)
		{
			case "name"(remove):
				say("@My name is Selganor. 'Tis a name with a long history... But you have the look of one with more important business.@");
				add(["business","history"]);

			case "job"(remove):
				say("@I am the guildmaster of artisans.@");

			case "history"(remove):
				say("@It means 'seeker of the crystal'. Perhaps I'll tell you more some other time.@");
				add(["crystal"]);

			case "crystal"(remove):
				say("@That's quite a tale.@");
				add(["tale"]);

			case "tale"(remove):
				say("@Indeed.@");
				
			case "business"(remove):
				say("@Perhaps you're interested in joining the guild.@");
				add(["join guild"]);

			case "rune"(remove):
				if (gflags[JOINED_ARTISANS_GUILD])
					say("@I already loaned you the rune.@");
				else
					say("@I'd be glad to loan you the rune, but only members of the guild are allowed to handle it.@");
				add(["join guild"]);
			
			case "join guild"(remove):
				if (!gflags[JOINED_ARTISANS_GUILD])
				{ 
					if (!gflags[ASKED_SELGANOR_ABOUT_RUNE])
						gflags[ASKED_SELGANOR_ABOUT_RUNE] = true; 
					
					say("@If you want to join the guild, you need to do two things. First, you need to make a set of panpipes. Julia can teach you how to that. You also need to commit 'Stones' to memory. 'Tis a simple tune - ask Gwenno to play it for thee.@");
					add(["Julia", "panpipes", "Gwenno"]);
				}
				else 
					say("@Wait a minute... You're already a member of the guild!@");
					
			case "panpipes"(remove):
				if (!gflags[JOINED_ARTISANS_GUILD])
				{
					say("@Have you made a set of panpipes?@");
					if (askYesNo())
					{
						if (UI_count_objects(PARTY, SHAPE_PANPIPES, QUALITY_ANY, FRAME_ANY) >= 1)
						{
							say("He inspects the pipes. @Very good, very good indeed. Now play the sequence of notes in 'Stones' and I'll induct you into the guild.@"); //going with SNES version where you play
							//script Avatar?
							add(["play 'Stones'"]);
						}
						else
							say("@But I don't see any!@");
						
						}
						else
						{
							say("@Oh. Well, Julia can show you how if you need help.@");
							add(["Julia"]);
						}
					}
					else
						say("@You should play your panpipes often - 'twill lighten your step on the long road ahead.@");

			case "Julia"(remove):
				if (isNearby(JULIA))
					say("@Yes, ask her about it.@");
				else 
				{
					say("@She made my lute - and most of our other instruments as well. She lives just across the road, next door to Lady Isabella.@");
					add(["lute", "Lady Isabella"]);
				}
				
			case "Lady Isabella"(remove):
				say("@She's the mayor.@");
			
			case "Gwenno"(remove):
				say("@I know she's around here somewhere...@");
				if (isNearby(GWENNO))
				{
					GWENNO.say("@I'm right here, Selganor!@");
					GWENNO.hide();
					say("@Ah, I knew you'd be somewhere close by.@");
				}
			
			case "lute"(remove):
				say("@I prefer stringed instruments. They make such lovely sounds.@");
				
			case "balloon"(remove):
				say("@Oh, are you looking for the man who invented the balloon?@ He stares upward, stroking his chin pensively. @Ah yes, now I remember. He flew to Sutek's castle. Said something about a big job he had to do there.@");
				if (!gflags[LEARNED_ABOUT_BALLOONIST])
					gflags[LEARNED_ABOUT_BALLOONIST] = true;  //flag used to prompt Sutek convo
				add(["Sutek"]);

			case "Sutek"(remove):
				say("@Sutek lives on an island, far to the south.@");
				
			case "island"(remove):
				say("@It's east of Serpent's Hold.@");

			case "play 'Stones'"(remove):
				say("@Now play the first verse of 'Stones' on the panpipes and I'll induct you into the guild.@");
				//add song?
				if (!gflags[LEARNED_STONES])
				{
					say("You attempt to play the notes of 'Stones' on your panpipes --horribly.");
					if(isNearby(IOLO))
					{
						IOLO.say("Iolo cringes, and shakes his head.");
						IOLO.hide();
					}
					say("@No, I'm afraid that's not it. Gwenno can help you learn the notes.@");
				}
				else 
				{
					say("You play the first verse of 'Stones' on your panpipes.*");
					UI_play_music(209, AVATAR);
					say("@Excellent!@ He strums a chord on his lute, then taps you lightly once on each shoulder with it.");
					
					say("@You are now a full member of the guild of artisans. He reaches into a belt-pouch, takes out the Rune of Sacrifice, and hands it to you.*");
					say("@I'm sure you'll be needing this in your travels. I know you'll find some solution to this gargoyle problem.@");
					UI_add_party_items(1, SHAPE_RUNE, QUALITY_ANY, FRAME_SACRIFICE);
				
					giveExperience(50);
					gflags[JOINED_ARTISANS_GUILD] = true;
				}
      				
			case "bye":
							
				var avatar_goodbye = "@Must be going now..@";
				var npc_goodbye = "@It was nice talking to you.@";
				
				//function that is called, do not change this:
				sayGoodbye(item, npc_goodbye, avatar_goodbye);
				break;
	
		}                               
	}
	else scheduleBarks(item);
}