
void CaptainJohne object# (0x46e) ()
{

	var party = UI_get_party_list();
	var player_name = getAvatarName();
	var polite_title = getPoliteTitle();
	var hour = UI_game_hour();
	var partynum = UI_get_array_size(party);
	var bark;
	var player_is_female = UI_is_pc_female();
	var greeting; //When addressing party as plural or singular
	var avatar_bark;
	var npc_bark;
	var time_of_day = timeFunction(hour);
	var schedule = UI_get_schedule_type(item); //use for schedule specific convos
	var current_schedule = schedule; 
	
	const int QUALITY_GARGISH_SCROLL = 54;
	
	var av_1st_greet;
	var npc_1st_greet;
				
	var av_2nd_greet;
	var npc_2nd_greet;	
	
	var avatar_goodbye;
	var npc_goodbye;
				
	
	//Flags used for conversation flags 
	// use PETRA, SI_ZOMBIE, FREEZE, NAKED, POLYMORPH
	var example = UI_get_item_flag(item, SI_ZOMBIE);
	
	
	//READ flag used to initiate conversations via TALK
	var started_talking = UI_get_item_flag(item, READ);

	if (player_is_female) //
	{
	//	pronoun = "  ";
	//	title = "madame";
	}
	else 
	{
	//	pronoun = " ";
	//	title = " ";
	}
	
	//determine single/plural greeting - change as needed
	if (partynum > 1)
		greeting = "friends"; 
	else 
		greeting = "friend"; //Avatar is solo
	
	if (event == DOUBLECLICK)
	{
		//Avatar and NPC greeting barks
		av_1st_greet = "@You there!@";
		npc_1st_greet = "@Praise the virtues!@";
				
		av_2nd_greet  = "@Captain Johne..@";
		npc_2nd_greet = "@Yes, Avatar?@";	
		
		//call convo script
		startConvo(item, av_1st_greet, npc_1st_greet, av_2nd_greet, npc_2nd_greet); 
	}
	
	if (started_talking)
	{
		//reset schedule for after convo
		UI_run_schedule(item);
	
		item.say("A long-haired gentleman with a scholarly demeanor.*");
		if (!UI_get_item_flag(item, SI_ZOMBIE)) //met flag isn't working on this?
		{
			item.say("@Praise the virtues! Humans have arrived here at last!@*");
			item.say("@But what's this? Not just any humans--the Avatar!@*");
			item.say("@'Tis most fortuitous that thou hast returned, noble " + player_name + ".@*");
			item.say("@Many cataclysms have occurred since thou last visited Britannia!@");
			UI_set_item_flag(item, SI_ZOMBIE);
						
		}
		else 
			item.say("@Ah, my good friend! Thou hast returned!@");
		
		//standard conversation options
		var options = ["name", "job", "bye", "cataclysms"];
	
	/////////////////////////////////////////////////////////////////////
	// Main conversation thread
	/////////////////////////////////////////////////////////////////////
		converse(options)
		{
			case "name"(remove): 
				say("@Why, I'm Captain Johne, " + polite_title + "!@");
			
			case "job"(remove):
				say("@For several years I have been here in the catacombs, studying the gargoyles.@");
  				add(["studying", "gargoyles"]); 

			case "cataclysms"(remove): 
				say("@The gargoyle world, once as large as Britannia itself, is slowly being destroyed!@*");
				say("@The forces thou set in motion have caused great sections of their land to fall off into the void!@*");
				say("@Only a single gargoyle city remains.@");	
				add(["city"]); 
				

			case "studying"(remove): 
				say("@Yes, I have learned much about them!@*");
	
				if (!UI_get_item_flag(item, PETRA)) //Petra flag used if haven't asked about tablet yet
				{
					say("@I had a silver tablet that contained much of what I had learned.@*");
					say("@I gave it to some gypsies to take to Mariah, at the Lycaeum.@*");
					say("@Did it arrive safely?@*");
					if (askYesNo())
					{
						say("@Good! I am glad to know that the gypsies kept their word.@*");
						say("@That tablet must have amazed Mariah!@*");
					}
					else 
					{
						say("@No?! But I paid money, good money, for them to carry it to her!@*");
						say("@No matter. Now that thou art here, all is well.@*");
						say("@You can study the gargoyles yourself, and carry the knowledge back to the surface!@");
					}
					UI_set_item_flag(item, PETRA);
				}

				

			case "gargoyles"(remove): 
				say("@They are not evil, as most humans believe!@");
				say("@I have spent much time talking to them, and I have found them to be almost human.@");
				say("@I have learned about their society, their beliefs, and their language.@");
				add(["society", "beliefs", "language"]); 

			case "society"(remove): 
				say("@There are two kinds of gargoyles, winged and wingless ones.@");
				say("@At first it seemed as if the wingless ones were slaves.@*");
				say("@But now I know that the wingless ones are beloved and valued family members.@*");
				say("@They must be told what to do, because they are not truly intelligent.@*");
				say("@The gargoyles live honorably, by their own set of beliefs.@*");

			case "beliefs"(remove): 
				say("@The gargoyles' beliefs are much like our own.@");
				say("@Where we have the three principles of Truth, Love and Courage,@*");
				say("@they have the principles of Control, Passion and Diligence.@*");
				say("@Directly, these lead to the virtues of Direction, Feeling, and Persistence.@*");
				say("@Combined, they lead to Balance, Achievement and Precision.@*");
				say("@Taken all together, they point to Order.@*");
				say("@And the sum of all the principles is Singularity.@*");
				say("@Gargoyle society stresses unity and singularity in all things.@*");
				say("@They have to; their world has always been harsh, even before the cataclysms.@*");
			

			case "language"(remove): 
				say("@With the help of a gargoyle child, Beh Lem, I have learned how to speak their language.@");
				if (!UI_get_item_flag(item, CONFUSED)) //Confused flag for when he gives scroll first
				{
					say("@Wouldst thou like to learn?@");
					if (askYesNo())
					{
						say("@Here.@ He hands you a scroll.*");
						UI_add_party_items(1, SHAPE_SCROLL, QUALITY_GARGISH_SCROLL, 1, true);	
						say("@Use this scroll- it contains a basic vocabulary of the Gargoyle language.@");
						UI_set_item_flag(item, CONFUSED); //to prevent giving more than 1 scroll
					}
					else 
						say("@But you must! Thou hast no chance of saving the gargoyles if thou knowest not their language!@");
				}	
				add(["Beh Lem"]); 

			case "city"(remove): 
				say("@The gargoyle City of Investigation, their place of learning and government, is all that is left.@");
				say("@Thou must do something to save the gargoyle race!@*");
				say("@I know not what, however.@*");
				say("@Thou must talk to the gargoyles.@");
				add(["gargoyles"]); 

			case "Beh Lem"(remove): 
				say("@He and I meet every day at noon, where Hythloth emerges in the gargoyle lands.@*");
				say("@Go and speak with him, learn about the gargoyles.@*");
				say("@You must save them!@*");
				add(["join"]); 

			case "join"(remove): 
				say("@No, I cannot. I must stay here and continue my writing.@");
				say("@But Beh Lem may join thee. With his help, thou canst travel the gargoyle lands and learn how to save them.@");
				

				
			case "bye":
				if (!UI_set_item_flag(item, NAKED))
				{
					say("@Wait! Thou must meet Beh Lem and travel with him among the gargoyle people.@");
					say("@That is the only way you can save them, and save them you must!@");
					say("@And without Beh Lem with you, the gargoyles will attack!@");
					UI_set_item_flag(item, NAKED);
					
				}

				else 
				{
					say("@Farewell again, noble Avatar. As the gargoyles say, 'May thy persistence and precision lead to success.@*");
									
				}
				
				avatar_goodbye = "@Farewell, Captain.@";
				npc_goodbye = "@Upon you rests the future of an entire race.@";
				
				//function that is called, do not change this:
				sayGoodbye(item, npc_goodbye, avatar_goodbye);
				break;
	
		}                               
	}
	else scheduleBarks(item);
}