void SinVraal object# (0x4b5) ()
{

	var party = UI_get_party_list();
	var player_name = getAvatarName();
	var polite_title = getPoliteTitle();
	var hour = UI_game_hour();
	var partynum = UI_get_array_size(party);
	var bark;
	var player_is_female = UI_is_pc_female();
	var greeting; //When addressing party as plural or singular
	var avatar_bark;
	var npc_bark;
	var time_of_day = timeFunction(hour);
	var schedule = UI_get_schedule_type(item); //use for schedule specific convos
	var current_schedule = schedule; 
	
	var av_1st_greet;
	var npc_1st_greet;
				
	var av_2nd_greet;
	var npc_2nd_greet;	
	
	var avatar_goodbye;
	var npc_goodbye;
	
	var pronoun;
	
	//For schedule specific behavior - Change WAITER with the 'working' schedule of the npc (BLACKSMITH/ TEND SHOP / etc)
	if (UI_get_schedule_type(item) == WAITER)
	{
		UI_set_item_flag(item, SHOP_IS_OPEN);
		UI_error_message("Shop is open");
	}
		
	//this makes sure you can talk to them still if their shop is open (convo function turns it to TALK)
	var shop_is_open = UI_get_item_flag(item, SHOP_IS_OPEN);
				
	
	//Flags used for conversation flags 
	// use PETRA, SI_ZOMBIE, FREEZE, NAKED, POLYMORPH
	var example = UI_get_item_flag(item, SI_ZOMBIE);
	
	
	//READ flag used to initiate conversations via TALK
	var started_talking = UI_get_item_flag(item, READ);

	if (player_is_female) //
	{
	//	pronoun = "  ";
	//	title = "madame";
	}
	else 
	{
	//	pronoun = " ";
	//	title = " ";
	}
	
	//determine single/plural greeting - change as needed
	if (partynum > 1)
		greeting = "friends"; 
	else 
		greeting = "friend"; //Avatar is solo
	
	if (event == DOUBLECLICK)
	{
		//Avatar and NPC greeting barks
		av_1st_greet = "@Hold, gargoyle!@";
		npc_1st_greet = "@Greetings, False Prophet.@";
				
		av_2nd_greet  = "@Hello again..@";
		npc_2nd_greet = "@Welcome back, Virtuous One.@";	
		
		//call convo script
		startConvo(item, av_1st_greet, npc_1st_greet, av_2nd_greet, npc_2nd_greet); 
	}
	
	if (started_talking)
	{
		//reset schedule for after convo
		UI_run_schedule(item);
		
		item.say("@The daemon Sin'Vraal.");
		item.say("@Good " + time_of_day + ", " + polite_title +".@");
		
		//standard conversation options
		var options = ["name", "job", "bye"];
		
		if (gflags[TALKEDTOHOMERABOUTMAP])
			add("pirate");
			
		if (gflags[MARIAH_READ_TABLET])
			add("Book of Prophesies");

	/////////////////////////////////////////////////////////////////////
	// Main conversation thread
	/////////////////////////////////////////////////////////////////////
		converse(options)
		{
			case "name"(remove): 
				say("@I am Sin'Vraal.@*");
		
			case "job"(remove):
				say("@No job, " + polite_title + ". I am free to wander where I wish.@");
				add(["free"]); 

			case "free"(remove): 
				say("@Among my people, those who can fly rule. Though I have wings, I cannot fly. So I was a slave.@*");
				say("@Here I am free!@");
				add(["fly", "people"]); 

			case "fly"(remove): 
				say("@There are two kinds of gargoyles: winged ones and wingless ones.@*");
				say("@Wingless ones are mute and unintelligent. They do all the manual labor.@*");
				say("@Winged ones are smart, and do all the  planning and leading. Being able to fly is, to them, a sign of intelligence.@*");
				say("@Even the Temple can only be reached by air.@*");
				add(["intelligence", "Temple"]); 

			case "people"(remove): 
				say("@I am not a daemon, though humans think so. I am a gargoyle.@*");
				add(["gargoyle"]); 

			case "gargoyle"(remove): 
				say("@I fled here to the Underworld because I was not free among the gargoyles.@*");
	
			case "intelligence"(remove): 
				say("@Yes, a strange concept this.@*");
				say("@Yet as some in Minoc can tell you, flying can be achieved by anyone.@*");
				if (!gflags[LEARNED_ABOUT_FLYING])
					gflags[LEARNED_ABOUT_FLYING] = true; //set for asking people in minoc about balloon. 
		
			case "Temple"(remove): 
				say("@The great Temple of Singularity held the Codex. The Temple is the most holy gargoyle place. A human could learn much by traveling there.@*");
				say("@But you could never get to the temple. Not only is it deep below the surface, but it can only be reached by flying.@");
			
			case "pirate"(remove): 
				say("@Yes, I once met a pirate here in the desert. He seemed to be hunting me, but he got dragged off by the ants!@*");
				add(["ants"]); 

			case "ants"(remove): 
				say("@The great desert ants build huge mounds, and are very dangerous!@*");
				
			case "Book of Prophesies"(remove): 
				say("@The Book of Prophecies says that the False Prophet will come to destroy the gargoyle race.@*");
				say("@Only the sacrifice of the False Prophet will save us.@*");
				add(["sacrifice"]); 

			case "sacrifice"(remove): 
				say("@Sacrifice means many things in my language.@*");
				say("@You should seek out a gargoyle scholar to learn more. Travel the other side of the world, and you should be able to find one.@*");
				say("@You can go down through Hythloth to get to the realm of gargoyles.@*");
				if (!gflags[LEARNED_ABOUT_HYTHLOTH])
				{
					gflags[LEARNED_ABOUT_HYTHLOTH] = true;
					//reveal guards with key
					UI_clear_item_flag(HYTH_GUARD1, DONT_RENDER);
					UI_clear_item_flag(HYTH_GUARD2, DONT_RENDER);
					UI_clear_item_flag(HYTH_GUARD3, DONT_RENDER);
					
					//should cause guards to go on regular schedule - patrol / pace
					UI_run_schedule(HYTH_GUARD1);
					UI_run_schedule(HYTH_GUARD2);
					UI_run_schedule(HYTH_GUARD3);
				
				}
				
	
			case "bye":
						
				avatar_goodbye = "@Goodbye!@";
				npc_goodbye = "@May your persistence and precision lead to success!@";
				
				//function that is called, do not change this:
				sayGoodbye(item, npc_goodbye, avatar_goodbye);
				break;
		
		}                               
	}
	else scheduleBarks(item);
}