var juliaInHouse(var location)
{
	//Rect of Julia's house - 
	var top_left = [1921, 0225];
	var bottom_right = [1950, 0238];
	
	if ((location[X] >= top_left[X] && location[X] <= bottom_right[X]) && (location[Y] >= top_left[Y] && location[Y] <= bottom_right[Y])) 
		return true;
	else
		return false;

}


void Julia object# (0x408) ()
{

	var party = UI_get_party_list();
	var player_name = getAvatarName();
	var polite_title = getPoliteTitle();
	var hour = UI_game_hour();
	var partynum = UI_get_array_size(party);
	var bark;
	var player_is_female = UI_is_pc_female();
	var greeting; //When addressing party as plural or singular
	var avatar_bark;
	var npc_bark;
	var time_of_day = timeFunction(hour);
	var schedule = UI_get_schedule_type(item); //use for schedule specific convos
	var current_schedule = schedule; 
	
	var av_1st_greet;
	var npc_1st_greet;
				
	var av_2nd_greet;
	var npc_2nd_greet;	
	
	var avatar_goodbye;
	var npc_goodbye;
	
	var pronoun;
	var title;
	
	
				
	
	//Flags used for conversation flags 
	// use PETRA, SI_ZOMBIE, FREEZE, NAKED, POLYMORPH
	var joined_party_before = UI_get_item_flag(item, PETRA); //allows join/leave
	
	//for Julia's leave conversation - won't leave party if shes in her house. 
	var julia_location = UI_get_object_position(item);
	
	//var on_water = UI_is_water([julia_location]);
	var on_water = UI_is_water([julia_location[X], julia_location[Y], 1]);
	
		UI_error_message("On water is: " + on_water);
	if (on_water)
		UI_error_message("Julia is on water");
	else
		UI_error_message("Julia is NOT on water");
	
	//READ flag used to initiate conversations via TALK
	var started_talking = UI_get_item_flag(item, READ);

	if (player_is_female) //
	{
		pronoun = "she";
		title = "her ladyship";
	}
	else 
	{
		pronoun = "he";
		title = "his lordship";
	}
	
	//determine single/plural greeting - change as needed
	if (partynum > 1)
		greeting = "friends"; 
	else 
		greeting = "friend"; //Avatar is solo


	if (event == DOUBLECLICK)
	{
		//Avatar and NPC greeting barks
		av_1st_greet = "@Greetings, my friend..@";
		npc_1st_greet = "@Ach! 'Tis the Avatar!@";
				
		av_2nd_greet  = "@Hello, Julia.@";
		npc_2nd_greet = "@Yes?@";	
		
		//call convo script
		startConvo(item, av_1st_greet, npc_1st_greet, av_2nd_greet, npc_2nd_greet); 
	}
	
	if (started_talking)
	{
		//reset schedule for after convo
		UI_run_schedule(item);
		
	
		if (inParty(item))
		{
			item.say("@Aye, and wha' can ye be askin' of me?@*");
			item.say("@Sure an' I don't think I can be helpin' ya with this!@");
		}
		else if (gflags[ASKED_JULIA_TO_LEAVE])
		{
			item.say("@Aye, so the great Avatar deigns to return, does " + pronoun + "? Well, what does " + title + " want now?@");
				
		}
		else if (!UI_get_item_flag(item, MET))
		{
			UI_set_item_flag(item, MET); 
			item.say("A sturdy woman with calloused hands and a loud manner.*");
			item.say("@Well, then the rumors are true!@*");
			item.say("@'Tis well and good that ye have returned to our land, Avatar!@");
		
		}
		else
			item.say("@Well met, Avatar. An' what can I be doin' for ye this " + time_of_day + "?@");
			
		//standard conversation options
		var options = ["name", "job", "bye"];
	
		if (joined_party_before)
			add (["join", "leave"]);
			
		if (inParty(item))
			add("leave"); 
		

		//learned that Julia can make panpipes from Selganor	
		if (gflags[ASKED_SELGANOR_ABOUT_RUNE])
			add("panpipes");
	
	//global flags to add that give new convo options:		
	
	/////////////////////////////////////////////////////////////////////
	// Main conversation thread
	/////////////////////////////////////////////////////////////////////
		converse(options)
		{
			case "name"(remove):
				say("@Sure and you're goin' daft, " + polite_title + ". I be named Julia, same as the last time we met!@");
								
			case "job":
				say("@Instruments I make, the finest in the land.@*");
				if (!item in party)
					say("@For now, though, I'm followin' ye, and glad to do it!@");
				
				else 
				{
					say("@Not to be immodest, but I'm respected by all the Guild!@*");
					say("@Ach, but give it all up I would for a life of adventure like your own...@");
					add(["Guild", "adventure"]); 
				}

			case "Guild"(remove):
				say("@If ye would like to be a member too, go talk to Selganor.@");
  				add(["Selganor"]); 

			case "adventure"(remove):
				say("@Aye, I'd join you if ye wish.@"); 
				add(["join"]);


			case "Selganor" (remove):
				say("@He's the guildmaster.@");
  				

			case "panpipes"(remove):
				say("@Sent you to me they did? Aye, I can believe that.@*");
				say("@Now the panpipes are a tricky instrument. You gotta have the finest wood.@*");
				say("@If you want to learn how to make pipes, you'll need to bring a yew board.@*");
				say("@But it must be freshly cut!@");
  				add(["board", "cut"]); 

			case "board"(remove):
				say("@Do ye have a fine yew board for me today?@");
				if (askYesNo())
				{
					if (UI_count_objects(PARTY, SHAPE_YEW_BOARD, QUALITY_ANY, FRAME_ANY) > 0) 
					{
						say("@Ach, aye, and good wood it is, too. A fine set of pipes this will make!@*");
						say("Julia sets the wood down on a bench and starts carving. As you watch, the rough board slowly turns into smooth wood rods.*");
						say("Then she hollows out each rod and pegs them all together. Lastly, she notches each tube and cuts them all to the proper lengths.*");
						say("@An' there it is, " + polite_title + ", a set of panpipes fit for any bard in the land!@*");
						say("She hands you the finished pipes.");
						UI_remove_party_items(1, SHAPE_YEW_BOARD, QUALITY_ANY, FRAME_ANY, true);
						UI_add_party_items(1, SHAPE_PANPIPES, QUALITY_ANY, FRAME_ANY, true);
					}
					else
						say("@Well where is it? I canna see any board on ye!@");
				}
				else 
				{
					say("@No? What are ye, daft? I canna be makin' pipes without wood!@*");
					say("@Go to Yew where they grow the best wood in Britannia. Buy a freshly-cut yew log and take it to a sawmill.@*");
					say("@Have 'em cut it into a board, and bring it back here. Then I'll show ye how panpipes are made!@");
				}

			case "cut"(remove):
				say("@Go to Yew where they grow the best wood in Britannia. Buy a freshly-cut yew log and take it to a sawmill.@*");
				say("@Have 'em cut it into a board, and bring it back here. Then I'll show ye how panpipes are made!@");

			case "join"(remove):
				say("@Join ye? Me?@*");
				if (item in party)
				{
					say("@I'm already in your band! Though now I'm not so sure I want to be led by a crazy person...@");
  				}
				else if (gflags[ASKED_JULIA_TO_LEAVE])
				{
					say("@Aye, and be dumped off in the middle of nowhere again?@*");
					say("@Not likely! Find some other sap to do your bidding!@");
				}
				
				else if (UI_get_array_size(party) < 8)	
				{
					say("@Aye, gladly!@");
					UI_add_to_party(item);
					sayGoodbyeAbrupt(item, "Let's be on our way!");
					break;
					
				}
				else
					say("@Ach, I can tell that you say that to everyone ye meet. Ask me again when you haven't as many companions.@");



			case "leave" (remove):
				
				//not inside Julia's house
				if (!juliaInHouse(julia_location))
				{
					var julia_location = UI_get_object_position(item);
					if (UI_is_water([julia_location[X], julia_location[Y], 0])) //Julia is on the ship
					{
						say("@Leave?! And jump overboard?!@*");
						say("@Ach, I get it. You're makin' a wee joke!@");
										
					}
					else
					{
						say("@What? Oh, I suppose a craftsman isn't warrior enough to suit " + title + "'s tastes!@*");
						say("@Well, that's fine and dandy with me!@*");
						say("@A good day and a good bye to the lot of ye! I'm tired of carrying all this junk anyway!@");
						if (isEquipped(item, SHAPE_ANY))
						{
							var pos = UI_get_object_position(item);
							dropAllItems(item, pos);
						}
						gflags[ASKED_JULIA_TO_LEAVE] = true;								
					//
						script item
							call leaveParty, MOVE_NPC2;
							
						sayGoodbyeAbrupt(item, "Well, I never!");	
						break;
					}
				}
				else
					say("@Leave! Nay, 'tis my house. You do the leavin'!@");
			
			case "bye":

				if (item in party)
				{
					say("@Aye, enough chatting. On with our quest!@");
					sayGoodbye2(item);
					break;
					
				}
				else if (gflags[ASKED_JULIA_TO_LEAVE])
				{
					say("@Ach, aye! I wouldna want to hinder " + title + "'s journey!@");
					sayGoodbyeAbrupt(item, "Hmmmfff!!");
					break;
				}
				else
				{
					avatar_goodbye = "@Farewell Julia..@";
					npc_goodbye = "@May fortune follow ye on thy way!@";
					
					//function that is called, do not change this:
					sayGoodbye(item, npc_goodbye, avatar_goodbye);
					break;
				}				
				
			
	
		}                               
	}
	else scheduleBarks(item);
}