void Leodon object# (0x4dd) ()
{

	var party = UI_get_party_list();
	var player_name = getAvatarName();
	var polite_title = getPoliteTitle();
	var hour = UI_game_hour();
	var partynum = UI_get_array_size(party);
	var bark;
	var player_is_female = UI_is_pc_female();
	var greeting; //When addressing party as plural or singular
	var avatar_bark;
	var npc_bark;
	var time_of_day = timeFunction(hour);
	var schedule = UI_get_schedule_type(item); //use for schedule specific convos
	var current_schedule = schedule; 
	
	var av_1st_greet;
	var npc_1st_greet;
				
	var av_2nd_greet;
	var npc_2nd_greet;	
	
	var avatar_goodbye;
	var npc_goodbye;
				
	
	//Flags used for conversation flags 
	// use PETRA, SI_ZOMBIE, FREEZE, NAKED, POLYMORPH
	var joined_party_before = UI_get_item_flag(item, PETRA); //allows join/leave
	
	
	//READ flag used to initiate conversations via TALK
	var started_talking = UI_get_item_flag(item, READ);

	if (player_is_female) //
	{
	//	pronoun = "  ";
	//	title = "madame";
	}
	else 
	{
	//	pronoun = " ";
	//	title = " ";
	}
	
	//determine single/plural greeting - change as needed
	if (partynum > 1)
		greeting = "friends"; 
	else 
		greeting = "friend"; //Avatar is solo
	
	if (event == PROXIMITY)
	{
		if (UI_get_schedule_type(item) == KID_GAMES)
		{
			var barks = ["@Who threw that?!@",
					"@Oof!@",
					"@Take that!@",
					"@You call that a punch?!@",
					"@I'll cut you, matey!@",
					"@You spilled mine drink!@",
					"@Ungh!@"];
			var rand_barks = UI_get_random(UI_get_array_size(barks));
			UI_item_say(item, barks[rand_barks]);
			
		}
	}	

	if (event == DOUBLECLICK)
	{
		//Avatar and NPC greeting barks
		av_1st_greet = "@Excuse me, miss..@";
		npc_1st_greet = "@Aye?@";
				
		av_2nd_greet  = "@Leonna..@";
		npc_2nd_greet = "@Aye, Avatar?@";	
		
		//call convo script
		startConvo(item, av_1st_greet, npc_1st_greet, av_2nd_greet, npc_2nd_greet); 
	}
	
	if (started_talking)
	{
		//reset schedule for after convo
		UI_run_schedule(item);
		
		if ((UI_get_schedule_type(item) == KID_GAMES) && !inParty(item))
		{
			item.say("@Not now, " + polite_title + "!@ She ducks a punch. @I'm busy!@");
			sayGoodbyeAbrupt(item, "@Take that!@");
			return;
		}


		if (inParty(item))
		{
			item.say("@Yes, " + player_name + "?@");
		}

		else if (!UI_get_item_flag(item, MET))
		{
			UI_set_item_flag(item, MET); //sets met flag
			item.say("A woman with a slightly seaworn look, but delicate hands.");
		
		}
		else
			item.say("@A good " + time_of_day + " to you, " + polite_title + ". Come, have a seat and talk with us a while.@");
			
		//standard conversation options
		var options = ["name", "job", "bye"];
	
		if (joined_party_before)
			add (["join", "leave"]);
			
		if (gflags[LEARNED_ABOUT_CAPT_JOHNE])
			add("Captain Johne");			
		
	/////////////////////////////////////////////////////////////////////
	// Main conversation thread
	/////////////////////////////////////////////////////////////////////
		converse(options)
		{
			case "name"(remove):
				say("@I'm Captain Leodon.@");
				add(["captain"]);

			case "job"(remove):
				say("@I'm captain of the Golden Hind.@");
  				add(["Golden Hind"]); 

			case "Golden Hind"(remove):
				say("@Life on the sea is the only life for me. Alas, the Hind needs serious repairs just now.@");
				add(["sea", "repairs"]);

			case "repairs"(remove):
				say("@Yes, I must keep myself occupied on land, meantime. Perhaps I could join thy party for a time.@");
				add(["join"]);

			case "sea"(remove):
				say("@Ah, the sea. 'Tis as vast as a thousand dreams.@");
				add(["dreams"]);

			case "dreams"(remove):
				say("@Indeed.@");

			case "join"(remove):
				if (!inParty(item))
				{
					say("@The Golden Hind won't be repaired for months, at the soonest. Traveling with you would likely prove interesting. Would you like me to come along?@");
					if (askYesNo())
					{
						if (UI_get_array_size(party) < 8)	
						{
							say("@Very well. This should make a nice change from my usual routine. You might ask Leonna if she would like to join us as well.@"); 
							UI_add_to_party(item);
							sayGoodbyeAbrupt(item, "Let us be off then!");
							if (!UI_get_item_flag(item, PETRA)) //to allow join / leave options again
								UI_set_item_flag(item, PETRA); 
							break;
						}
						else
							say("@You have enough travelling with you already. But if you ask one of them to leave first, I'd be happy to join you.@");  //  Too many people in the party
					}
					else
						say("@Okay. I'll be here if you change your mind.@");
				}
				else
					say("@I'd be glad to join you--but I have already!@");  // If all ready in the party
		
			case "leave"(remove):
				say("@Has the time come for me to leave your crew?@");
				if (askYesNo())
				{
					say("@Do you want me to wait here, or go home?@");
					converse(["wait here", "go home"])
					{
					
						case "wait here":
							say("@Very well, I shall wait here for you to return.@");
							UI_remove_from_party(item);
							UI_set_schedule_type(item, WAIT);
							sayGoodbyeAbrupt2(item, "I'll be right here, matey.");
							break;
						
						case "go home":
							if (isEquipped(item, SHAPE_ANY))
							{
								var pos = UI_get_object_position(item);
								say("@Okay. I think I'll head back to the Fallen Virgin, then. Here's all the equipment I was carrying, if you need it.@");
								say("She sets down everything she was carrying before walking off.");  
								dropAllItems(item, pos);
							}
							else
								say("@Okay. I think I'll head back to the Fallen Virgin, then.@");
							script item
								call leaveParty, MOVE_NPC2;
							sayGoodbye2(item);	
							break;
					}
				}			
					
					
				else
					say("@Well, I shall stay with you then.@");

		
			case "captain"(remove):
				if ((isNearby(CAPTAIN_FOX)) || (isNearby(LEONNA)) || (isNearby(CAPTAIN_ELAD)) || (isNearby(HOMER)))	
					say("When you say 'Captain,' all the pirates at the table turn to you expectantly. When they realize you weren't talking to them, they return to their business.");  // Said out loud.
				
				say("@You wouldn't be talking about Captain Johne would you?@");
				add(["Captain Johne"]);
			

			case "Leonna"(remove):
				say("@Aye, Leonna is the best first mate I've ever had.@");
				if (isNearby(LEONNA))
				{
					LEONNA.say("@Leonna blushes and looks away, embarassed.@");  // 
					LEONNA.hide();
				}
				say("@Comes from being a captain once herself, you know.@");  

			case "Captain Johne"(remove):
				say("@That scallawag? He went down to the other side of the world to join up with the gargoyles, the dirty traitor...@");
				if (isNearby(CAPTAIN_ELAD))
				{
					CAPTAIN_ELAD.say("The tea-drinker interrupts. @No, no, you've got it all wrong! I can tell you the truth about Captain Johne.@");  
					CAPTAIN_ELAD.hide();
				}
				add(["gargoyles"]);

			case "gargoyles"(remove):
				say("@Vile creatures, they are. One of them attacked my ship once. He flew off with a ham before anyone could stop him.@");
				add(["ham"]);

			case "ham"(remove):
				say("@Yes, he stole my ham, and I dined on biscuits that night.@");
				add(["biscuits"]);

			case "biscuits"(remove):
				say("@That's right.@");

			case "bye"(remove):
				if (inParty(item))
				{
					say("@Back to our quest, eh " + polite_title + "?@");  
					avatar_goodbye = "@Nothing more..@";
					npc_goodbye = "@Lead on, matey.@";
				}
				else
				{
					say("@Drop by again next time you're in town.@");  // If not in pary

					avatar_goodbye = "@Farewell..@";
					npc_goodbye = "@A pleasure, matey.@";
				}
				//function that is called, do not change this:
				sayGoodbye(item, npc_goodbye, avatar_goodbye);
				break;
	
		}                               
	}
	else scheduleBarks(item);
}