void Leonna object# (0x4df) ()
{

	var party = UI_get_party_list();
	var player_name = getAvatarName();
	var polite_title = getPoliteTitle();
	var hour = UI_game_hour();
	var partynum = UI_get_array_size(party);
	var bark;
	var player_is_female = UI_is_pc_female();
	var greeting; //When addressing party as plural or singular
	var avatar_bark;
	var npc_bark;
	var time_of_day = timeFunction(hour);
	var schedule = UI_get_schedule_type(item); //use for schedule specific convos
	var current_schedule = schedule; 
	
	var av_1st_greet;
	var npc_1st_greet;
				
	var av_2nd_greet;
	var npc_2nd_greet;	
	
	var avatar_goodbye;
	var npc_goodbye;
				
	
	//Flags used for conversation flags 
	// use PETRA, SI_ZOMBIE, FREEZE, NAKED, POLYMORPH
	var joined_party_before = UI_get_item_flag(item, PETRA); //allows join/leave
	
	
	//READ flag used to initiate conversations via TALK
	var started_talking = UI_get_item_flag(item, READ);

	if (player_is_female) //
	{
	//	pronoun = "  ";
	//	title = "madame";
	}
	else 
	{
	//	pronoun = " ";
	//	title = " ";
	}
	
	//determine single/plural greeting - change as needed
	if (partynum > 1)
		greeting = "friends"; 
	else 
		greeting = "friend"; //Avatar is solo
//delete if not needed:	
	if (event == PROXIMITY)
	{
		if (UI_get_schedule_type(item) == KID_GAMES)
		{
			var barks = ["@Who threw that?!@",
					"@Oof!@",
					"@Take that!@",
					"@You call that a punch?!@",
					"@I'll cut you, matey!@",
					"@You spilled mine drink!@",
					"@Ungh!@"];
			var rand_barks = UI_get_random(UI_get_array_size(barks));
			UI_item_say(item, barks[rand_barks]);
			
		}
	}	

	if (event == DOUBLECLICK)
	{
		//Avatar and NPC greeting barks
		av_1st_greet = "@Greetings, milady..@";
		npc_1st_greet = "@Oh!@";
				
		av_2nd_greet  = "@Leonna..@";
		if (UI_get_schedule_type(item) != KID_GAMES)
			npc_2nd_greet = "@Yes, Avatar?@";	
		else
			npc_2nd_greet = "@...@";
		
		//call convo script
		startConvo(item, av_1st_greet, npc_1st_greet, av_2nd_greet, npc_2nd_greet); 
	}
	
	if (started_talking)
	{
		//reset schedule for after convo
		UI_run_schedule(item);
		
		if ((UI_get_schedule_type(item) == KID_GAMES) && !inParty(item))
		{
			item.say("You fail to get her attention in the midst of the brawl.");
			sayGoodbyeAbrupt(item, "@...@");
			return;
		}


		if (inParty(item))
		{
			item.say("@Yes, " + player_name + "?@");
		}
		else if (!UI_get_item_flag(item, MET))
		{
			UI_set_item_flag(item, MET); //sets met flag
			item.say("A smartly dressed woman. Her smile has a delightful subtlety to it.");
			item.say("@Oh, you must be " + player_name + ", the famous Avatar! 'Tis an honor to meet thee.@*");
		}
		else
			item.say("Her face lights up as she recognizes you. @Hello again, " + player_name + "!@");
			
		//standard conversation options
		var options = ["name", "job", "bye"];
	
		if (joined_party_before)
			add (["join", "leave"]);
	
		//global flags to add that give new convo options:		
		if (gflags[LEARNED_ABOUT_CAPT_JOHNE])
			add("Captain Johne");			
		
	/////////////////////////////////////////////////////////////////////
	// Main conversation thread
	/////////////////////////////////////////////////////////////////////
		converse(options)
		{
			case "name"(remove):
				say("@My name is Leonna.@");

			case "job"(remove):
				say("@I used to captain my own ship. But I fell on hard times, and now I sail with Leodon on the Hind.@");
  				add(["Leodon", "Golden Hind", "captain"]); 

			case "Golden Hind"(remove):
				say("@A fine old vessel, the Golden Hind. Alas, I have little to do while she's being repaired.@");
				add(["join"]);

			case "join" (remove):
				if (!inParty(item))
				{
					say("@Could I join your party, perhaps?@");
					if (askYesNo())
					{
						if (UI_get_array_size(party) < 8)	
						{
							say("@Oh good! I bet we'll meet a lot of interesting men...@");
							UI_add_to_party(item);
							add(["leave"]);
						}
						else
							say("@You have enough traveling with you already. But if you ask one of them to leave first, I'd be happy to join you.@");  // Too many people in the party
					}
					else
						say("@Okay. I guess I'll just stay here for now.@");
				}
				else
					say("@I'd be glad to join you--but I have already!@");  
		
			case "leave"(remove):
				say("@Has the time come for me to leave your crew?@");
				if (askYesNo())
				{
					say("@Do you want me to wait here, or go home?@");
					converse(["wait here", "go home"])
					{
						case"wait here":
							say("@Very well, I shall wait here for you to return.@");
							UI_remove_from_party(item);
							UI_set_schedule_type(item, WAIT);
							sayGoodbyeAbrupt2(item, "I shall wait here for thee.");
							break;
						
						case "go home":
							if (isEquipped(item, SHAPE_ANY))
							{
								var pos = UI_get_object_position(item);
								say("@Okay. I think I'll head back to the Fallen Virgin, then. Here's all the equipment I was carrying, if you need it.@");
								say("She sets down everything she was carrying before walking off.");  
								dropAllItems(item, pos);
							}
							else
								say("@Okay. I think I'll head back to the Fallen Virgin, then.@");
							sayGoodbye2(item);
							
							//function to make sure she goes back to proper map
							script item
								call leaveParty, MOVE_NPC2;
							break;				
					}
					
				}
				else
					say("@Well, I shall stay with you then.@");

		
			case "captain"(remove):
				if ((isNearby(CAPTAIN_FOX)) || (isNearby(LEONNA)) || (isNearby(CAPTAIN_ELAD)) || (isNearby(HOMER)))	
					say("When you say 'Captain,' all the pirates at the table turn to you expectantly. When they realize you weren't talking to them, they return to their business.");  // Said out loud.
				
				say("@You wouldn't be talking about Captain Johne would you?@");
				add(["Captain Johne"]);
				
			case "Leodon"(remove):
				say("@There's none I'd rather ship out with.@");	

			case "Leonna"(remove):
				say("@Aye, Leonna is the best first mate I've ever had.@");
				if (isNearby(LEONNA))
				{
					LEONNA.say("@Leonna blushes and looks away, embarassed.@");  // 
					LEONNA.hide();
				}
				say("@Comes from being a captain once herself, you know.@");  

			case "Captain Johne"(remove):
				say("@Captain Johne is a madman! He went down in Hythloth seeking a way to the other side of the world. Said he was going to kill as many gargoyles as he could before they got him.@");
				if (isNearby(CAPTAIN_FOX))
				{
					CAPTAIN_FOX.say("@That's not true!@ says Captain Fox. @I can tell you what really happened.@");  
					CAPTAIN_FOX.hide();
				}
				add(["gargoyles"]);


			case "gargoyles"(remove):
				say("@Please, let's not talk about them.@");
				
			case "bye"(remove):
				if (inParty(item))
				{
					avatar_goodbye = "@Nothing more..@";
					npc_goodbye = "@Lead on, matey.@";
				}
				else
				{
					avatar_goodbye = "@Goodbye..@";
					npc_goodbye = "@Talk to you later!@";
				}
				//function that is called, do not change this:
				sayGoodbye(item, npc_goodbye, avatar_goodbye);
				break;
	
		}                               
	}
	else scheduleBarks(item);
}