
void Loubet object# (0x4ec) ()
{

	var party = UI_get_party_list();
	var player_name = getAvatarName();
	var polite_title = getPoliteTitle();
	var hour = UI_game_hour();
	var partynum = UI_get_array_size(party);
	var bark;
	var player_is_female = UI_is_pc_female();
	var greeting; //When addressing party as plural or singular
	var avatar_bark;
	var npc_bark;
	var time_of_day = timeFunction(hour);
	var schedule = UI_get_schedule_type(item); //use for schedule specific convos
	var current_schedule = schedule; 
	var pronoun;
	var title;
	
	var av_1st_greet;
	var npc_1st_greet;
				
	var av_2nd_greet;
	var npc_2nd_greet;	
	
	var avatar_goodbye;
	var npc_goodbye;
	
	//For schedule specific behavior - Change WAITER with the 'working' schedule of the npc (BLACKSMITH/ TEND SHOP / etc)
	if (UI_get_schedule_type(item) == TEND_SHOP)
	{
		UI_set_item_flag(item, SHOP_IS_OPEN);
		UI_error_message("Shop is open");
	}
		
	//this makes sure you can talk to them still if their shop is open (convo function turns it to TALK)
	var shop_is_open = UI_get_item_flag(item, SHOP_IS_OPEN);
				
	
	//Flags used for conversation flags 
	// use PETRA, SI_ZOMBIE, FREEZE, NAKED, POLYMORPH
	var example = UI_get_item_flag(item, SI_ZOMBIE);
	
	
	//READ flag used to initiate conversations via TALK
	var started_talking = UI_get_item_flag(item, READ);

	if (player_is_female)
	{
		pronoun = "amie";
		title = "madame";
	}
	else 
	{
		pronoun = "ami";
		title = "m'sieur";
	}
	
	//determine single/plural greeting - change as needed
	if (partynum > 1)
		greeting = "friends"; 
	else 
		greeting = "friend"; //Avatar is solo
	
	if (event == DOUBLECLICK)
	{
		//Avatar and NPC greeting barks
		av_1st_greet = "@Greetings, milord..";
		npc_1st_greet = "@Bonjour!@";
				
		av_2nd_greet  = "@M'siuer Loubet..@";
		npc_2nd_greet = "@Bonjour, mon " + pronoun + "!@";	
		
		//call convo script
		startConvo(item, av_1st_greet, npc_1st_greet, av_2nd_greet, npc_2nd_greet); 
	}
	
	if (started_talking)
	{
		//reset schedule for after convo
		UI_run_schedule(item);
		
		item.say("A tall and dashing gentleman.*");
		item.say("He greets you with an elaborate bow and flourish. @Good " + time_of_day + ", mon " + pronoun + "!@");
		if (shop_is_open)
			item.say("@Ave you come to moi for instruction? You 'ave but to ask, mah friend.@");
		
		//standard conversation options
		var options = ["name", "job", "bye"];
		
		if (gflags[TRAINED_WITH_LOUBET])
			add("lesson");
		
	
	/////////////////////////////////////////////////////////////////////
	// Main conversation thread
	/////////////////////////////////////////////////////////////////////
		converse(options)
		{
			case "name"(remove): 
				say("@I am M'sieur Loubet.@");
				say("@Touche!@ He wields his foil casually, lunging at an imaginary target.");
				if (!UI_get_item_flag(item, SI_ZOMBIE))	
				{
					UI_set_item_flag(item, SI_ZOMBIE); 
					say("@Much pleased to meet you, " + title + ".@");
				}
				else 
					say("@But you already know who I am, silly person!@");
				add(["touche"]);

			case "job"(remove):
				if (shop_is_open)
					say("@Oui, I teach ze fencing here in my salle, my school@"); 
				else
					say("@Oui, I teach ze fencing.@");
				say("@Is very difficult sometimes. Most fighters, zey have no subtlety, no finesse.");
				if (!gflags[TRAINED_WITH_LOUBET])
					say("@But you, you look much better than that, my friend.@");
				else
					say("@He turns up his nose and sniffs aristocraticlly. Zey are not like you, mah friend! You are most talented!@");
				add("lesson");
				

			case "lesson": 
				
				if (!shop_is_open)
				{ 
					say("@Practice? Here? Surely you jest!@*");
					say("@No, come to ma salle sometime, zen we will spar, yes?@");
				}
				else
				{
					say("@I charge 70 gold for a session, but thou wilt benefit greatly. Is this agreeable, " + title + "?@");
					if (askYesNo())
						LoubetTrain([DEXTERITY, COMBAT], 70);
					else
						say("@No? When you're ready, you 'ave but to ask, mah friend.@");
     
				}

				
			case "touche"(remove):
				say("@Zat simply means 'touch.' In fencing we score by touching ze opponent with ze foil tip.@");
				add(["foil tip"]);

			case "foil tip"(remove):
				say("@Zey are blunt on ze end, see? Ze first third of ze blade -near ze 'andle- is 'forte'--strong. It is good to parry with zis part of ze sword.@*");
				say("@Ze rest of ze blade is 'foible'--weak and flexible. Ze foil, she is a very delicate thing. There must be much skill, yes?@*");
				say("@You must 'old ze sword like a living bird: Too loose and she flies away. Too tight and she smothers. Just right, and...She sings very sweet!@*");
				UI_play_sound_effect(5); //ding!
				say("He strikes metal and the foil makes a pleasant ringing noise.");
				add(["noise"]);

			case "noise"(remove):
				say("@SHINGGG!@");
				UI_play_sound_effect(5); //ding!

			case "bye"(remove):
			
				avatar_goodbye = "@Must be going now..@";
				npc_goodbye = "@Au revoir!@";
				
				//function that is called, do not change this:
				sayGoodbye(item, npc_goodbye, avatar_goodbye);
				break;
	
		}                               
	}
	else scheduleBarks(item);
}