void Morchella object# (0x4ee) ()
{

	var party = UI_get_party_list();
	var player_name = getAvatarName();
	var polite_title = getPoliteTitle();
	var hour = UI_game_hour();
	var partynum = UI_get_array_size(party);
	var bark;
	var player_is_female = UI_is_pc_female();
	var greeting; //When addressing party as plural or singular
	var avatar_bark;
	var npc_bark;
	var time_of_day = timeFunction(hour);
	var schedule = UI_get_schedule_type(item); //use for schedule specific convos
	var current_schedule = schedule; 
	
	var av_1st_greet;
	var npc_1st_greet;
				
	var av_2nd_greet;
	var npc_2nd_greet;	
	
	var avatar_goodbye;
	var npc_goodbye;
	
	//For schedule specific behavior - Change WAITER with the 'working' schedule of the npc (BLACKSMITH/ TEND SHOP / etc)
	if (UI_get_schedule_type(item) == WAITER)
	{
		UI_set_item_flag(item, SHOP_IS_OPEN);
		UI_error_message("Shop is open");
	}
		
	//this makes sure you can talk to them still if their shop is open (convo function turns it to TALK)
	var shop_is_open = UI_get_item_flag(item, SHOP_IS_OPEN);
				
	
	//Flags used for conversation flags 
	// use PETRA, SI_ZOMBIE, FREEZE, NAKED, POLYMORPH
	var example = UI_get_item_flag(item, SI_ZOMBIE);
	
	
	//READ flag used to initiate conversations via TALK
	var started_talking = UI_get_item_flag(item, READ);

	if (player_is_female) //
	{
	//	pronoun = "  ";
	//	title = "madame";
	}
	else 
	{
	//	pronoun = " ";
	//	title = " ";
	}
	
	//determine single/plural greeting - change as needed
	if (partynum > 1)
		greeting = "friends"; 
	else 
		greeting = "friend"; //Avatar is solo
	
	if (event == DOUBLECLICK)
	{
		//Avatar and NPC greeting barks
		av_1st_greet = "@Excuse me, miss..@";
		npc_1st_greet = "@What do ye want?@";
				
		av_2nd_greet  = "@Might we speak again?@";
		npc_2nd_greet = "@What now?@";	
		
		//call convo script
		startConvo(item, av_1st_greet, npc_1st_greet, av_2nd_greet, npc_2nd_greet); 
	}
	
	if (started_talking)
	{
		//reset schedule for after convo
		UI_run_schedule(item);
				
		item.say("A tough-looking woman with a walk like a troll.*");
		item.say("She stares insolently at you.");
		
		//standard conversation options
		var options = ["name", "job", "bye"];
		
		if (gflags[TALKEDTOHOMERABOUTMAP])
			add("map");

		if (UI_get_item_flag(item, TATTOOED) || UI_get_item_flag(SANDY, SI_ZOMBIE)) //after Dupre accuses her of being a pirate OR gave Sandy the dragon egg
			add (["pirate", "sailor"]);
		
		if (UI_get_item_flag(item, SI_ZOMBIE)) //gave Morchella the shield for the map
			add (["Caradon"]);


	/////////////////////////////////////////////////////////////////////
	// Main conversation thread
	/////////////////////////////////////////////////////////////////////
		converse(options)
		{
			case "name"(remove):
				say("@I'm Morchella.@");

			case "job"(remove):
				say("@I be a retired sailor, that I am.@");
				if (isNearby(DUPRE))
				{
					if (!UI_get_item_flag(item, TATTOOED)) //flag used to avoid using globals - 'knows morchella is pirate'
					{
						UI_set_item_flag(item, TATTOOED); //sets 'knows morchella is a pirate' flag 
					}
					DUPRE.say("@Thou wert a pirate!@");
					DUPRE.hide();
					
					say("@Well!@ She turns up her nose and leaves.");
					sayGoodbyeAbrupt(item, "How rude!");
					break;
				}  
				say("@An honest one, mind ye.@");
  				add(["sailor"]);   

			case "pirate"(remove):
				say("@I know nothing about that!@ She walks off in a huff.");  
				if (!UI_get_item_flag(item, TATTOOED))
					UI_set_item_flag(item, TATTOOED); // can ask her about pirate
				sayGoodbyeAbrupt(item, "Nothing!");
				break;

			case "sailor"(remove):
				say("@That's right, me bucko. Why, I've sailed with Lord British and Captain Johne.@");
				add(["Lord British", "Captain Johne"]);

			case "Lord British"(remove):
				say("@He walks with a limp, ye know. 'Fraid of mice, too, he is.@");
				if (isNearby(SHERRY))
				{
					SHERRY.say("Sherry turns to you, giving you a look of amused bewilderment only a talking mouse could.");
					SHERRY.hide();
				}
				
			case "Captain Johne"(remove):
				say("@He offered to marry me but of course I refused. Didn't want to be tied down.@");
				if ((isNearby(DUPRE)) && (isNearby(SHAMINO)))
				{
					DUPRE.say("Dupre leans towards Shamino and whispers, @That's an image no amount of ale could cleanse from the mind...@");
					DUPRE.hide();
					SHAMINO.say("Shamino shudders and nods in agreement");
					SHAMINO.hide();
				}

			case "map"(remove):
				say("She looks around furtively first. @Well, now, I might have seen the likes of that in me travels...Tell ye what, matey: If ye give me a shield of the Order of the Serpent, I'll tell ye where that map be at.@");
				add(["shield"]);

			case "Caradon"(remove):
				say("@I might even ask 'im to marry me.@ She winks slyly at you.");
								
			case "shield"(remove):
				if (!UI_get_item_flag(item, SI_ZOMBIE)) //'gave morchella shield'
				{
					if (!UI_count_objects(PARTY, SHAPE_MAGIC_SHIELD, QUALITY_ANY, FRAME_ANY) > 0)
					{
						say("@If I had a Silver Serpent shield, I'd give it to Caradon.@");
						say("@He's a fine, brave lad, he is.@");
						add(["Caradon"]);
					}
					else 
					{
						say("@That be quite a prize there, matey. Will ye trade it to me for a bit o' map?@");  // yes/no question
						if (askYesNo())
						{
							say("From a little box Morchella hands over a piece of paper. It is a piece of the pirate map. @I was going to give this magic shield to Caradon but methinks I'll keep it for meself instead! Good " + time_of_day + ", " + polite_title + ".@ She walks off.");  // if answered yes
							UI_remove_party_items(1, SHAPE_MAGIC_SHIELD, QUALITY_ANY, FRAME_ANY, true);
							UI_remove_cont_items(item, 1, SHAPE_TREASURE_MAP, QUALITY_ANY, FRAME_MAP6);
							UI_add_party_items(1, SHAPE_TREASURE_MAP, QUALITY_ANY, FRAME_MAP6, false);
							UI_add_cont_items(item, 1, SHAPE_MAGIC_SHIELD, QUALITY_ANY, FRAME_ANY);
							UI_set_item_flag(item, SI_ZOMBIE);
							sayGoodbyeAbrupt(item, "@It's all mine!@");
							break;
						}
						else 
						{							
							say("@Then leave me be!@ She turns her back angrily on you and walks off.@");  // if answered no
							sayGoodbyeAbrupt(item, "@Begone ye scalliwag!@");
							break;
						}
					}

				}
				else 
					say("@Now all I need is a magic sword; then methinks I'll be a knight. @"); 
				

			case "bye":
				avatar_goodbye = "@That will be all..@";
				npc_goodbye = "@So long, matey.@";
				
				//function that is called, do not change this:
				sayGoodbye(item, npc_goodbye, avatar_goodbye);
				break;
	
		}                               
	}
	else scheduleBarks(item);
}