
void Whitsaber object# (0x451) ()
{

	var party = UI_get_party_list();
	var player_name = getAvatarName();
	var polite_title = getPoliteTitle();
	var hour = UI_game_hour();
	var partynum = UI_get_array_size(party);
	var bark;
	var player_is_female = UI_is_pc_female();
	var greeting; //When addressing party as plural or singular
	var avatar_bark;
	var npc_bark;
	var time_of_day = timeFunction(hour);
	var schedule = UI_get_schedule_type(item); //use for schedule specific convos
	var current_schedule = schedule; 
	
	var av_1st_greet;
	var npc_1st_greet;
				
	var av_2nd_greet;
	var npc_2nd_greet;
	
	var avatar_goodbye;
	var npc_goodbye;
	
	//Flags used for conversation flags 
	// use PETRA, SI_ZOMBIE, FREEZE, NAKED, POLYMORPH
	var whitsaber_mad = UI_get_item_flag(item, NAKED);
	
	var know_whitsaber_is_pirate = UI_get_item_flag(item, SI_ZOMBIE);
	var whitsaber_gave_map = UI_get_item_flag(item, PETRA); // Gave you the map
	var kept_whitsaber_secret = UI_get_item_flag(item, FREEZE); // Kept his secret
	
	//READ flag used to initiate conversations via TALK
	var started_talking = UI_get_item_flag(item, READ);

	if (player_is_female) //
	{
	//	pronoun = "  ";
	//	title = "madame";
	}
	else 
	{
	//	pronoun = " ";
	//	title = " ";
	}
	
	//determine single/plural greeting - change as needed
	if (partynum > 1)
		greeting = "friends"; 
	else greeting = "friend"; //Avatar is solo
	
	if (event == DOUBLECLICK)
	{
		//Avatar and NPC greeting barks
		av_1st_greet = "@Greetings, milord..@";
		npc_1st_greet = "@'tis an honor!@";
				
		av_2nd_greet  = "@Might we speak again?@";
		if (whitsaber_mad)
			npc_2nd_greet = "@Not you again!@";
		else
			npc_2nd_greet = "@Of course, honorable one.@";	
		
		//call convo script
		startConvo(item, av_1st_greet, npc_1st_greet, av_2nd_greet, npc_2nd_greet); 
	}
	
	if (started_talking)
	{
		//reset schedule for after convo
		UI_run_schedule(item);
		
		if (whitsaber_mad) //flag set if you made him mad
		{
			item.say("Recognizing you, fear fills the former pirate's eyes.");
     		item.say("@What do you want? I thought we had a deal!@");
		}
		else if (!UI_get_item_flag(item, MET))
		{
			UI_set_item_flag(item, MET); 
			item.say("A balding but distinguished man.");
			item.say("@Welcome, Avatar!@");
			
		}
		else
			item.say ("@Welcome back, Avatar!@");
		
		//standard conversation options
		var options = ["name", "job", "bye"];
		
		if (gflags[TALKEDTOHOMERABOUTMAP]) //set by Homer when asked about map pieces
			add(["pirate", "map"]);
	
	
	/////////////////////////////////////////////////////////////////////
	// Main conversation thread

	/////////////////////////////////////////////////////////////////////
		converse(options)
		{
			case "name"(remove):
				say("@I am Lord Whitsaber, mayor of this honorable town!@");
				
			case "job"(remove):
				say("@I am entrusted with an honor above all others-that of governing Trinsic, the Town of Honor!@");
  				add(["honor"]); 

			case "honor"(remove):
				say("@Every citizen of this fine town strives every day to be a living example of honor.@");
				say("@Of course, thy own example guides us all, Avatar!@");
				add(["rune", "mantra"]);
			
			case "pirate"(remove):
				if (!gflags[LEARNED_WHITSABERS_SECRET])
				{
					say("@Me, a pirate? Absurd!@ He laughs out loud...but you sense a trace of fear in his voice!@");
				
				}
				else 
				{
					say("@Me, a pirate? Absurd!@ He laughs out loud...but you sense a trace of fear in his voice!");
					add(["Alastor Gordon"]);
				}	
			case "Alastor Gordon"(remove):
				say("@Wh--what did Sandy tell you?@*");
				say("@Did he say I was once a pirate?@");
				if (askYesNo())
				{
					say("@Then all is lost!@*");
					say("@I have changed since those dark days, truly I have!@");
					if (!know_whitsaber_is_pirate)
						UI_set_item_flag(item, SI_ZOMBIE);
					add("map"); //could have already asked him, so adding it back
				}
				else
					say("He seems strangely relieved. @Oh. Well, good, because it isn't true!@");

			case "map"(remove):
				
				if (!UI_get_item_flag(item, PETRA)) //not given map yet
				{
					if (gflags[LEARNED_WHITSABERS_SECRET])
					{
						say("@All right! If thou wouldst but promise to keep my secret, I'll give thee the map! Agreed?@");
						if(askYesNo())
						{
							say("@Oh, thank you, Avatar.@*");
							
							UI_add_party_items(1, SHAPE_TREASURE_MAP, QUALITY_ANY, FRAME_MAP2, false);
							say("He hands over his piece of the map.*");
							say("@I'll rely on thy honor to keep my secret.@");
							UI_set_item_flag(item, PETRA); // Gave you the map
							UI_set_item_flag(item, FREEZE); //kept whitsaber's secret
						}
						else 
						{
							say("@But what more can I do? I cannot change the past!@*");
							UI_add_party_items(1, SHAPE_TREASURE_MAP, QUALITY_ANY, FRAME_MAP2, false);
							say("@By giving you the map, do I not prove that I have changed my ways?@");
							say("@No pirate would willingly give up the key to such a treasure!@");
							UI_set_item_flag(item, NAKED);//Sets "Whitsaber's mad" flag
							UI_set_item_flag(item, PETRA); // Gave you the map
							subtractKarma(10);
						}
					}
					else
						say("@What are you insinuating?@");
				}
				else
					say("@I gave you the map. What more do you want?@");



			case "rune"(remove):
				say("@The Rune of Honor? Why, it is on a pedestal in the center of town!@");
				say("@Even though the rune is our most prized possession, we do not guard it!@");
				say("@And dost thou know why not?@");
				if (askYesNo())
					say("@Oh.@ He seems disappointed somehow.");
				else
			    {
					 say("@Because Trinsic is the Town of Honor! None here would be dishonorable enough to steal it.@");
					 say("@And surely, if any took the rune, they would do the honorable thing and return it afterwards!@");
				}

				
			case "mantra"(remove):	
				say("@The Mantra of Honor? Let me think...@");
				say("@Oh yes, I remember now. It's 'summ.'@");
				if (!gflags[LEARNED_MANTRA_HONOR])
				{
					gflags[LEARNED_MANTRA_HONOR] = true;
					giveExperience(15);
				}
			
			case "bye":
				
				if (whitsaber_gave_map)
				{				
					if (kept_whitsaber_secret)
					{			
						say("@Goodbye, Avatar! Thou hast my thanks!@");
						say("@Truly are thy compassion and honor an example to us all!@");	
						avatar_goodbye = "@Take care, mayor.@";					
						npc_goodbye = "@Farewell, honorable Avatar!@";
														
					}
					else
					{
						avatar_goodbye = "@Must be going now..@";
						npc_goodbye = "@Indeed.@";

					}
					
				}
				else
				{
					say("@Goodbye, Avatar. Return again when thou hast more time to chat!@");
					avatar_goodbye = "@Goodbye, mayor.@";
					npc_goodbye = "@Farewell, honorable Avatar!@";
				}
				
				//function that is called, do not change this:
				sayGoodbye(item, npc_goodbye, avatar_goodbye);
				break;
	
		}                               
	}
	else scheduleBarks(item);
}