void Boskin object# (0x415) ()
{

	var party = UI_get_party_list();
	var player_name = getAvatarName();
	var polite_title = getPoliteTitle();
	var hour = UI_game_hour();
	var partynum = UI_get_array_size(party);
	var bark;
	var player_is_female = UI_is_pc_female();
	var greeting; //When addressing party as plural or singular
	var avatar_bark;
	var npc_bark;
	var time_of_day = timeFunction(hour);
	var schedule = UI_get_schedule_type(item); //use for schedule specific convos
	var current_schedule = schedule; 
	
	//make sure you can't talk to Boskin if you aren't in the same room
	var avatar_pos = UI_get_object_position(AVATAR);

	var can_reach = UI_is_dest_reachable(BOSKIN, [avatar_pos]);
	
	//Flags used for conversation flags 
	// use PETRA, SI_ZOMBIE, FREEZE, NAKED, POLYMORPH
	var boskin_pissed = UI_get_item_flag(item, SI_ZOMBIE);
	
	
	//READ flag used to initiate conversations via TALK
	var started_talking = UI_get_item_flag(item, READ);

	if (player_is_female) //
	{
	//	pronoun = "  ";
	//	title = "madame";
	}
	else 
	{
	//	pronoun = " ";
	//	title = " ";
	}
	
	//determine single/plural greeting - change as needed
	if (partynum > 1)
		greeting = "friends"; 
	else greeting = "friend"; //Avatar is solo
	

	if (event == PROXIMITY)
	{
		var barks = UI_get_random(3);
		
		if (barks == 1)
		
			delayedBark(item, "@Lemme outta here!@", 0);
			
		
		else if (barks == 2)
			delayedBark(item, "@I didn't do it!...@", 2);
		else
			delayedBark(item, "@Me poor kids!...@", 3);
	}

	if (event == DOUBLECLICK)
	{
		//Avatar and NPC greeting barks
		var av_1st_greet = "@Might we speak?@";
		var npc_1st_greet = "@Who's there?@";
		var npc_2nd_greet;
		var av_2nd_greet  = "@Might we speak again?@";
		
		//can't talk to Boskin through walls
		if (!can_reach)
			abort;
		
		if (boskin_pissed)
			npc_2nd_greet = "@Go away!@";
		else
			npc_2nd_greet = "@Strewth!@";	
		
		//call convo script
		startConvo(item, av_1st_greet, npc_1st_greet, av_2nd_greet, npc_2nd_greet); 
	}
	
	if (started_talking)
	{
		//reset schedule for after convo
		UI_run_schedule(item);
		
		if (boskin_pissed)
		{
			var rand = UI_get_random(3);
			if (rand != 3)
				item.say("@I ain't talkin' to you, you're just like all the rest! I'll never crack, no matter 'ow many times you come back!@");
			else
			{
				item.say("@All right, I give up. The rune is 'idden under a potted plant at the Slaughtered Lamb. Now go away and leave me alone.@");
				UI_clear_item_flag(item, SI_ZOMBIE);
			}
			sayGoodbyeAbrupt(BOSKIN, "Begone!");
			return;
			
		}
		
		if (!UI_get_item_flag(item, MET))
		{
			item.say("A short, heavyset man dressed in rags.*");
			item.say("@Who's there?@ the thief calls insolently. The thief's tone becomes more respectful as he recognizes you.*");
			item.say("@'Strewth, it's the Avatar! You've got to get me out of 'ere, " + polite_title + "!@");
			UI_set_item_flag(item, MET);
		}
		else 
			item.say("@" + polite_title + "! Am I glad to see thee! You're me last light in a world of darkness.@");
		
		//standard conversation options
		var options = ["name", "job", "bye", "crime"];
		
			//Lenora said he's a liar, call him out on it
			if (gflags[BOSKINLIES])
				add("lie");
		
			//Lenora said no to freeing him
			if (gflags[BOSKINDENIED])
				add("free");
		/* Conversation options based on MET flag of other npc's - delete all if not used
			if (UI_get_item_flag(NPCNAME, MET))
				add ("NPC name");
		*/


	/////////////////////////////////////////////////////////////////////
	// Main conversation thread

	/////////////////////////////////////////////////////////////////////
		converse(options)
		{
		case "name"(remove):
				say("@Me name's Boskin, Avatar.@");

			case "job"(remove):
				say("@I'm but a poor farmer, forced into crime by the harshness of these times. There weren't no other way to feed me family, Avatar!@");
  				add(["crime", "family"]);

			case "family"(remove):
				say("Tears fill the man's eyes. @My poor children've got no one to take care of them now. I only stole to feed them, and that's the truth.@");
				if (!gflags[BOSKINCHILDREN]) //can ask Lenora bout his kids
					gflags[BOSKINCHILDREN] = true;
				add(["truth"]);

			case "truth"(remove):
				say("@True? Of course it's true! Even a thief like me wouldn't lie to the Avatar.@");

			case "lie"(remove):
				say("@All right, I admit it. I 'aven't got any kids. But that stupid cow they got runnin' this place won't listen to reason--a little give-and-take, know what I mean?@*");
				say("@I tell you what. If I tell you where the rune is, will you take it away? I don't want these pompous blighters to 'ave it. Okay?@.");
				if (askYesNo())
				{
					say("@All right, I'll take your word for it. Go to the Slaughtered Lamb; I 'id the rune under a potted plant there. And spit on Her Ladyship for me!@");
					if (!UI_get_item_flag(item, NAKED))
					{
						giveExperience(50);
						UI_get_item_flag(item, NAKED);
					}	
					sayGoodbye2(BOSKIN);
					gflags[BOSKINLIES] = false;
					break;
				}
				else 
				{	
					say("@Then the gargoyles can take the lot of you! You'll never get nothin' out of me!@");
					UI_set_item_flag(item, SI_ZOMBIE);
					gflags[BOSKINPISSED] = true;
					break;
				}
			case "rune"(remove):
				say("@I'll tell you where the rune is if you'll let me go. I've got me kids to think of.@");
				if (!gflags[FREEBOSKIN])
					gflags[FREEBOSKIN] = true;

			case "crime"(remove):
				say("@I admit I robbed that grave. But it were only because 'is Lordship wouldn't be needin' that stuff no more. I 'ad me kids to feed, didn't I?@");
				add(["rune"]);

			case "free"(remove):
				say("@You mean it, Avatar? Are they gonna let me go 'ome?@");
				if (askYesNo())
				{
					say("His face lights up. @I knew I could count on you, Avatar! And I'll keep my end of the bargain. I 'id the rune under a potted plant in the Slaughtered Lamb inn.@");
					if (UI_npc_nearby(IOLO))
					{	
						IOLO.say("As you leave, Iolo whispers to you. @Maybe it was necessary, Avatar, but lying makes me uneasy. Even to someone like him.@");
						IOLO.hide();
						subtractKarma(5);
						break;
						
					}
				}
				else say("His face falls. @Then I ain't sayin' nothin'. I've got me kids to think of, I do.@");

		
			case "bye":
				item.say("@Please, Avatar! Tell them to let me go 'ome! Tell them about me poor fatherless kids! They'll listen to you!@");
				var avatar_goodbye = "@I must be going now..@";
				var npc_goodbye = "@Think of me children!@";
				
				//function that is called, do not change this:
				sayGoodbye(item, npc_goodbye, avatar_goodbye);
				break;
	
		}                               
	}
	else scheduleBarks(item);
}