
void Lenora object# (0x412) ()
{

	var party = UI_get_party_list();
	var player_name = getAvatarName();
	var polite_title = getPoliteTitle();
	var hour = UI_game_hour();
	var partynum = UI_get_array_size(party);
	var bark;
	var player_is_female = UI_is_pc_female();
	var greeting; //When addressing party as plural or singular
	var avatar_bark;
	var npc_bark;
	var time_of_day = timeFunction(hour);
	var schedule = UI_get_schedule_type(item); //use for schedule specific convos
	var current_schedule = schedule; 
	
	var av_1st_greet;
	var npc_1st_greet;
				
	var av_2nd_greet;
	var npc_2nd_greet;
	
	var npc_goodbye;
	
		
	//Flags used for conversation flags 
	// use PETRA, SI_ZOMBIE, FREEZE, NAKED, POLYMORPH
	var lenora_pissed = UI_get_item_flag(item, SI_ZOMBIE);
	
	//FAILSAFE:  make sure Avatar can only ask about murder while she's sitting in the courtroom
	if (UI_get_schedule_type(item) == MAJOR_SIT && hour >= 6 && hour < 21)
	{
		UI_set_item_flag(item, SHOP_IS_OPEN);
		UI_error_message("Shop is open");
	}
	
	
	//this makes sure you can talk to them still if their shop is open (convo function turns it to TALK)
	var shop_is_open = UI_get_item_flag(item, SHOP_IS_OPEN);
	
	//READ flag used to initiate conversations via TALK
	var started_talking = UI_get_item_flag(item, READ);

	if (player_is_female) //
	{
	//	pronoun = "  ";
	//	title = "madame";
	}
	else 
	{
	//	pronoun = " ";
	//	title = " ";
	}
	
	//determine single/plural greeting - change as needed
	if (partynum > 1)
		greeting = "friends"; 
	else greeting = "friend"; //Avatar is solo
	
	
	if (event == DOUBLECLICK)
	{
		//Avatar and NPC greeting barks
		av_1st_greet = "@Excuse me, milady..@";
		npc_1st_greet = "@Ah, the Avatar has returned.@";
		
		av_2nd_greet  = "@Lady Lenora..@";
		if (lenora_pissed)
			npc_2nd_greet = "@Back again?@";	
		else
			npc_2nd_greet = "Greetings, Avatar.";
		
		//call convo script
		startConvo(item, av_1st_greet, npc_1st_greet, av_2nd_greet, npc_2nd_greet); 
	}
	
	if (started_talking)
	{
		//reset schedule for after convo
		UI_run_schedule(item);
		
		if (lenora_pissed)
		{
			item.say("@Well, Avatar. I graciously grant thee another interview. I certainly hope thou wilt be more respectful this time.@");
			UI_clear_item_flag(item, SI_ZOMBIE);
		}
		
		else if (!UI_get_item_flag(item, MET))
		{
			item.say("You see a tall, stern woman, with graying red hair and a perpetual scowl.");
			item.say("@Welcome, worthy Avatar, to the Hall of Justice. How may we assist thee in thy quest?@");
			UI_set_item_flag(item, MET);
		}
		else 
			item.say("@Welcome again, worthy Avatar, to my hall.@");
		
		//standard conversation options
		var options = ["name", "job", "bye"];
		
		if (gflags[ASKEDABOUTPERMISSION])
			add("letter");

		if (gflags[BOSKINCHILDREN])
			add("children");

		if (gflags[FREEBOSKIN])
			add("free thief");

		if (gflags[MICHAEL_PISSED])
			add("murder in Skara Brae");

		if (gflags[ASKED_PRIDGARM_ABOUT_DRUDGEY])
			add("Drudgeworth and Saduj");
			
		if (UI_get_item_flag(NICODEMUS, MET) || (gflags[LEARNED_ABOUT_NICODEMUS])) //asked Thairand about him
			add ("enchanter");
		


	/////////////////////////////////////////////////////////////////////
	// Main conversation thread

	/////////////////////////////////////////////////////////////////////
		converse(options)
		{
			case "name"(remove):
				say("@I am Lenora, Lady Mayor of Yew.@");
		
			case "job"(remove):
				say("@It is my honor to preside over this town and its courts. We also provide the finest wood in the realm.@");
  				add(["courts", "wood"]); 

			case "wood"(remove):
				say("@Go ask Ben the logger. Head west from here into the forest until you can go no further. Then look for a way through the trees to the north.@");
	
			case "courts"(remove):
				say("@In Yew we take pride in our system of justice.@");
				if (gflags[RINALDO_BACK])
				{
					say("@Now that Rinaldo is back, he will be assuming his duties of presiding over the courts.@");
				} 
				add(["justice"]);

			case "justice"(remove):
				say("@Indeed, the Rune of Justice itself was sent here for safekeeping.@");
				add(["Rune", "mantra"]);

			case "Rune"(remove):
				say("@A thief stole the rune from the grave of our most respected resident, the former Lord Mayor. Even though the thief was caught, we have not yet found the rune.@");
				add(["thief"]);

			case "thief"(remove):
				say("@The thief is in the jail, awaiting the carriage of justice.@");

			case "mantra"(remove):
				say("@'Tis most strange, Avatar, that thou knowest not the Mantra of Justice. How can that be?@");
				var choice = chooseFromMenu(["I forgot..", "say nothing"]);
				if (choice == "I forgot..")
				{
					say("@Hmmm...well, no matter,@ she says suspiciously.");
					say("@I suppose 'twould be improper to deny anything the Avatar requires. The Mantra of Justice is 'beh'.@");
					if (!gflags[LEARNED_MANTRA_JUSTICE])
					{
						gflags[LEARNED_MANTRA_JUSTICE] = true;
						giveExperience(15);
					}
				}
				else
				{
					say("@Hmpf! Well, mayhap 'twould be best for you to seek such wisdom elsewhere!*@");
					say("@Thou may return when thou seest fit to answer my question!@");
					UI_set_item_flag(item, SI_ZOMBIE); //Lenora pissed
					sayGoodbyeAbrupt(item, "Hmpf!..'Avatar', indeed!");
					return;
				
				}
			
			case "letter"(remove):
				if (!gflags[LENORA_GAVE_LETTER])
				{				
					say("@A letter of permission? Dost thou truly need to speak with that reprehensible thief?@");

					if (askYesNo())
					{
						if (UI_add_party_items(1, SHAPE_SCROLL, 52, 3, false))
						{		
							say("@Very well then.@ Putting quill to parchment, she drafts a quick letter. @The jailer will now let you in, or verily shall he answer to me!@");
							//give letter to Avatar
							gflags [LENORA_GAVE_LETTER] = true;
						}
						else say("@Ask again when you have room to carry the letter@");
					}
					else
					{
						say("@Then why dost thou waste my time with frivolous requests?! Begone, Avatar, and return when thou hast more serious business on thy mind!@");
						UI_set_item_flag(LENORA, SI_ZOMBIE); //lenora pissed
						sayGoodbyeAbrupt(item, "Don't waste my time!");
						return;
					}
				}

			else 
				say("@I already gave thee the letter, Avatar.@");

			case "free thief"(remove):
				say("@What, free the thief in return for the rune? Never! To do so would betray everything the rune itself stands for! Better to leave it lost.@");
				gflags[BOSKINDENIED] = true;

			case "children"(remove):
				say("@What? What stories has that thief been telling you? He has no family--he's just a drifter! Don't be taken in by his lies.@");
				gflags[BOSKINLIES] = true;
				add(["lies"]);

			case "lies"(remove):
				say("@Tell him he's not fooling anyone.@");

			case "enchanter"(remove):
				say("@Nicodemus the enchanter lives near here. His house lies between two rivers.@");

			case "Drudgeworth and Saduj"(remove):
				say("@What do you know of them? They were responsible for the murder of a few guards during their transport.@");
				say("@It happened during the former Lord Mayor's tenure while I was just a clerk. What he knew about the case most likely died with him.@");
				say("@It's possible he might have talked to the barmaid about it as he enjoyed a good drink in the evenings, but he never discussed it with me.@");
				if (!gflags[ASK_ANDREA_ABOUT_DRUDGEY]) //open up Drudgeworth conversation on ANDREA
					gflags[ASK_ANDREA_ABOUT_DRUDGEY] = true;
				
								
		
			case "murder in Skara Brae"(remove):
				

				if (!gflags[ASKED_LENORA_ABOUT_MURDER])
				{
					if (shop_is_open)
					{
						gflags[ASKED_LENORA_ABOUT_MURDER] = true;
					
						say("You inform Lenora of the events in Skara Brae surrounding Quenton's murder and the seance, in which Quenton indicated Michael was the culprit.");
						say("@Yes, I'm aware of the unfortunate death in Skara Brae, but people die all the time to gargoyle attacks these days.@");
						say("@What wouldst thou have me do? Drop everything and send our already overstretched guards to arrest someone, based on a ghost's testimony?@");
						say("@It sounds more credible that it was the doings of those vile gargoyles. Please run along and trouble me not with this nonsense...@");
						//AVATAR->set_item_flag(BG_DONT_MOVE);
						RINALDO->move_object([0x2b6, 0x208, 0x0]);
					
					//failsaife - make sure Rinaldo is "alive" and havne't met
						RINALDO->clear_item_flag(DEAD);
						
						UI_set_schedule_type(RINALDO, TALK);
						
						//Lenora gives up the seat for Rinaldo
						UI_modify_schedule(LENORA, 3, LOITER, [0654, 0515]);
						sayGoodbye2(item);
						break;
					}
					else 
						say("@Come back tomorrow when I'm working and we'll discuss this matter.@");
					
				}
				else
					say("@As I have said, all further discussion on this matter should be with Rinaldo.@");		

			case "bye":
				if (lenora_pissed)
				{
					say("@Hmpf! Well, mayhap 'twould be best for you to seek such wisdom elsewhere!@");
					say("@Thou may return when thou seest fit to answer my question!@");
					sayGoodbyeAbrupt(item, "Avatar, indeed!");
				
				}
				else
					say("@May you find that which thou deservest on thy quest.@");
				
				var avatar_goodbye = "@Goodbye..@";
				
				if (lenora_pissed)
					npc_goodbye = "@Goodbye, indeed! Hmpfh!@";
				else
					npc_goodbye = "@Go in Justice, Avatar.@";
				//function that is called, do not change this:
				sayGoodbye(item, npc_goodbye, avatar_goodbye);
				break;
	
		}                               
	}
	else scheduleBarks(item);
}