
void Rinaldo object# (0x432) ()
{

	var party = UI_get_party_list();
	var player_name = getAvatarName();
	var polite_title = getPoliteTitle();
	var hour = UI_game_hour();
	var partynum = UI_get_array_size(party);
	var bark;
	var player_is_female = UI_is_pc_female();
	var greeting; //When addressing party as plural or singular
	var avatar_bark;
	var npc_bark;
	var time_of_day = timeFunction(hour);
	var schedule = UI_get_schedule_type(item); //use for schedule specific convos
	var current_schedule = schedule; 
	
	var av_1st_greet;
	var npc_1st_greet;
				
	var av_2nd_greet;
	var npc_2nd_greet;	
	
	var avatar_goodbye;
	var npc_goodbye;
	
	var pronoun;
	
	const int QUALITY_QUENTONLETTER = 62;

	
	//Get time since 9am. That way this quest is time limited, after midnight, its done!
	var hours_since_9am = (hour - 9); 
	var time_lapsed = (24 - hours_since_9am); //this determines how much time needs to lapse 

	var whole_day = 24; //used for adding an entire day before Rinaldo announces Michael's capture

	
	
	
	
	//For schedule specific behavior - Change WAITER with the 'working' schedule of the npc (BLACKSMITH/ TEND SHOP / etc)
	if (UI_get_schedule_type(item) == WAITER)
	{
		UI_set_item_flag(item, SHOP_IS_OPEN);
		UI_error_message("Shop is open");
	}
		
	//this makes sure you can talk to them still if their shop is open (convo function turns it to TALK)
	var shop_is_open = UI_get_item_flag(item, SHOP_IS_OPEN);
				
	
	//Flags used for conversation flags 
	// use PETRA, SI_ZOMBIE, FREEZE, NAKED, POLYMORPH
	var example = UI_get_item_flag(item, SI_ZOMBIE);
	
	
	//READ flag used to initiate conversations via TALK
	var started_talking = UI_get_item_flag(item, READ);

	if (player_is_female) //
	{
	//	pronoun = "  ";
	//	title = "madame";
	}
	else 
	{
	//	pronoun = " ";
	//	title = " ";
	}
	
	//determine single/plural greeting - change as needed
	if (partynum > 1)
		greeting = "friends"; 
	else 
		greeting = "friend"; //Avatar is solo
	
	//Initial first meeting with Rinaldo. 
	if (UI_get_schedule_type(item) == TALK && !UI_get_item_flag(RINALDO, SI_ZOMBIE))
	{
		item.say("@Greetings, milady Lenora. Didst I overhear of a murder in Skara Brae?@");	
		LENORA.say("@This situation is being taken care of, Rinaldo. There is no need for thy concern.@");
		item.say("@Lest ye not forget that Lord British himself appointed me to properly administrate Justice, after it had been twisted during his absense for so long.@");
		item.say("@While I do not doubt the Avatar's integrity, relying on the testimony of a spirit could set a horrible precedent. There is nothing on the books that would make it proper evidence.@");
		LENORA.say("Lenora, looking flustered, says @Then we shall arrest Michael, if that wouldst make thee happy. Tis enough evidence for me, Rinaldo. Mine intuitions have not failed me yet. The cells are full of prisoners who deserved their sentences...@");
		item.say("@I shall relieve you from the duties of judicial matters so you can concentrate on governing the city. Thank thee for filling in during my absense.@");
		LENORA.say("Lenora, looking both irate and insulted at the same time, resigns herself to authority.");
		LENORA.say("@Very well, milord.@ she sighs. @Avatar, thou shouldst consult with Rinaldo concerning this matter. Good luck.@");
		LENORA.say("She glances at Rinaldo and then goes about her duties, quietly fuming to herself.");
		LENORA.hide();
		UI_set_schedule_type(item, LOITER);
		UI_clear_item_flag(item, MET);
		UI_set_item_flag(item, SI_ZOMBIE);
		AVATAR->clear_item_flag(BG_DONT_MOVE);
		return;
	}
	
	
	if (event == DOUBLECLICK)
	{
		//Avatar and NPC greeting barks
		av_1st_greet = "@Greetings milord.@";
		npc_1st_greet = "@Well met, Avatar.@";
				
		av_2nd_greet  = "@Hello again, Rinaldo.@";
		npc_2nd_greet = "@Ah yes, welcome back Avatar.@";	
		
		//call convo script
		startConvo(item, av_1st_greet, npc_1st_greet, av_2nd_greet, npc_2nd_greet); 
	}
	
	if (started_talking)
	{
		//reset schedule for after convo
		UI_run_schedule(item);
		
		if (gflags[FAILED_QUENTON_QUEST]) //BAD ending
		{
			item.say("@Cheating are we? Tisk tisk.@");
			sayGoodbye2(item);
			return;
			
		}
		
		
		if ((isNearby(RENTHAR)) && (!UI_get_item_flag(RENTHAR, MET)))
		{
			UI_set_item_flag(RENTHAR, MET); //so Rinaldo and Renthar have discussed already
			item.say("@If you will excuse me Avatar, Renthar is discussing an important matter with me. Please come back later.@");
			
			//clear their wait schedules
			UI_set_schedule_type(RENTHAR, LOITER);
			UI_set_schedule_type(RINALDO, LOITER);
			
			sayGoodbye2(item);	
			return;
		}
				
		//killed Michael in his hideaway but haven't talked to Rinaldo about it yet
		if (gflags[MICHAEL_CAPTURED] && (!gflags[QUENTON_MURDER_SOLVED]))
		{
			item.say("@I thank thee for helping bring a murderer to justice, noble Avatar. With the gargoyles running roughshod across Britannia, manpower has been quite scarce in dealing with such crimes.@");
			if (gflags[MARNEY_GONE]) //semi-Good ending
			{				
				item.say("@Renthar was able to make Michael reveal the location of Marney and he is en route to the location. He promised to return her to Skara Brae, let us hope he is not too late.@"); 
				item.say("@Take this reward for your troubles.@");
				//give money
				if (UI_add_party_items(100, SHAPE_GOLD, QUALITY_ANY, FRAME_ANY, false))
				{	
					gflags[QUENTON_MURDER_SOLVED] = true;	
					UI_add_party_items(100, SHAPE_GOLD, QUALITY_ANY, FRAME_ANY, true);
					item.say("He hands you a pouch of 100 gold coins.");
					
					//free up Marney from the holding place
					UI_set_schedule_type(MARNEY, LOITER);
					UI_run_schedule(MARNEY);
					
					item.say("@Thou art truly a shining example of the virtue of Justice.@"); 
					sayGoodbye2(item);	
					return;
					
					//set flag to where Marney will be reeling from the experience and be angry with the Avatar
					gflags[MARNEY_PISSED] = true;
					giveExperience(50);
					
				}
				else
					item.say("@Ask again when you have room to carry thy reward.@");
			}
			else if (gflags[MARNEY_SAVED])
			{
				item.say("@Take this reward for your troubles.@");
				//give money
				if (UI_add_party_items(200, SHAPE_GOLD, QUALITY_ANY, FRAME_ANY, false))
				{	
					gflags[QUENTON_MURDER_SOLVED] = true;	
					UI_add_party_items(200, SHAPE_GOLD, QUALITY_ANY, FRAME_ANY, true);
					item.say("He hands you a pouch of 200 gold coins.");
					addKarma(20);
					giveExperience(200);
					item.say("@Thou art truly a shining example of the virtue of Justice, noble Avatar.@"); 
					sayGoodbye2(item);
					return;
				}
				else
					item.say("@Ask again when you have room to carry thy reward.@");
				
				
				
			}	
		
		
		}
		
		
		if (!UI_get_item_flag(item, MET))
		{
			UI_set_item_flag(item, MET); 
			item.say("You see a nobleman in judge's robes.");
			item.say("@Avatar, 'tis an honor to meet thee.@ He shakes your hand.@"); 
		}
		else
			item.say("@A pleasure to see thee again, " + player_name + ". What wouldst thou speak of?@");
		
		//standard conversation options
		var options = ["name", "job", "bye", "murder in Skara Brae"];
		
		//Marney is either saved or gone
		if ((gflags[MARNEY_GONE] || gflags[MARNEY_SAVED]) && !gflags[QUENTON_MURDER_SOLVED])
			add("Michael's whereabouts");
		
		if (gflags[STARTED_INVESTIGATION] && !gflags[QUENTON_MURDER_SOLVED])	
			add("evidence");

	

	/////////////////////////////////////////////////////////////////////
	// Main conversation thread
	/////////////////////////////////////////////////////////////////////
		converse(options)
		{
			case "name"(remove):
				say("@I am Rinaldo, and I strive to uphold the virtue of Justice.@");				

			case "job"(remove):
				say("@I was appointed a judge of the High Court of Yew, by Lord British. In my absense, Lenora took care of my duties.@");
  				add(["absense", "Lenora", "Lord British"]); 

			case "absense"(remove):
				say("@I was away for a while on a sabbatical, scouring books in the Lycaeum for any information regarding moongates and their functions.@");
				add(["moongates"]);

			case "Lenora"(remove):
				
				say("@Lenora was gracious enough to temporarily take over my duties overseeing the High Court of Yew.@");
				if (isNearby(LENORA))
				{
					LENORA.say("Lenora looks over and scowls, then goes back to what she was doing.");
					LENORA.hide();
					say("Rinaldo looks at you and grins slightly");
				}
				say("He whispers: @Between you and I, her idea of justice was a bit too heavy handed and apparently based on her emotions...usually anger!@");
				say("Rinaldo laughs.");
				

			case "Lord British"(remove):
				say("@Such a noble and just ruler. The former lord mayor of Yew recommended me to him for this position. I hope my service doth make him proud, and I strive to dispense justice fairly and according to the law.@");

			case "murder in Skara Brae"(remove):
				if (gflags[QUENTON_MURDER_SOLVED])
				{
					say("@Such a shame. My thoughts go out to the young woman left behind without her father. I am glad thou hast brought the murderer to justice.@");
				}
				else
				{
					say("@I hope thou weren't offended by mine interjection. I strive for Justice, even for those who may seem like scoundrels. From what I understand about thy last visit here, justice was grossly misapplied...@");
					say("@Let us have a thorough investigation into this matter so we can properly prosecute the murderer by the books.@");				
					add(["investigation"]);
				}
			case "moongates"(remove):
				say("@Yes, very interesting topic. Much like thyself, I come from another land.@");
				add(["another land", "why?"]);

			case "another land"(remove):
				say("@Yes, far away. I like Britannia much better. In fact, I hope to see my sister here again one day as well. I was hoping that I might be able to find something on moongate appearances and how often inter-wordly gates appear. I didn't find much of use though.@");
				add(["sister"]);

			case "sister"(remove):
				say("@She's powerful in the art of magic. It was her who found a way for us to come here, via the moongates.@");
				say("@I do not know the specifics, but she studied legends of strange people appearing through moongates, or disappearing through them altogther.@");
				say("@Somehow she was able to discern exactly when a moongate would appear and that it would lead us to this land.@");
				add(["how?"]);

			case "why?"(remove):
				say("@Why I came here? Let's just say mine homeland cares not for the true meaning of justice.@");
				
			case "how?"(remove):
				say("@My knowledge of magic is very miniscule. She just told me to trust her intiutions, that we would be going to a far better place than our own homeland.@");
				add(["homeland"]);

			case "homeland"(remove):
				say("@We do not have a system of virtues like here in Britannia. My interest in law led me to Yew, the city of Justice. This was some time after Blackthorn's reign. My sister stayed briefly, but left for an unknown destination.@");
				add(["virtues", "law", "unknown destination"]);

			case "virtues"(remove):
				say("@Thy legendary Quest was very inspiring. Justice is a virtue that I strive to uphold.@");
				
			case "law"(remove):
				say("@I spent years studying Britannian law. Quite interesting stuff.@");
				
			case "unknown destination"(remove):
				say("@Her quest for knowledge has lead her to many different lands, and quite possibly different planes of existence. She promised she would return to Britannia eventually.@");
				say("@She had mentioned wanting to move to Skara Brae when she returns. 'Tis the City of Spirituality of course.@");
				add(["Skara Brae"]);

			case "Skara Brae"(remove):
				say("@Never been there.@");

			case "investigation"(remove):
				if (gflags[QUENTON_MURDER_SOLVED])
					say("@Thou hast successfully completed the investigation already. Good work.@");
				
				else
				{	
					say("@Start at the scene of the crime. Talk to all the townsfolk again. Were there witnesses? If so, ask them.@");
					say("@A credible witness willing to testify would be beneficial to our case. Leave no stone unturned.@");
					say("@Report back here with me if thou dost need more assitance, or if you have evidence we can act upon. Make haste!@");
					
					/* When the investigation starts, Michael is moved to his house and won't allow the Avatar to look around. 
					* That will start a timer waiting until 9pm which will move Michael and Marney to the docks
					* If the player is too late, they will both be gone, Marney having went along with Michael.
					*/
					
					if (!gflags[STARTED_INVESTIGATION])
					{
						gflags[STARTED_INVESTIGATION] = true;  
						
						//Move michael to center of his house, make him wait.
						MICHAEL->move_object([0626, 1381, 0]);
						MICHAEL->set_schedule_type(WAIT);
						
				
						//Set Rinaldo's npc ID to the time_lapsed so it can be accessed in quenton_sidequest_eggs
						UI_set_npc_id(RINALDO, time_lapsed);
				
						//start actual timer	
						UI_set_timer(INVESTIGATION_TIMER);
						var timer_num = UI_get_timer(INVESTIGATION_TIMER);
						UI_error_message("gflag STARTED_INVESTIGATION is set");
						UI_error_message("Current hour is: " + hour + " and INVESTIGATION_TIMER is set to " + timer_num);
				
					}
				}		
			
			
			case "evidence"(remove):
				say("@Thou hast found some evidence? Let me see it.@");
				if (UI_count_objects(PARTY, SHAPE_SCROLL, QUALITY_QUENTONLETTER, FRAME_ANY) >= 1)
				{
					say("You show Rinaldo the scroll you found, and inform him that Michael has fled on his ship.");
					say("@So, Quenton owed him a debt. Seems as though Michael murdered him when he didn't pay.@");
					say("@Any potential witnesses?@"); 
					if (gflags[STIVIUS_SAW_MICHAEL])
						add("Stivius");
					
				}
				else 
					say("@Well, where is it? Where is thine evidence?@");

			//this should only come about when Michael is gone, and you haven't "met" Renthar yet
			case "Michael's whereabouts"(remove):
				if (gflags[MARNEY_SAVED])
					say("You inform Rinaldo that Michael had fled on a ship and Marney was saved.");
				else if (gflags[MARNEY_GONE])
					say("You inform Rinaldo that Michael had fled on a ship with Marney.");
							
				say("@Indeed... he could be anywhere by now. Avatar, please speak with this fellow here, Renthar, immediately.@");
				say("@Before you came in, he was revealing some information on a pirate crew that may be interesting to you.@");
				say("@Michael has a connection to them! Talk to him, and find out where Michael might be hiding. I'm afraid due to the lack of manpower with the gargoyle war, it is up to thee to bring him to Justice!@");
				say("@Do what thou must, but bring him in alive, so that he faces a proper trial.@");
				UI_set_item_flag(RENTHAR, MET); //so you can talk to Renthar now.
				sayGoodbyeAbrupt(item, "@Make haste and good fortune to thee!@");
				return;
				

			case "Stivius"(remove):
				say("Rinaldo listens as you inform him that Stivius witnessed the murder, but made the gargoyle story up to save himself from Michael.");
				say("@I see. I will see to it that he testifies against Michael and his safety will be guaranteed. Excellent work.@");
			
							
			case "bye":
				avatar_goodbye = "@Goodbye, Rinaldo.@";
				npc_goodbye = "@Til we meet again, " + player_name + ".@";
				sayGoodbye(item, npc_goodbye, avatar_goodbye);
				break;				

	
		}                               
	}
	else scheduleBarks(item);
}