void spellEnchantEffect object#() ()
{
	var normal_missiles = [SHAPE_ARROWS, SHAPE_BOLTS];
	var magic_missiles = [SHAPE_MAGIC_ARROWS, SHAPE_MAGIC_BOLTS];
	for (missile in normal_missiles with index)
		if (missile == get_item_shape())
			set_item_shape(magic_missiles[index]);
}





void spellEnchant object#(0x651) ()
{
	var normal_missiles = [SHAPE_ARROWS, SHAPE_BOLTS];
	var magic_missiles = [SHAPE_MAGIC_ARROWS, SHAPE_MAGIC_BOLTS];
	
	var BP = UI_count_objects(AVATAR, SHAPE_REAGENT, QUALITY_ANY, FRAME_BLACK_PEARL);	
	var NS = UI_count_objects(AVATAR, SHAPE_REAGENT, QUALITY_ANY, FRAME_NIGHTSHADE);	
	var SA = UI_count_objects(AVATAR, SHAPE_REAGENT, QUALITY_ANY, FRAME_SULFUR_ASH);	
	var BM = UI_count_objects(AVATAR, SHAPE_REAGENT, QUALITY_ANY, FRAME_BLOOD_MOSS);	
	var MR = UI_count_objects(AVATAR, SHAPE_REAGENT, QUALITY_ANY, FRAME_MANDRAKE_ROOT);	
	var SS = UI_count_objects(AVATAR, SHAPE_REAGENT, QUALITY_ANY, FRAME_SPIDER_SILK);
	var GL = UI_count_objects(AVATAR, SHAPE_REAGENT, QUALITY_ANY, FRAME_GARLIC);		
	
	var Avatar_Level = getExpLevel(AVATAR); 
	
	if (event == DOUBLECLICK)
	{
		halt_scheduled();
		var target = UI_click_on_item();
		var target_shape = target->get_item_shape();
		var dir = direction_from(target);
		item_say("@Ort Ylem@");
		
		if (target_shape == SHAPE_YEW_STAFF)
		{
			AVATAR.say("Which spell do you want to enchant it with?");
			var spell_options = ["none"];
			
			if (hasSpell(FIRE_BLAST))
				add("Fire Blast");
			
			if (hasSpell(DEATH_BOLT))
				add("Death Bolt");		

			if (hasSpell(POISON))
				add("Poison");		

			if (hasSpell(LIGHTNING))
				add("Lightning");							

			converse(spell_options)
			{
				case "Poison": //BP, BM, NS lvl 3
					if (BP >= 10 && BM >= 10 && NS >= 10)
					{
						if (Avatar_Level >= 3)
						{
							//set yew staff to enchanted staff (change type!)
							UI_set_item_shape(target, SHAPE_YEW_STAFF_POISON);
							
							//give it 10 charges
							UI_set_item_quality(target, 10);
							
							//remove regs:
							UI_remove_party_items(10, SHAPE_REAGENT, QUALITY_ANY, FRAME_BLOOD_MOSS);
							UI_remove_party_items(10, SHAPE_REAGENT, QUALITY_ANY, FRAME_BLACK_PEARL);
							UI_remove_party_items(10, SHAPE_REAGENT, QUALITY_ANY, FRAME_NIGHTSHADE);
							
							script item
							{	nohalt;						face dir;
								sfx 67;						actor frame reach_1h;
								actor frame raise_1h;		actor frame strike_1h;
							}
							
							return;
						}
						else
						{
							AVATAR->spellFails();
							avatarBark("@I can't cast that spell yet.@");
							return;
							
						}
						
					}
					else
					{
						AVATAR->spellFails();
						avatarBark("Requires 10 of each Poison reagent.");
						return;
						
					}
			
			
				case "Fire Blast": 
					if (BP >= 10 && SA >= 10)
					{
						if (Avatar_Level >= 2)
						{
							//set yew staff to enchanted staff (change type!)
							UI_set_item_shape(target, SHAPE_YEW_STAFF_FIREBOLT);
							
							//give it 10 charges
							UI_set_item_quality(target, 10);
							
							script item
							{	nohalt;						face dir;
								sfx 67;						actor frame reach_1h;
								actor frame raise_1h;		actor frame strike_1h;
							}
							
							//remove regs:
							UI_remove_party_items(10, SHAPE_REAGENT, QUALITY_ANY, FRAME_SULFUR_ASH);
							UI_remove_party_items(10, SHAPE_REAGENT, QUALITY_ANY, FRAME_BLACK_PEARL);
							return;
						}
						else
						{
							AVATAR->spellFails();
							avatarBark("@I can't cast that spell yet.@");
							return;
							
						}
						
					}
					else
					{
						AVATAR->spellFails();
						avatarBark("Requires 10 of each Fire Bolt reagent.");
						return;
						
					}
					
				case "Death Bolt":
					if (BP >= 10 && NS >= 10 && SA >= 10)
					{
						if (Avatar_Level >= 7)
						{
							//set yew staff to enchanted staff (change type!)
							UI_set_item_shape(target, SHAPE_YEW_STAFF_DEATHBOLT);
							
							//give it 10 charges
							UI_set_item_quality(target, 10);
							
							script item
							{	nohalt;						face dir;
								sfx 67;						actor frame reach_1h;
								actor frame raise_1h;		actor frame strike_1h;
							}
							
							//remove regs:
							UI_remove_party_items(10, SHAPE_REAGENT, QUALITY_ANY, FRAME_SULFUR_ASH);
							UI_remove_party_items(10, SHAPE_REAGENT, QUALITY_ANY, FRAME_NIGHTSHADE);
							UI_remove_party_items(10, SHAPE_REAGENT, QUALITY_ANY, FRAME_BLACK_PEARL);
							return;
						}
						else
						{
							AVATAR->spellFails();
							avatarBark("@I can't cast that spell yet.@");
							return;
							
						}
						
					}
					else
					{
						AVATAR->spellFails();
						avatarBark("Requires 10 of each Death Bolt reagent.");
						return;
					}
					
				case "Lightning": //BP, MR, SA
					if (BP >= 10 && SA >= 10 && MR >=10)
					{
						if (Avatar_Level >= 4)
						{
							//set yew staff to enchanted staff (change type!)
							UI_set_item_shape(target, SHAPE_YEW_STAFF_LIGHTNING);
							
							//give it 10 charges
							UI_set_item_quality(target, 10);
							
							script item
							{	nohalt;						face dir;
								sfx 67;						actor frame reach_1h;
								actor frame raise_1h;		actor frame strike_1h;
							}
							
							//remove regs:
							UI_remove_party_items(10, SHAPE_REAGENT, QUALITY_ANY, FRAME_SULFUR_ASH);
							UI_remove_party_items(10, SHAPE_REAGENT, QUALITY_ANY, FRAME_BLACK_PEARL);
							UI_remove_party_items(10, SHAPE_REAGENT, QUALITY_ANY, FRAME_MANDRAKE_ROOT);
							return;
						}
						else
						{
							AVATAR->spellFails();
							avatarBark("@I can't cast that spell yet.@");
							return;
							
							
						}
						
					}
					else
					{
						AVATAR->spellFails();
						avatarBark("Requires 10 of each Lightning reagent.");
						return;
					}
					
					case "none":
						return;
					
			}
		
		}
		else if (inMagicStorm() && (target_shape in normal_missiles))
		{
			script item
			{	nohalt;						face dir;
				sfx 67;						actor frame reach_1h;
				actor frame raise_1h;		actor frame strike_1h;}
			script target after 4 ticks
			{	nohalt;						call spellEnchantEffect;}
		}
		else
		{
			script item
			{	nohalt;						face dir;
				actor frame reach_1h;		actor frame raise_1h;
				actor frame strike_1h;		call spellFails;
			}
		}
	}


}
