/*
 *
 *  Copyright (C) 2006  The Exult Team
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 *	This header file overrides the spellbook's spells (most of them, anyway)
 *	to use the new versions. I preferred to do it this way for four reasons:
 *		(1) There is a clean algorythm by which NPC spells are cast;
 *		(2) It allows me to override specific spells and leave others;
 *		(3)	I can add new NPC-only spells without removing existing spells.
 *		(4) It is easier to add NPC-specific spells which only one NPC
 *			can cast (although I haven't made any such spells yet).
 *
 *	Presently, I haven't overriden Help (except for Multimap support), Recall
 *	and Armageddon -- I don't think that they are appropriate for NPCs, so I
 *	left them alone. I _have_ overriden Mark, but only so that is won't be
 *	possible to use it while inside the Shrine of the Codex.
 *	All other spells are overriden so that the Avatar and the NPCs play by the
 *	same rules.
 *
 *	Author: Marzo Junior
 *	Last Modified: 2006-02-27
 */

//spellAwaken_Override			object#(0x640) () {spellAwaken(UI_click_on_item());}
//spellWeather_Override			object#(0x641) () {spellWeather();}
//spellDouse_Override				object#(0x642) () {spellDouse(UI_click_on_item());}
//spellFireworks_Override			object#(0x643) () {spellFireworks();}
//spellGlimmer_Override			object#(0x644) () {spellGlimmer();}
spellHelp_Override				object#(0x645) ()
{
	if (event == DOUBLECLICK)
		//If we came here from a doubleclick, forward to original:
		spellHelp_Override.original();
	else if (event == SCRIPTED)
	{
		//We got here from a Usecode script, so we override it
		//for multi-map support:
		var pos = [0x03A7, 0x0432, 0x0, 0x0];
		PARTY->move_object(pos);
	}
}

extern void spellUnlockMagic_Override		object#(0x667) () {spellUnlockMagic(UI_click_on_item());}

