

//Tells the compiler the game type
#game "blackgate"


//Starts autonumbering at function number 0xC00.
//I leave function numbers in the range 0xA00 to
//0xBFF for weapon functions; this is a total of
//512 unique functions. That is likely much more
//than enough...
#autonumber 0xC00



#include "headers/u6_npcs.uc"				//Ultima 6 npcs

#include "headers/bg_externals.uc"			//extern declarations for BG functions

#include "headers/bg_externals2.uc"			//extern declarations for BG functions

#include "headers/constants.uc"				//standard constant definitions

#include "headers/constants2.uc"

#include "headers/array_functions.uc"

#include "headers/global_flags.uc"


#include "headers/shapes.uc"

#include "headers/functions.uc"

#include "headers/functions2.uc"

#include "headers/services.uc"

#include "utility/gypsy_schedules.uc"




////////Utility Functions
#include "utility/karmafunctions.uc"

#include "utility/si_usecode_script.uc"

#include "utility/check_can_npc_talk.uc"

#include "utility/choose_from_menu.uc"

#include "utility/transfer_all_items.uc"

#include "utility/create_new_shape2.uc" //disabled, not needed?

#include "utility/leaveParty.uc" //handles leaving party members better (putting them on correct maps)


//#include "utility/get_party_items.uc"

#include "utility/make_party_face_npc.uc"

#include "utility/NIM_DR_CAT.uc"

#include "utility/shrine_functions.uc"


#include "utility/drop_all_items.uc" 

#include "utility/guardArrest.uc" 

#include "utility/deleteEggs.uc"

#include "utility/codexWall.uc"



#include "utility/openCodex.uc"
#include "utility/body_function.uc" //finds body that can be rezzed
#include "utility/callGuards.uc" //for testing

#include "utility/deleteBarrier.uc"

#include "utility/time_function.uc"

//#include "utility/wearing_amulet.uc"

#include "utility/convo_start.uc"

#include "utility/CenterOnAvatar.uc"

#include "utility/createShip.uc"

#include "utility/basic_sell.uc"

#include "utility/healer_functions.uc"

#include "utility/npc_functions.uc"

#include "utility/glenCremation.uc"

//#include "utility/ringBell.uc"

#include "utility/RentharScript.uc"

#include "utility/randomizeBooks.uc"

#include "utility/convertSpell.uc"

#include "utility/magicShopkeeper.uc"  

#include "utility/u6_shopkeepers.uc"  

#include "utility/teleportCastle.uc" //used to teleport to the castle and bypass intro which is buggy 

//#include "utility/erupt_volcano.uc" -removed for now, doesn't work right

#include "utility/canCarry.uc"


//MONSTERS

#include "monsters/createGargoyle.uc"

#include "monsters/createWingedGargoyle.uc"

#include "monsters/createHighwayman.uc"

#include "monsters/guards.uc"

////////

#include "cutscenes/script_test.uc" //for testing

#include "items/Ankh.uc" //for utility, merge with U6 npc file

#include "headers/keys.uc"

#include "utility/isEquipped.uc"

//SPELL STUFF
#include "spells/unlock_magic.uc"  //custom spell
#include "spells/Pickpocket.uc"  //custom spell
#include "spells/Enchant.uc"  //custom spell
#include "spells/Help.uc"  //custom spell
#include "spells/ChainBolt.uc"  //custom spell - replaces Create Gold DISABLED - doesn't work correctly

/////CUTSCENES
#include "cutscenes/intro_functions.uc"     //REWORKED 4/15/2024 , changed to intro.uc

//#include "cutscenes/intro.uc"

#include "cutscenes/gypsy_cutscene.uc" 

#include "cutscenes/freeShrines.uc"

#include "cutscenes/crypts.uc"

#include "cutscenes/innkeepers.uc"

#include "cutscenes/GetValorRune.uc"

#include "cutscenes/death_events.uc"

#include "cutscenes/BrawlEngine.uc"

//#include "cutscenes/Glen_Cremation.uc"

#include "cutscenes/SendCodexToVoid.uc"

#include "cutscenes/quenton_sidequest.uc"

#include "cutscenes/quenton_sidequest_eggs.uc"

#include "cutscenes/startEndgame.uc"


//#include "items/Ankh.uc"



//#include "items/Alcohol_Functions.uc"  //disabled, does not work

#include "npcs.uc"							//npc functions

#include "items/signs.uc"

#include "items/rubberducky.uc"

#include "items/runes.uc"

#include "items/CastleSchedules.uc"

#include "items/eggs.uc"

//#include "items/belltimer.uc" //disabled

#include "items/scrolls.uc"

#include "items/tombstones.uc"

#include "items/lamp.uc"

#include "items/yew_staff.uc"

//#include "items/orb_of_the_moons.uc"

#include "items/orb_of_the_moons_new.uc" //updated for U6

#include "items/litlamp.uc"

#include "items/packed_balloon.uc"

#include "items/books.uc"

#include "items/shovel.uc"

//#include "items/volcano.uc"

#include "items/dagger.uc"

#include "items/rawmeat.uc"

#include "monsters/sheep.uc"

#include "items/shears.uc"

#include "items/kindling.uc"

#include "items/balloon.uc"

//#include "items/anchor.uc" 

#include "items/lever.uc"

//#include "items/BlackSword.uc" //used to test 'officer sword' for another mod maybe

#include "npcs/Misc/GenericGuard.uc"

//#include "npcs/Misc/GenericGuard1.uc"

#include "items/garg_signs.uc"

//#include "headers/drunk_events.uc"  //Working, but disabled for testing

//#include "headers/AvatarDrunkEvents.uc" //not sure?

#include "items/fishingrod.uc"

#include "items/Shrines.uc"

//#include "headers/PartyDrunkEvents.uc" //Disabled for now

//#include "items/bottle.uc" //Disabled for now

#include "items/new_balloon.uc" //used to land it

#include "items/raft.uc" //

#include "items/spell_scroll.uc"

//#include "npcs/test_npc.uc"

#include "items/AmuletOfSubmission.uc"

#include "items/gargishbooks.uc"

#include "items/altar_of_singularity.uc"

#include "items/Codex.uc"

#include "items/moonstone.uc"

#include "items/rusty_cutlass.uc" //Drudgeworth quest item

#include "utility/checkVortexCube.uc"

#include "items/storm_cloak.uc" 

#include "items/endgame_eggs.uc"

#include "items/horseflesh.uc"

#include "items/baking.uc" //from quests and interactions mod, cleaned up and working now

#include "items/horn.uc" // silver serpent horn in gargoyle land

#include "items/magic_quill.uc" //utility item to randomize nearby books

#include "items/ChaosSword.uc" //

#include "items/book.uc" //

#include "items/crystal_ball.uc" //

#include "items/desk_item.uc" // rework of desk items to use parrot

#include "items/gems.uc"

#include "items/lion_statue.uc"
