/***Individual stat raising functions*****/
//Gets the current Str, Dex, Int of the npc
//then functions like the original

void addDexterity(npc, amount)
{
	var npcDexterity = UI_get_npc_prop(npc, DEXTERITY);
	
	UI_set_npc_prop(npc, TRAINING, -amount);
	if (npcDexterity == 29) amount = 1;
	if ((npcDexterity == 28) && (amount > 2))  amount = 2;
	UI_set_npc_prop(npc, DEXTERITY, amount);

}

void addIntelligence(npc, amount)
{
	var npcIntelligence = UI_get_npc_prop(npc, INTELLIGENCE);
	var npcMana = UI_get_npc_prop(npc, MAX_MANA);
	
	UI_set_npc_prop(npc, TRAINING, -amount);
	if (npcIntelligence == 29) amount = 1;
	if ((npcIntelligence == 28) && (amount > 2))  amount = 2;
	//If npc has Mana such as the Avatar , add to max mana as well.
	if (npcMana > 0) UI_set_npc_prop(npc, amount);
	UI_set_npc_prop(npc, INTELLIGENCE, amount);

}

void addStrength(npc, amount)
{
	var npcStrength = UI_get_npc_prop(npc, STRENGTH);
	UI_set_npc_prop(npc, TRAINING, -amount);
	if (npcStrength == 29) amount = 1;
	if ((npcStrength == 28) && (amount > 2))  amount = 2;
	UI_set_npc_prop(npc, STRENGTH, amount);

}	
/*********************************************/	
	
void raiseStats(var npc, var shrine) 
{
	var msg;
	var npcname = UI_get_npc_name(npc);
	var failure_msg;
	var success_msg;
	var training_points = UI_get_npc_prop(npc, TRAINING);
	var avatar_training_points = UI_get_npc_prop(AVATAR, TRAINING);
	var npcStrength = UI_get_npc_prop(npc, STRENGTH);
	var npcDexterity = UI_get_npc_prop(npc, DEXTERITY);
	var npcIntelligence = UI_get_npc_prop(npc, INTELLIGENCE);
	
	UI_error_message("NPC training points are: " + training_points + ".  Avatar's training points are " + avatar_training_points + ".");
	var shrine_face;

	
	
	//get Shrine
//***COMPASSION SHRINE*****//		
	if (shrine == "Compassion") //adds +3 Dexterity
	{
		shrine_face = NPC_COMPASSION;
		shrine_face.say("@Speak the Mantra of Compassion.@");
		if (npc != AVATAR)
		{
			npc.say("@Mu...Mu...Mu...@");
			npc.hide();
		}
			else AVATAR.say("@Mu...Mu...Mu....@"); AVATAR.hide();
		say("@No beast so fierce but shows some touch of pity. Sweet mercy is nobility's true badge.@");
		
		if ((training_points >=3) && (npcDexterity < 30))
		{
			addDexterity(npc, 3);
			say("@" + npcname + " has gained Dexterity! There is naught else for you to learn here and now. Return when thy journey has progressed further.@");
				if (!gflags[MEDITATE_COMPASSION])
				{
					addKarma(10);
					gflags[MEDITATE_COMPASSION] = true;
				}
			
			}
			else say("@" + npcname + " receives no enlightenment.@");
			return;
		}	
		
//***VALOR SHRINE*****//			
	if (shrine == "Valor") //adds +3 Strength
	{
		shrine_face = NPC_VALOR;
		shrine_face.say("@Speak the Mantra of Valor.@");
		if (npc != AVATAR)
		{
			npc.say("@Ra...Ra...Ra...@");
			npc.hide();
		}
		else AVATAR.say("@Ra...Ra...Ra...@");
		AVATAR.hide();
		say("@Tender-handed stroke a nettle, and it stings you for your pains.@*");
		say("@Grasp it as a man of mettle, and it soft as silk remains.@");

		if ((training_points >=3) && (npcStrength < 30))
		{
			addStrength(npc, 3);
			say("@" + npcname + " has gained Strength! There is naught else for you to learn here and now. Return when thy journey has progressed further.@");
				if (!gflags[MEDITATE_VALOR])
				{
					addKarma(10);
					gflags[MEDITATE_VALOR] = true;
				}
				
		}
		else say("@" + npcname + " receives no enlightenment.@");
		return;
	}		
//***HONESTY SHRINE*****//			
	if (shrine == "Honesty") //adds +3 Intelligence.  If you are the Avatar, it trains mana as well
	{
		shrine_face = NPC_HONESTY;
		shrine_face.say("@Speak the Mantra of Honesty.@");
		if (npc != AVATAR)
		{

			npc.say("@Ahm....Ahm....Ahm....@");
			npc.hide();
		}
		else
		{
			AVATAR.say("@Ahm...Ahm...Ahm...@"); 
			AVATAR.hide();
		}	
		say("@Whatsoever things are true...@*");
        say("@Whatsoever things are honest...@*");
        say("@If there be any virtue and if there be any praise, think on these things.@*");
		
		if ((training_points >=3) && (npcIntelligence < 30))
		{
			if (npc == AVATAR)
				trainMagic(AVATAR, 3);
			
			addIntelligence(npc, 3);
			
			say("@" + npcname + " has gained Intelligence! There is naught else for you to learn here and now. Return when thy journey has progressed further.@");
			if (!gflags[MEDITATE_HONESTY])
			{
				addKarma(10);
				gflags[MEDITATE_HONESTY] = true;
			}
					
		}
		else say("@" + npcname + " receives no enlightenment.@");
		return;
	}			
//***JUSTICE SHRINE*****//	

	if (shrine == "Justice") //adds +3 Intelligence
	{
		shrine_face = NPC_JUSTICE;
		shrine_face.say("@Speak the Mantra of Justice.@");
		if (npc != AVATAR)
		{
			npc.say("@Beh....Beh....Beh....@");
			npc.hide();
		}
		else
		{
			AVATAR.say("@Beh....Beh....Beh....@");
			AVATAR.hide();
			
		}
		shrine_face.say("@Justice without force is impotent.@*");
 	    shrine_face.say("@Force without justice is tyranny.@*");
    	 		
		if (training_points >=2)
		{
			if (npcIntelligence < 30)
				addIntelligence(npc, 1);
			if (npcDexterity < 30)
				addDexterity(npc, 1);
			say("@" + npcname + " has gained Intelligence and Dexterity! There is naught else for you to learn here and now. Return when thy journey has progressed further.@");
			if (!gflags[MEDITATE_JUSTICE])
			{
				addKarma(10);
				gflags[MEDITATE_JUSTICE] = true;
			}
		}
			else say("@" + npcname + " receives no enlightenment.@");
			return;
	}			
	
//***SACRIFICE SHRINE*****//	

	if (shrine == "Sacrifice") //adds +1 Strength and +1 Dexterity
	{
		shrine_face = NPC_SACRIFICE;
		shrine_face.say("@Speak the Mantra of Sacrifice.@");
		if (npc != AVATAR)
		{
			npc.say("@Cah....Cah....Cah....@");
			npc.hide();
		}
		else
		{	
			AVATAR.say("@Cah....Cah....Cah....@"); 
			AVATAR.hide();
		}	
		say("@The universe is so vast and so ageless..@*");
		say("@..that the life of one man can only be justified@*");
		say("@by the measure of his sacrifice.@");
    	 		
		if (training_points >=2)
		{
			if (npcStrength < 30)
				addStrength(npc, 1);
			if (npcDexterity < 30)
				addDexterity(npc, 1);
			say("@" + npcname + " has gained Dexterity and Strength! There is naught else for you to learn here and now. Return when thy journey has progressed further.@");
			if (!gflags[MEDITATE_SACRIFICE])
			{
				addKarma(10);
				gflags[MEDITATE_SACRIFICE] = true;
			}
		}
		else say("@" + npcname + " receives no enlightenment.@");
		return;
	}			

//***HONOR SHRINE*****//	

	if (shrine == "Honor") //adds +1 Strength and +1 Intelligence
	{
		shrine_face = NPC_HONOR;
		shrine_face.say("@Speak the Mantra of Honor.@");
		if (npc != AVATAR)
		{
			npc.say("@Summ....Summ....Summ....@");
			npc.hide();
		}
		else AVATAR.say("@Summ....Summ....Summ....@"); AVATAR.hide();
			
		say("@Honor may be assailed, but can never be hurt.@*");
 	    say("@Surprised by unjust force, but not enthralled.@*");
    	 		
		if ((training_points >=2) && (npcStrength < 30)||(npcIntelligence < 30))
		{
			if (npcStrength < 30)
				addStrength(npc, 1);
			if (npcIntelligence < 30)
				addIntelligence(npc, 1);
			say("@" + npcname + " has gained Intelligence and Strength! There is naught else for you to learn here and now. Return when thy journey has progressed further.@");
			if (!gflags[MEDITATE_HONOR])
			{
				addKarma(10);
				gflags[MEDITATE_HONOR] = true;
			}
		}
		else say("@" + npcname + " receives no enlightenment.@");
		return;
	}		

//***SPIRITUALITY SHRINE*****//	

	if (shrine == "Spirituality") //adds +1 Strength ,Intelligence and Dexterity
	{
		shrine_face = NPC_SPIRITUALITY;
		shrine_face.say("@Speak the Mantra of Spirituality.@");
		if (npc != AVATAR)
		{
			npc.say("@Om....Om....Om....@");
			npc.hide();
		}
		else AVATAR.say("@Om....Om....Om....@");
		AVATAR.hide();
			
		say("@Throughout this varied and eternal world, soul is the only element.@*");
 	  	say("@The wealth of the spirit is the only true wealth..@*");
    	 		
		if (training_points >= 3)
		{
			if (npcStrength < 30)
				addStrength(npc, 1);
			if (npcIntelligence < 30)	
				addIntelligence(npc, 1);
			if (npcDexterity < 30)
				addDexterity(npc, 1);
				
			say("@" + npcname + " has gained Dexterity, Intelligence and Strength! There is naught else for you to learn here and now. Return when thy journey has progressed further.@");
			if (!gflags[MEDITATE_SPIRITUALITY])
			{
				addKarma(10);
				gflags[MEDITATE_SPIRITUALITY] = true;
			}
		}
		else
			say("@" + npcname + " receives no enlightenment.@");
		return;
	}				
	
//***HUMILITY SHRINE*****//	

	if (shrine == "Humility") //adds NOTHING, what a waste of points!
	{	
		shrine_face = NPC_HUMILITY;
		shrine_face.say("@Speak the Mantra of Humility.@");
		if (npc != AVATAR)
		{
			npc.say("@Lum....Lum....Lum....@");
			npc.hide();
		}
		else AVATAR.say("@Lum....Lum....Lum....@"); AVATAR.hide();
			
		say("@The humblest citizen of all the land, when clad in the armor of a righteous cause,@*");
 	  	say("@is stronger than all the hosts of error.@*");
    	 		
		if (training_points >=3)
		{
			say("@There is naught else for you to learn here and now. Return when thy journey has progressed further.@");
			if (!gflags[MEDITATE_HUMILITY])
			{
				addKarma(10);
				gflags[MEDITATE_HUMILITY] = true;
			}
			UI_set_npc_prop(npc, TRAINING, -3);
		}
			else say("@" + npcname + " receives no enlightenment.@");
			return;
	}				
	
	
}



/*********************************************/	

void Meditate(var shrine, var virtue)
{	
	var party_list = UI_get_party_list();
	var karma = getKarma();
	var SHRINE;
	
	if (shrine == "Sacrifice")
		SHRINE = NPC_SACRIFICE;
	else if (shrine == "Justice")
		SHRINE = NPC_JUSTICE;
	else if (shrine == "Humility")
		SHRINE = NPC_HUMILITY;
	else if (shrine == "Spirituality")
		SHRINE = NPC_SPIRITUALITY;
	else if (shrine == "Valor")
		SHRINE = NPC_VALOR;
	else if (shrine == "Honesty")
		SHRINE = NPC_HONESTY;
	else if (shrine == "Compassion")
		SHRINE = NPC_COMPASSION;
	else if (shrine == "Honor")
		SHRINE = NPC_HONOR;
	else
		SHRINE = AVATAR;
	
		SHRINE.say("The altar of " + shrine + ".");
		if (karma < 40)
			item.say("@Thou hast much to learn about " + virtue + ".@");
		else if ((karma >=40) && (karma < 80)) 
			item.say("@Thy deeds have shown admirable " + virtue + ".@");
		else
			item.say("@Thy deeds serve as an example to all.@");
		SHRINE.say("@Do you wish to meditate at this altar?@");
		if (askYesNo())
		{
			SHRINE.say("@Who will meditate?@");
			add("no one");
			add("Avatar");
			if (inParty(BEHLEM)) add("Beh Lem");
			if (inParty(BLAINE)) add("Blaine");
			if (inParty(DUPRE)) add("Dupre");
			if (inParty(GORN)) add("Gorn");	
			if (inParty(GWENNO)) add("Gwenno");
			if (inParty(IOLO)) add("Iolo");
			if (inParty(JAANA)) add("Jaana");
			if (inParty(JULIA)) add("Julia");
			if (inParty(KATRINA)) add("Katrina");
			if (inParty(LEODON)) add("Leodon");
			if (inParty(LEONNA)) add("Leonna");
			if (inParty(SEGGALLION)) add("Segallion");
			if (inParty(SENTRI)) add("Sentri");
			if (inParty(SHERRY)) add("Sherry");
			if (inParty(SHAMINO)) add("Shamino");
			//add any new party members here
			
			converse(0)
			{	
				case "no one":
					return;
				case "Avatar":	
					raiseStats(AVATAR, shrine);
					return;
	
				case "Beh Lem":	
					raiseStats(BEHLEM, shrine);
					return;
	
				case "Blaine":	
					raiseStats(BLAINE, shrine);
					return;
					
				case "Dupre":	
					raiseStats(DUPRE, shrine);
					return;	
					
				case "Gorn":	
					raiseStats(GORN, shrine);
					return;	
					
				case "Gwenno":	
					raiseStats(GWENNO, shrine);
					return;	
					
				case "Iolo":	
					raiseStats(IOLO, shrine);
					return;	
					
				case "Jaana":	
					raiseStats(JAANA, shrine);
					return;	
				
				case "Julia":	
					raiseStats(JULIA, shrine);
					return;		

				case "Katrina":	
					raiseStats(KATRINA, shrine);
					return;

				case "Leodon":	
					raiseStats(LEODON, shrine);
					return;	
				
				case "Leonna":	
					raiseStats(LEONNA, shrine);
					return;								
	
				case "Segallion":	
					raiseStats(SEGGALLION, shrine);
					return;
					
				case "Sherry":	
					raiseStats(SHERRY, shrine);
					return;	
					
				case "Sentri":	
					raiseStats(SENTRI, shrine);
					return;	
	
				case "Shamino":	
					raiseStats(SHAMINO, shrine);
					return;
	
	
	
	
	
			}
		}
				
	}					