// function to find all "sellable items" left in the inventory that weren't sold, and change their frames back to 0 - 'un-sellable = worn"
var clearSellableItems(var item_shape)
{
	var sellable_item_array;
	var has_item = false;
	var count = 0;
	const int FRAME_SELLABLE = 32;
	const int SHAPE_SELLABLE = 921; 
	var shape;
	var party = UI_get_party_list();
	
	var npc;
	
	UI_error_message("item shape passed to clearSellableItems is: " + item_shape);
	
	var original_shape = UI_get_item_shape(item_shape);
	
	//get an array of all objects held by the party

	for (npc in party)
	{
		//UI_get_cont_items(npc, SHAPE_SELLABLE, QUALITY_ANY, FRAME_ANY);
		sellable_item_array = sellable_item_array + UI_get_cont_items(npc, SHAPE_SELLABLE, QUALITY_ANY, FRAME_ANY);
		//sellable_item_array[count] = UI_get_cont_items(npc, SHAPE_SELLABLE, QUALITY_ANY, FRAME_ANY);
		count += 1;
	}
	UI_error_message("Item array of 'betting markers' is " + UI_get_array_size(sellable_item_array) - 1);
	
	//reset count
	count = 0;
	
	for (shape_betting_marker in sellable_item_array with index to max)
	{
		UI_set_item_shape(shape_betting_marker, item_shape);
		shape_betting_marker->set_item_shape(item_shape); //back to normal shape
		count += 1;
	}
	UI_error_message("There were " + count + " objects frames changed back to 0.");
}

var sellBackItems(var item_array, var item_choices, var item_prices, var rate)
{
	var sellable_items;
	var count = 0;
	var party = UI_get_party_list();
	var npc;
	UI_error_message("Party size is " + UI_get_array_size(party) + ".");
	const int FRAME_SELLABLE = 1;
	
	const int SHAPE_SELLABLE = 921; //temporary shape
	var sell_item_choices;
	var shape_item;
	var item_array_length = UI_get_array_size(item_array);	
	
	var index = 0;
	
	say("@I will only buy back these items, which do you have to sell?@");
	
	//get index of item choice they want to sell **NOTE** INDEX BY DEFAULT STARTS OUT AS '1'!
	var item_index = chooseFromMenu2(item_choices);
		UI_error_message("item_index is " + item_index);

	//get shape of item based on index
	var item_shape_choice = item_choices[item_index];
	var item_shape = item_array[item_index-1];
	var price = item_prices[item_index-1];

	UI_error_message("Item shape choice is " + item_shape_choice + " and item price initally is " + price + ". Item shape num is " + item_shape + ". Index is " + item_index);
	
	
	
	if (item_index == 1)
	{
		say("@Very well, what else can I help you with?@");
		
	}
	else
	{
	
		//get how many of the shape the party has 
		//check party for each shape, add it to array of sellable items
		if (UI_count_objects(PARTY, item_shape, QUALITY_ANY, FRAME_ANY) > 0) //shape found in party
		{
			UI_error_message("There are " + UI_count_objects(PARTY, item_shape, QUALITY_ANY, FRAME_ANY) + " of item " + item_shape_choice + ".");
			
			//get array of all items of the current shape by checking each person in party
			var shape_items;
			for (npc in party)
			{
				shape_items << UI_get_cont_items(npc, item_shape, QUALITY_ANY, FRAME_ANY);  //changed from = shape_items + UI_get_cont_items(npc, item_shape, QUALITY_ANY, FRAME_ANY);
			}
			UI_error_message("There are " +  UI_get_array_size(shape_items) + " found in shape_items array.");
			
			//check and make sure item isn't worn
			for (shape_item in shape_items)
			{
				//sellable item is found in Party's inventory.  Determine if it's in a container:
				var item_container = UI_get_container(shape_item);
				if (!UI_is_npc(item_container))
				{
					UI_error_message("Item shape is " + UI_get_item_shape(shape_item) + ".");
					sellable_items[count] = shape_item;  //add item at index to sellable items
					
					//****Change item frame to "32" if item is not worn / held by npc*****//
					//UI_set_item_frame(shape_item, FRAME_SELLABLE);
							
				//Set to temporary shape to discern if sellable or not: 
					UI_set_item_shape(shape_item, SHAPE_SELLABLE); 
					
					UI_error_message("Item shape is " + UI_get_item_shape(shape_item) + ", item frame is " + UI_get_item_frame_rot(shape_item) + ".");
					UI_error_message("Item not worn, adding to sellable_items array.");
					count += 1;
					UI_error_message("Index is now " + count);
				}
				else
				{
					UI_error_message("Item worn, NOT adding to sellable_items array.");
					continue;
				}	
			}
			
			//determine how many sellable items are
			var max_sellable_items = UI_count_objects(PARTY, SHAPE_SELLABLE, QUALITY_ANY, FRAME_ANY);
			
			if (max_sellable_items > 0)
			{
				//display sellable items and ask how many they want to sell
				say("@How many " + item_shape_choice + " do you want to sell?@");
				max_sellable_items = UI_count_objects(PARTY, SHAPE_SELLABLE, QUALITY_ANY, FRAME_ANY);
				
				//get player input from 0 to max items able to be sold of type
				var num_to_sell = UI_input_numeric_value(0, max_sellable_items, 1, 1); 
				
				if (num_to_sell == 0)
				{
					say("@Very well, but I don't haggle on price!@");
				
					//cleanup - any unsold items switch back to normal frame:
					clearSellableItems(item_shape);
				}
				else
				{
			
					//calculate sell price and add to total
					var sell_price = num_to_sell * price / rate;

					//remove items from party and add sell price to party's funds

					UI_remove_party_items(num_to_sell, SHAPE_SELLABLE, QUALITY_ANY, FRAME_ANY);
					
					
				

					//display message confirming sale and new funds balance
					say("You sold " + num_to_sell + " " + item_shape_choice + " for " + sell_price + " gold.  @What else can I do for you?@");
					
					//cleanup - any unsold items switch back to normal frame:
					clearSellableItems(item_shape);
				}
			
			}
			else
			{
				say("@Sorry, but you have no sellable " + item_shape_choice + " items.@");
				
			}

		
		}
		else
			say("@Sorry, but you have no sellable " + item_shape_choice + " items.@");
	
	}


}



//buy armor 
var buyArmor(var npc, var armor_options, var armor_prices, var armor_shapes, var dialog)
{
	var index;
	var armor_index = 1;
	var frame;
	var quantity = 1;
	var quality = 0;
	var success;
	var success2;
	
	//Which of these?
	say(dialog[1]);  
	UI_error_message("Dialog[3] is " + dialog[3] + "."); //"That will cost you " (gold) "gold coins")
	
	//choose from menu of armor options
	var item_choice = chooseFromMenu(armor_options); //item selected from choice

	//find index of item in armor options
	//should cycle through armor options and return the index when it is the same
	for (index in armor_options)
	{
		if (index == item_choice)
			break; //return armor_index;
		else
			armor_index += 1;
	
	}
	
	//get shape of armor based on index
	var shape = armor_shapes[armor_index-1];
	var price = armor_prices[armor_index-1];
	
	
	if (item_choice == "magic boots")
		frame = 1;
		
	
	UI_error_message("Price is " + price);
	UI_error_message("Armor index is " + armor_index);
	UI_error_message("frame is " + frame);
	UI_error_message("item choice is " + item_choice);
	
	//                       1                        2               3                 4       5            6      7       8       9
	//buy dialog = [initial_choice_question, askIfInterested1, askIfInterested2, cant_afford, cant_hold, saidNo, nothing,success, success2];
	
	
	//***NPC DIALOGUE****
	if (item_choice != "nothing")
	{
		say(dialog[2]  + price +  dialog[3]); //Ask if interested?
		if (askYesNo())
		{
			if (hasGold(price * quantity))
			{
				
					
				if (UI_add_party_items(quantity, shape, quality, frame, true))
				{
					chargeGold(price * quantity);
					say(dialog[8] + item_choice); //success
					if (success2)
						say(dialog[9]); //only if extra success message. ex: "Hope this serves you well!"
				}
				else 
					say([5]); //Can't carry
			}
			else
				say(dialog[4]); //Cant afford
		}	
		else
			say(dialog[6]); //said no
	}	
	else
		say(dialog[7]); //chose "nothing"
}

//*************************************************************************************//
var buyWeapons(var npc, var weapon_options, var weapon_prices, var weapon_shapes, var dialog)
{
	var index;
	var weapon_index = 1;
	
	var frame;
	var quantity = 1;
	var quality = 0;
	var success;
	var success2;
	
	
	//Which of these?
	say(dialog[1]);  
	
	//choose from menu of weapon options
	var item_choice = chooseFromMenu(weapon_options); //item selected from choice
	


	//find index of item in weapon options
	//should cycle through weapon options and return the index when it is the same
	for (index in weapon_options)
	{
		if (index == item_choice)
			break; //return weapon_index;
		else
			weapon_index += 1;
	
	}
	
	//get shape of armor based on index
	var shape = weapon_shapes[weapon_index-1];
	var price = weapon_prices[weapon_index-1];
	
	UI_error_message("Price is " + price);
	UI_error_message("Weapon index is " + weapon_index);
	
	//                       1                        2               3                 4       5            6      7       8       9
	//buy dialog = [initial_choice_question, askIfInterested1, askIfInterested2, cant_afford, cant_hold, saidNo, nothing,success, success2];
	
	if (item_choice == "arrows" || item_choice == "bolts")
	{
		dialog[3] = " gold for a dozen. Okay?@";
		quantity = 12;
	
	
	}
	
	//***NPC DIALOGUE****
	if (item_choice != "nothing")
	{
		say(dialog[2]  + price +  dialog[3]); //Ask if interested?
		if (askYesNo())
		{
			if (hasGold(price * quantity))
			{
				if (UI_add_party_items(quantity, shape, quality, frame, true))
				{
					chargeGold(price * quantity);
					say(dialog[8] + item_choice); //success
					if (success2)
						say(dialog[9]); //only if extra success message. ex: "Hope this serves you well!"
				}
				else 
					say([5]); //Can't carry
			}
			else
				say(dialog[4]); //Cant afford
		}	
		else
			say(dialog[6]); //said no
	}	
	else
		say(dialog[7]); //chose "nothing"
}



//*********************************************//

var buyItems(var npc, var item_options, var prices, var item_shapes, var item_frames, var dialog)
{
	var npcname = UI_get_npc_name(npc);
	var shape;
	var quantity = 1;
	var quality;
	var frame;
	var price;
	
	var item_cost = price * quantity; //this is used normally unless it's an item that requires extra handling such as arrows and bolts
	
	
	var item_choice;
	//						1					2				   3		        4			   5		   6		7		  8		  9        10
	//var dialog = [initial_choice_question, askIfInterested1, askIfInterested2, ask_quantity, cant_afford, cant_hold, saidNo, nothing, success, success2];
	
		
	var initial_choice_question = dialog[1];//which of these?
	var askIfInterested1 = dialog[2];
	var askIfInterested2 = dialog[3];
	var ask_quantity = dialog[4];
	var cant_afford = dialog[5];
	var cant_hold = dialog[6];
	var saidNo = dialog[7];
	var nothing = dialog[8];
	var success = dialog[9]; // Ex: " + npcname + " hands you the " + item + ".";
	var success2 = dialog[10]; //"I hope this item works well for you!" etc
	var success_msg;
	
	var has_quantity;
		
	say(initial_choice_question); //Which of these?
	item_choice = chooseFromMenu(item_options); //item selected from choice

		
	//should get price and frame based on index of item choice
	var item_index = 0;
	var index;
	
	//should cycle through item options and return the index when it is the same
	for (index in item_options)
	{
		if (index == item_choice)
			break; //return food_index;
		else
			item_index += 1;
	
	}
	
	
	//Item frame
	frame = item_frames[item_index];
	
	//Item shape
	shape = item_shapes[item_index];
	
	//Item price
	price = prices[item_index]; //from +1
	
	UI_error_message("item index is " + item_index);
	UI_error_message("Item chosen is " + shape + " with frame of " + frame + " and cost of " + price);
		
	

	
//special cases for NPCS's	

	if (npc == BUDO)
	{
		if (item_choice == "lockpicks" || item_choice == "torch" || item_choice == "bag");
			has_quantity = true;
	
	
	}
	
	if (item_choice == "arrows" || item_choice == "bolts" || item_choice == "torch" || item_choice == "oil")
		has_quantity = true;
		


//////////////////////////Main conversation/////////////////////////////////////////////////////
	
	if (item_choice != "nothing") // "nothing" - Avatar didn't want anything
	{
		say(askIfInterested1 + price + askIfInterested2);
		if (askYesNo())
		{
			
			if (has_quantity)
			{	
				say(ask_quantity);
				
				
				//special handling for arrows and bolts which come by dozens (12)
				if (item_choice == "arrows" || item_choice == "bolts")
				{
					quantity = UI_input_numeric_value(1, 8, 1, 1) * 12; 
					item_cost = (quantity / 12 )* price; // so we're only paying for price per dozen
					
				}
				else
					quantity = UI_input_numeric_value(1, 20, 1, 1);
			}
			else
				quantity = 1;
			UI_error_message("Quantity is " + quantity);	
			
			if (hasGold(item_cost)) // (price * quantity)
			{
				if (UI_add_party_items(quantity, shape, quality, frame, true))
				{
					chargeGold(item_cost);
					say(success + item_choice + success2);
					//For special case npcs who give a freebie:
					if (npc == CULLEN)
						UI_add_party_items(1, shape, quality, frame, true);
					
				}
				else 
					say(cant_hold);
			}
			else
				say(cant_afford);
		}	
		else
			say(saidNo);
	}
	else
		say(nothing); 
} 


//*********************************************//


var sellFood(var npc, var food_drink_options, var prices, var food_drink_frames, var dialog)
{
	var npcname = UI_get_npc_name(npc);
	var shape;
	var quantity = 1;
	var quality;
	var frame;
	
	var price;
	var item_choice;
	//						1					2				   3		        4			   5		   6		7		  8		  9        10
	//var dialog = [initial_choice_question, askIfInterested1, askIfInterested2, ask_quantity, cant_afford, cant_hold, saidNo, nothing, success, success2];
	
		
	var initial_choice_question = dialog[1];//which of these?
	var askIfInterested1 = dialog[2];
	var askIfInterested2 = dialog[3];
	var ask_quantity = dialog[4];
	var cant_afford = dialog[5];
	var cant_hold = dialog[6];
	var saidNo = dialog[7];
	var nothing = dialog[8];
	var success = dialog[9]; // Ex: " + npcname + " hands you the " + item + ".";
	var success2 = dialog[10]; //"I hope this item works well for you!" etc
	
	//for food, has quanity is true until otherwise
	var has_quantity = true;
		
	say(initial_choice_question); //Which of these?
	item_choice = chooseFromMenu(food_drink_options); //item selected from choice

	//determine whether shape is bottle or food item
	switch (item_choice)
	{
		case "ale": case "wine": case "mead": case "Frasier's Folly": case "milk":
			shape = SHAPE_BOTTLE;
			break;
			
		default:
			shape = SHAPE_FOOD;
		
		//for npcs who only sell wine
		if (npc == FAREN || npc == STIVIUS)
			shape = SHAPE_BOTTLE;
		
	}
	
	
	
	
	
	//should get price and frame based on index of item choice
	var food_index = 0;
	var index;
	
	//should cycle through food options and return the index when it is the same
	for (index in food_drink_options)
	{
		if (index == item_choice)
			break; //return food_index;
		else
			food_index += 1;
	
	}
	
	
	//get frame of food based on index
	frame = food_drink_frames[food_index];
	price = prices[food_index]; //from +1
	UI_error_message("Price is " + price);
	UI_error_message("food index is " + food_index);
	UI_error_message("Frame is " + frame);
	
	
//special cases for NPCS's	
	if (npc == ROB)
	{
		if (shape == SHAPE_BOTTLE)
		{
			has_quantity = false;
		//	success2 = "@Drink up and enjoy, for who knows what tomorrow may bring?@");
		}
			
		if (item_choice == "baked brie")
		{
			ask_quantity = "@It's a fine cheese. We serve it warm with sliced almonds on top. It costs 6 crowns each.@";
			has_quantity = true;
	
		}
		
		if (item_choice == "bread")
		{
			ask_quantity = "@I charge 3 gold per loaf. How many do you want?@";
			has_quantity = true;
	
		}
		
	}
	
	if (npc == DR_CAT)
	{
		if (shape == SHAPE_BOTTLE)
		{
			has_quantity = false;
			success = "Dr Cat gives you the ";
			success2 = ". @Drink up and enjoy, for who knows what tomorrow may bring?@";
			
			if (item_choice == "milk")
				success2 = ". @You have good taste, my friend.@";
		}
			
		
		
	}

	if (npc == AMANDA)
	{
		if (item_choice == "waybread")
		{
			has_quantity = true;
			askIfInterested1 = "@Some say I make the best Waybread in these parts. It costs just ";
			askIfInterested2 = " gold. You want to try some?@";
		}	
		
		if (shape == SHAPE_BOTTLE)
			success2 = "@Y'all enjoy it, now.@";
			
			
		if (item_choice == "milk")
			success2 = "@You have good taste, my friend.@";
		
			
		
		
	}
	
	
	if (npc == DUNBAR)
	{
		if (item_choice == "fish")
		{
			has_quantity = true;
			askIfInterested1 = "@I buy all my fish fresh from Conor. It's "; 
			askIfInterested2 = " gold per serving. Would you like some?@";
			success = "@Here you go. I hope you enjoy it.@";
			success2 = "@Next week we should have some red snapper.@";
		}	
		
		if (item_choice == "beef" || item_choice == "mutton")
		{
			askIfInterested1 = "@That will cost ";  
			askIfInterested2 = " gold per portion. Do you want some?@";


		}
			
		
		
	}
	

//////////////////////////Main conversation/////////////////////////////////////////////////////
	
	if (item_choice != "nothing") // "nothing" - Avatar didn't want anything
	{
		say(askIfInterested1 + price + askIfInterested2);
		if (askYesNo())
		{
			
			if (has_quantity)
			{	
				say("How many?");
				quantity = UI_input_numeric_value(1, 20, 1, 1);
			}
			else
				quantity = 1;
				
			if (hasGold(price * quantity))
			{
				if (UI_add_party_items(quantity, shape, quality, frame, true))
				{
					chargeGold(price * quantity);
					say(success + item_choice + success2);
					//For special case npcs who give a freebie:
					if (npc == CULLEN)
						UI_add_party_items(1, shape, quality, frame, true);
					
				}
				else 
					say(cant_hold);
			}
			else
				say(cant_afford);
		}	
		else
			say(saidNo);
	}
	else
		say(nothing); 
		
	
} 
	